{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program adifconv;

uses
  TpCrt,
  AdifEng,
  TpString;

procedure WriteHelp;
begin
  Clrscr;
  Writeln('RTTY by WF1B >>to>> ADIF Conversion Utility Version 1.4');
  writeln;
  writeln('Usage:');
  writeln('      ADIFCONV <infile> [<outfile>]');
  writeln;
  writeln('Where:');
  writeln('      <infile>  is RTTY .BIN file to be used as input');
  writeln('      <outfile> is ADIF formatted data.  If outfile is not entered');
  writeln('                then the outfile will be <infile>.ADI');
  writeln;
  writeln;
  writeln('Copyright 1998-2000 Wyvern Technology, Inc.');
  writeln;
  halt;
end;


var
  InFile  : string;
  OutFile : string;
  i : integer;

begin
  if (ParamCount < 1) or (ParamCount > 2)  then WriteHelp;
  InFile := DefaultExtension(ParamStr(1),'BIN');
  if ParamCount = 2 then
    OutFile := ParamStr(2)
  else
    OutFile := ForceExtension(InFile, 'ADI');
  for i := 1 to length(InFile) do
    InFile[i] := UpCase(InFile[i]);
  for i := 1 to length(OutFile) do
    OutFile[i] := UpCase(Outfile[i]);
  if not ConvertToAdif(Infile,OutFile) then begin
    Clrscr;
    Writeln;
    writeln('The conversion failed.');
    writeln;
    writeln('Error Message: '+AdifStatus);
    halt;
  end
  else begin
    Clrscr;
    Writeln;
    writeln('Conversion complete!');
    writeln;
    writeln('Inputfile.....'+InFile);
    writeln('Outputfile....'+OutFile);
    Writeln('# records.....'+long2str(AdifRecords));
    writeln;
  end;
end.