{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
PROGRAM Cabrillo;

uses
  IniFile,
  CColors,
  TAccess,
  TAHigh,
  TpCrt,
  TpDate,
  TpEntry,
  TpMouse,
  TpString,
  TpWindow,
  Diskio,
  clogarrl,
  clogcqww,
  clognaqp,
  RecTypes;

const
  ArrlSections : array[1..81] of String[3] = (
     'AB',
     'AK',
     'AL',
     'AR',
     'AZ',
     'BC',
     'CO',
     'CT',
     'DE',
     'DX',
     'EB',
     'EMA',
     'ENY',
     'EPA',
     'EWA',
     'GA',
     'IA',
     'ID',
     'IL',
     'IN',
     'KS',
     'KY',
     'LA',
     'LAX',
     'MAR',
     'MB',
     'MDC',
     'ME',
     'MI',
     'MN',
     'MO',
     'MS',
     'MT',
     'NC',
     'ND',
     'NE',
     'NFL',
     'NH',
     'NL',
     'NLI',
     'NM',
     'NNJ',
     'NNY',
     'NTX',
     'NV',
     'NWT',
     'OH',
     'OK',
     'ON',
     'OR',
     'ORG',
     'PAC',
     'PR',
     'QC',
     'RI',
     'SB',
     'SC',
     'SCV',
     'SD',
     'SDG',
     'SF',
     'SFL',
     'SJV',
     'SK',
     'SNJ',
     'STX',
     'SV',
     'TN',
     'UT',
     'VA',
     'VI',
     'VT',
     'WCF',
     'WI',
     'WMA',
     'WNY',
     'WPA',
     'WTX',
     'WV',
     'WWA',
     'WY');

  OperatorCategories : array[1..7] of String[18] = (
     'SINGLE-OP',
     'SINGLE-OP-ASSISTED',
     'MULTI-ONE',
     'MULTI-TWO',
     'MULTI-MULTI',
     'SCHOOL-CLUB',
     'CHECKLOG');

  BandCategories : array[1..6] of string[4] = (
     'ALL',
     '80M',
     '40M',
     '20M',
     '15M',
     '10M');

  PowerCategories : array[1..3] of string[4] = (
     'QRP',
     'LOW',
     'HIGH');

  ModeCategories : array[1..4] of string[5] = (
     'CW',
     'PH',
     'RY',
     'MIXED');

  CategoryOverlays : array[1..6] of string[12] = (
    '',
    'ROOKIE',
    'BAND-LIMITED',
    'TB-WIRES',
    'OVER-50',
    'HQ');

  Contests : array[1..3] of string[10] = (
    'ARRL-RTTY',
{    'CQ-WW-RTTY', }
    'NAQP-RTTY',
    'TARA-RTTY' );

type
  Log_Rec        = record
                     ToolBoxNumber  : Integer;
                     VersionControl : VersionType;
                     Contest        : ContestType;
                     Date           : Date;
                     Ts             : Time;
                     Band           : BandType;
                     Mode           : ModeType;
                     Call           : String[12];
                     His_Country    : String[5];
                     His_RST        : Byte;
                     His_Qth        : String[3]; {grp# in waedc}
                     His_Zone       : Byte; {age in jarts, qtcs in waedc}
                     His_Serno      : Word;
                     His_Time       : Time;
                     My_Rst         : Byte;
                     My_Qth         : String[3];
                     My_Zone        : Byte;
                     My_Serno       : Word;
                     My_Time        : Time;
                     Point          : Byte;
                     New_Zone       : Boolean;
                     New_Country    : Boolean;
                     New_Qth        : Boolean; {in wae, F=not sent, T=sent}
                     New_Continent  : Boolean;
                     Dupe           : Boolean;
                     Comment        : String[25];
                   end;

type
    tCabrilloData = record
      ArrlSection     : string;
      Callsign        : string;
      OperatorCat     : string;
      BandCat         : string;
      PowerCat        : string;
      ModeCat         : string;
      CategoryOverlay : string;
      Club            : string;
      Contest         : string;
      Name            : string;
      Address1        : string;
      Address2        : string;
      Address3        : string;
      Address4        : string;
      Address5        : string;
      Operators       : string;
      Soapbox1        : string;
      Soapbox2        : string;
      Soapbox3        : string;
      Soapbox4        : string;
      Soapbox5        : string;
      FileNameIn      : string;
      FileNameOut     : string;
    end;

var
  EditEsr      : EsRecord;
  ExitCommand  : EStype;
  EditPtr      : WindowPtr;
  DoneEditting : Boolean;
  WriteFile    : Boolean;
  CabrilloData : tCabrilloData;
  ArrlSectionNumber : integer;
  OperatorCatNumber : integer;
  BandCatNumber : integer;
  PowerCatNumber : integer;
  ModeCatNumber : integer;
  CatOverlayNumber : integer;
  ContestNumber : integer;



  procedure IncChoice(var Value; FieldID : Byte;
                          Factor         : Integer;
                      var St             : String); far;
  var
    vSelected : byte absolute Value;
  begin
    case FieldID of
      000 : begin
              case Factor of
                 1 : if vSelected = 81 then vSelected := 1
                                     else Inc(vSelected);
                -1 : if vSelected = 1 then vSelected := 81
                     else Dec(vSelected);
              end;
              St := ArrlSections[vSelected];
            end;
      002 : begin
              case Factor of
                 1 : if vSelected = 7 then vSelected := 1
                                     else Inc(vSelected);
                -1 : if vSelected = 1 then vSelected := 7
                     else Dec(vSelected);
              end;
              St := OperatorCategories[vSelected];
            end;
      003 : begin
              case Factor of
                 1 : if vSelected = 6 then vSelected := 1
                                     else Inc(vSelected);
                -1 : if vSelected = 1 then vSelected := 6
                     else Dec(vSelected);
              end;
              St := BandCategories[vSelected];
            end;
      004 : begin
              case Factor of
                 1 : if vSelected = 3 then vSelected := 1
                                     else Inc(vSelected);
                -1 : if vSelected = 1 then vSelected := 3
                     else Dec(vSelected);
              end;
              St := PowerCategories[vSelected];
            end;
      005 : begin
              case Factor of
                 1 : if vSelected = 4 then vSelected := 1
                                     else Inc(vSelected);
                -1 : if vSelected = 1 then vSelected := 4
                     else Dec(vSelected);
              end;
              St := ModeCategories[vSelected];
            end;
      006 : begin
              case Factor of
                 1 : if vSelected = 6 then vSelected := 1
                                     else Inc(vSelected);
                -1 : if vSelected = 1 then vSelected := 6
                     else Dec(vSelected);
              end;
              St := CategoryOverlays[vSelected];
            end;
      008 : begin
              case Factor of
                 1 : if vSelected = 3 then vSelected := 1
                                     else Inc(vSelected);
                -1 : if vSelected = 1 then vSelected := 3
                     else Dec(vSelected);
              end;
              St := Contests[vSelected];
            end;
    end;
  end;


function ArrlSectionToNumber(s : string) : integer;
var
  i : integer;
begin
  for i := 1 to 80 do
    if ArrlSections[i] = s then begin
      ArrlSectionToNumber := i;
      Exit;
    end;
  ArrlSectionToNumber := 1;
end;

function OperatorCatToNumber(s : string) : integer;
var
  i : integer;
begin
  for i := 1 to 7 do
    if OperatorCategories[i] = s then begin
      OperatorCatToNumber := i;
      Exit;
    end;
  OperatorCatToNumber := 1;
end;

function BandCatToNumber(s : string) : integer;
var
  i : integer;
begin
  for i := 1 to 6 do
    if BandCategories[i] = s then begin
      BandCatToNumber := i;
      Exit;
    end;
  BandCatToNumber := 1;
end;


function PowerCatToNumber(s : string) : integer;
var
  i : integer;
begin
  for i := 1 to 3 do
    if PowerCategories[i] = s then begin
      PowerCatToNumber := i;
      Exit;
    end;
  PowerCatToNumber := 1;
end;


function ModeCatToNumber(s : string) : integer;
var
  i : integer;
begin
  for i := 1 to 4 do
    if ModeCategories[i] = s then begin
      ModeCatToNumber := i;
      Exit;
    end;
  ModeCatToNumber := 1;
end;

function CatOverlayToNumber(s : string) : integer;
var
  i : integer;
begin
  for i := 1 to 6 do
    if CategoryOverlays[i] = s then begin
      CatOverlayToNumber := i;
      Exit;
    end;
  CatOverlayToNumber := 1;
end;

function ContestToNumber(s : string) : integer;
var
  i : integer;
begin
  for i := 1 to 3 do
    if Contests[i] = s then begin
      ContestToNumber := i;
      Exit;
    end;
  ContestToNumber := 1;
end;

procedure BuildScreen;
begin
    MakeWindow(EditPtr, 1, 1, ScreenWidth, ScreenHeight, True, True, False, Colors^.WindowAttr,
               Colors^.FrameAttr, Colors^.HeaderAttr,
               'Edit Cabrillo Specifications for RTTY by WF1B');
    Colors^.SetEntryAttributes;
    WriteFile := True;
    DoneEditting := False;
    DisplayWindow(EditPtr) ;
    InitEsRecord(EditEsr);
    SetWrapMode(EditEsr, WrapAtEdges);
    AddChoiceField(EditEsr, 'ARRL-SECTION     ',3, 3, 'XXXXXX',
                                                 3, 23, 0, 1, @IncChoice, ArrlSectionNumber);

    AddStringField(EditEsr, 'CALLSIGN         ',4,  3, '!!!!!!!!!!!!',
                                                 4, 23, 12, 0, nil, CabrilloData.Callsign);

    AddChoiceField(EditEsr, 'CATEGORY         ',5, 3, 'XXXXXXXXXXXXXXXXXX',
                                                 5, 23, 0, 1, @IncChoice, OperatorCatNumber);
    AddChoiceField(EditEsr, '',                  5, 3, 'XXXX',
                                                 5, 42, 0, 1, @IncChoice, BandCatNumber);
    AddChoiceField(EditEsr, '',                  5, 3, 'XXXX',
                                                 5, 47, 0, 1, @IncChoice, PowerCatNumber);
    AddChoiceField(EditEsr, '',                  5, 3, 'XXXXX',
                                                 5, 52, 0, 1, @IncChoice, ModeCatNumber);
    AddChoiceField(EditEsr, 'CATEGORY-OVERLAY ',6,  3, 'XXXXXXXXXXXX',
                                                 6, 23, 0, 1, @IncChoice, CatOverlayNumber);

    AddStringField(EditEsr, 'CLUB'              ,7,  3, '',
                                                 7, 23, 50, 0, nil, CabrilloData.Club);

    AddChoiceField(EditEsr, 'CONTEST          ',8,  3, 'XXXXXXXXXX',
                                                 8, 23, 0, 1, @IncChoice, ContestNumber);

    AddStringField(EditEsr, 'OPERATORS'         ,9,  3, '',
                                                 9, 23, 50, 0, nil, CabrilloData.Operators);

    AddStringField(EditEsr, 'NAME'             ,10,  3, '',
                                                10, 23, 50, 0, nil, CabrilloData.Name);

    AddStringField(EditEsr, 'ADDRESS'          ,11,  3, '',
                                                11, 23, 50, 0, nil, CabrilloData.Address1);
    AddStringField(EditEsr, ''                 ,12,  3, '',
                                                12, 23, 50, 0, nil, CabrilloData.Address2);
    AddStringField(EditEsr, ''                 ,13,  3, '',
                                                13, 23, 50, 0, nil, CabrilloData.Address3);
    AddStringField(EditEsr, ''                 ,14,  3, '',
                                                14, 23, 50, 0, nil, CabrilloData.Address4);
    AddStringField(EditEsr, ''                 ,15,  3, '',
                                                15, 23, 50, 0, nil, CabrilloData.Address5);

    AddStringField(EditEsr, 'SOAPBOX'          ,16,  3, '',
                                                16, 23, 50, 0, nil, CabrilloData.Soapbox1);
    AddStringField(EditEsr, ''                 ,17,  3, '',
                                                17, 23, 50, 0, nil, CabrilloData.Soapbox2);
    AddStringField(EditEsr, ''                 ,18,  3, '',
                                                18, 23, 50, 0, nil, CabrilloData.Soapbox3);
    AddStringField(EditEsr, ''                 ,19,  3, '',
                                                19, 23, 50, 0, nil, CabrilloData.Soapbox4);
    AddStringField(EditEsr, ''                 ,20,  3, '',
                                                20, 23, 50, 0, nil, CabrilloData.Soapbox5);

    AddStringField(EditEsr, 'INPUT FILE(.BIN)' ,21,  3, '',
                                                21, 23, 50, 0, nil, CabrilloData.FileNameIn);

    AddStringField(EditEsr, 'OUTPUT FILE'      ,22,  3, '',
                                                22, 23, 50, 0, nil, CabrilloData.FileNameOut);

    FastWrite('Use the plus(+) and minus(-) keys to change choice items', 23, 5, Colors^.WindowAttr);
    FastWrite('Use <CTL-ENTER> to generate the cabrillo file', 24, 5, Colors^.WindowAttr);
end;


  procedure Edit;
  var
    FieldName : string[3];
    CurBand   : BandType;
  begin
    repeat
      ExitCommand := EditScreen(EditEsr, 0, False);
      case ExitCommand of
        EsDone : begin
                   CabrilloData.ArrlSection := ArrlSections[ArrlSectionNumber];
                   CabrilloData.OperatorCat := OperatorCategories[OperatorCatNumber];
                   CabrilloData.BandCat := BandCategories[BandCatNumber];
                   CabrilloData.PowerCat := PowerCategories[PowerCatNumber];
                   CabrilloData.ModeCat := ModeCategories[ModeCatNumber];
                   CabrilloData.CategoryOverlay := CategoryOverlays[CatOverlayNumber];
                   CabrilloData.Contest := Contests[ContestNumber];
                   WriteFile := True;
                   DoneEditting := True;
                 end;
        EsQuit : begin
                   WriteFile := False;
                   DoneEditting := True;
                 end;
      end;
    until DoneEditting;
  end;

  procedure DestroyScreen;
  begin
    KillWindow(EditPtr);
    DisposeEditScreen(EditEsr);
  end;

  procedure GetValues;
  begin
    with CabrilloData do begin
      ArrlSection     := RttyIni^.GetProfileString('ARRL-SECTION', 'Cabrillo', '');
      Callsign        := RttyIni^.GetProfileString('CALLSIGN', 'Cabrillo', '');
      OperatorCat     := RttyIni^.GetProfileString('OPERATOR-CATEGORY', 'Cabrillo', '');
      PowerCat        := RttyIni^.GetProfileString('POWER-CATEGORY', 'Cabrillo', '');
      BandCat         := RttyIni^.GetProfileString('BAND-CATEGORY', 'Cabrillo', '');
      ModeCat         := RttyIni^.GetProfileString('MODE-CATEGORY', 'Cabrillo', '');
      CategoryOverlay := RttyIni^.GetProfileString('CATEGORY-OVERLAY', 'Cabrillo', '');
      Club            := RttyIni^.GetProfileString('CLUB', 'Cabrillo', '');
      Contest         := RttyIni^.GetProfileString('CONTEST', 'Cabrillo', '');
      Name            := RttyIni^.GetProfileString('NAME', 'Cabrillo', '');
      Address1        := RttyIni^.GetProfileString('ADDRESS_1', 'Cabrillo', '');
      Address2        := RttyIni^.GetProfileString('ADDRESS_2', 'Cabrillo', '');
      Address3        := RttyIni^.GetProfileString('ADDRESS_3', 'Cabrillo', '');
      Address4        := RttyIni^.GetProfileString('ADDRESS_4', 'Cabrillo', '');
      Address5        := RttyIni^.GetProfileString('ADDRESS_5', 'Cabrillo', '');
      Operators       := RttyIni^.GetProfileString('OPERATORS', 'Cabrillo', '');
      Soapbox1        := RttyIni^.GetProfileString('SOAPBOX_1', 'Cabrillo', '');
      Soapbox2        := RttyIni^.GetProfileString('SOAPBOX_2', 'Cabrillo', '');
      Soapbox3        := RttyIni^.GetProfileString('SOAPBOX_3', 'Cabrillo', '');
      Soapbox4        := RttyIni^.GetProfileString('SOAPBOX_4', 'Cabrillo', '');
      Soapbox5        := RttyIni^.GetProfileString('SOAPBOX_5', 'Cabrillo', '');
      FilenameIn      := RttyIni^.GetProfileString('FILENAMEIN', 'Cabrillo', '');
      FilenameOut     := RttyIni^.GetProfileString('FILENAMEOUT', 'Cabrillo', '');
      ArrlSectionNumber := ArrlSectionToNumber(ArrlSection);
      OperatorCatNumber := OperatorCatToNumber(OperatorCat);
      BandCatNumber     := BandCatToNumber(BandCat);
      PowerCatNumber    := PowerCatToNumber(PowerCat);
      ModeCatNumber     := ModeCatToNumber(ModeCat);
      CatOverlayNumber  := CatOverlayToNumber(CategoryOverlay);
    ContestNumber     := ContestToNumber(Contest);
    end;
  end;

  procedure SetValues;
  begin
    with CabrilloData do begin
      RttyIni^.SetOrAddProfileString('ARRL-SECTION', 'Cabrillo', ArrlSection );
      RttyIni^.SetOrAddProfileString('CALLSIGN', 'Cabrillo',Callsign );
      RttyIni^.SetOrAddProfileString('OPERATOR-CATEGORY', 'Cabrillo', OperatorCat);
      RttyIni^.SetOrAddProfileString('POWER-CATEGORY', 'Cabrillo', PowerCat);
      RttyIni^.SetOrAddProfileString('BAND-CATEGORY', 'Cabrillo', BandCat);
      RttyIni^.SetOrAddProfileString('MODE-CATEGORY', 'Cabrillo', ModeCat);
      RttyIni^.SetOrAddProfileString('CATEGORY-OVERLAY', 'Cabrillo',CategoryOverlay );
      RttyIni^.SetOrAddProfileString('CLUB', 'Cabrillo', Club);
      RttyIni^.SetOrAddProfileString('CONTEST', 'Cabrillo',Contest );
      RttyIni^.SetOrAddProfileString('NAME', 'Cabrillo',Name );
      RttyIni^.SetOrAddProfileString('ADDRESS_1', 'Cabrillo',Address1 );
      RttyIni^.SetOrAddProfileString('ADDRESS_2', 'Cabrillo',Address2 );
      RttyIni^.SetOrAddProfileString('ADDRESS_3', 'Cabrillo',Address3 );
      RttyIni^.SetOrAddProfileString('ADDRESS_4', 'Cabrillo',Address4 );
      RttyIni^.SetOrAddProfileString('ADDRESS_5', 'Cabrillo',Address5 );
      RttyIni^.SetOrAddProfileString('OPERATORS', 'Cabrillo',Operators );
      RttyIni^.SetOrAddProfileString('SOAPBOX_1', 'Cabrillo',Soapbox1 );
      RttyIni^.SetOrAddProfileString('SOAPBOX_2', 'Cabrillo',Soapbox2 );
      RttyIni^.SetOrAddProfileString('SOAPBOX_3', 'Cabrillo',Soapbox3 );
      RttyIni^.SetOrAddProfileString('SOAPBOX_4', 'Cabrillo',Soapbox4 );
      RttyIni^.SetOrAddProfileString('SOAPBOX_5', 'Cabrillo',Soapbox5 );
      RttyIni^.SetOrAddProfileString('FILENAMEIN', 'Cabrillo',FileNameIn );
      RttyIni^.SetOrAddProfileString('FILENAMEOUT', 'Cabrillo',FileNameOut );
    end;
  end;

  procedure CreateCabrilloFile;
  var
    f : text;
    a : diskio.log_rec;

    procedure  WriteLogToFile;
      procedure  WriteDetail;
      var
        s : string;
      begin
        s := LogFile^.CabrilloDetail(a);
        writeln(f,'QSO: '+S);
        s := '';
      end;
    begin
      InputFileName := CabrilloData.FileNameIn;
      LogFile := nil;
      if CabrilloData.Contest = 'ARRL-RTTY' then
        LogFile := New(PARRLLogFile, Init);
      if CabrilloData.Contest = 'CQ-WW-RTTY' then
        LogFile := New(PCQWWLogFile, Init);
      if CabrilloData.Contest = 'NAQP-RTTY' then
        LogFile := New(PNAQPLogFile, Init);
      if CabrilloData.Contest = 'TARA-RTTY' then
        LogFile := New(PARRLLogFile, Init);
      if LogFile = nil then begin
        clrscr;
        writeln('Cabrillo.exe error, contest name not programmed.');
        halt;
        end;
      LogFile^.Index := '';
      LogFile^.ResetLog;
      LogFile^.Get_Next(a);
      while OK do begin
        WriteDetail;
        LogFile^.Get_Next(a);
      end;
      Dispose(LogFile, Done);
    end;

  begin
    assign(f,CabrilloData.FileNameOut);
    rewrite(f);
    writeln(f,'START-OF-LOG: 2.0');
    if Trim(CabrilloData.ArrlSection) <> '' then
      writeln(f,'ARRL-SECTION: '+ CabrilloData.ArrlSection);
    writeln(f,'CALLSIGN: '+ CabrilloData.Callsign);
    writeln(f,'CATEGORY: '+ CabrilloData.OperatorCat+' '+
    CabrilloData.BandCat+' '+ CabrilloData.PowerCat+' '+CabrilloData.ModeCat);
    writeln(f,'CATEGORY-OVERLAY: '+ CabrilloData.CategoryOverlay);
    writeln(f,'CLAIMED-SCORE: ');
    if Trim(CabrilloData.Club) <> '' then
      writeln(f,'CLUB: '+ CabrilloData.Club);
    writeln(f,'CONTEST: '+ CabrilloData.Contest);
    if Trim(CabrilloData.Operators) <> '' then
      writeln(f,'OPERATORS: '+ CabrilloData.Operators);
    if Trim(CabrilloData.Name) <> '' then
      writeln(f,'NAME: '+ CabrilloData.Name);
    if Trim(CabrilloData.Address1) <> '' then
      writeln(f,'ADDRESS: '+ CabrilloData.Address1);
    if Trim(CabrilloData.Address2) <> '' then
      writeln(f,'ADDRESS: '+ CabrilloData.Address2);
    if Trim(CabrilloData.Address3) <> '' then
      writeln(f,'ADDRESS: '+ CabrilloData.Address3);
    if Trim(CabrilloData.Address4) <> '' then
      writeln(f,'ADDRESS: '+ CabrilloData.Address4);
    if Trim(CabrilloData.Address5) <> '' then
      writeln(f,'ADDRESS: '+ CabrilloData.Address5);
    if Trim(CabrilloData.Soapbox1) <> '' then
      writeln(f,'SOAPBOX: '+ CabrilloData.Soapbox1);
    if Trim(CabrilloData.Soapbox2) <> '' then
      writeln(f,'SOAPBOX: '+ CabrilloData.Soapbox2);
    if Trim(CabrilloData.Soapbox3) <> '' then
      writeln(f,'SOAPBOX: '+ CabrilloData.Soapbox3);
    if Trim(CabrilloData.Soapbox4) <> '' then
      writeln(f,'SOAPBOX: '+ CabrilloData.Soapbox4);
    if Trim(CabrilloData.Soapbox5) <> '' then
      writeln(f,'SOAPBOX: '+ CabrilloData.Soapbox5);
    writeln(f,'SOAPBOX: RTTY by WF1B Software v4');
    WriteLogToFile;
    writeln(f,'END-OF-LOG:');
    close(f);
  end;

  begin
    InitIni;
    Colors := new(pColors,Init);
    GetValues;
    BuildScreen;
    Edit;
    if WriteFile then
      CreateCabrilloFile;
    DestroyScreen;
    Dispose(Colors,Done(True));
    SetValues;
  end.
