{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit CAmt;
interface
uses
  RecTypes,
  tncobject,
  ApPort,
  Keys;
type
  PAmt         = ^TAmt;
  TAmt         = object(TTnc)
                     constructor Init(const Port : ComNameType);
                     procedure SendString(const Data : String); virtual;
                     procedure Transmit(const Xmit : Boolean); virtual;
                     procedure SetBaudRate(const Rate : Byte); virtual;
                     procedure SetMode(const Mode : String); virtual;
                     procedure Letters; virtual;
                     procedure ClearXmitBuffer; virtual;
                     procedure StopEverything; virtual;
                     destructor Done; virtual;
                   end;

implementation
uses
  DebugRtns,
  TpCrt;

  procedure TAmt.SendString(const Data : String);
  var
    B              : Byte;
  begin
    for B := 1 to Length(Data) do begin
      SendChar(Data[B]);
      if KeyPressed then
        if ReadKeyWord = kbEsc then
          B := Length(Data);
    end;
    while KeyPressed do
      ReadKeyWord;
  end;

  procedure TAmt.Transmit(const Xmit : Boolean);
  begin
    if Xmit then SendByte($01)
    else SendByte($04);
  end;

  procedure TAmt.Letters;
  begin
    SendByte($7F);             { DELETE }
  end;

  procedure TAmt.ClearXmitBuffer;
  begin
    SendByte($18);
  end;

  procedure TAmt.SetMode(const Mode : String);
  begin
    inherited SetMode(Mode);
    if Mode = 'RTTY' then SendString(#27+'R');
  end;

  procedure TAmt.SetBaudRate(const Rate : Byte);
  begin
    case Rate of
      45 : SendString(#27+'B45R');
      50 : SendString(#27+'B50R');
      57 : SendString(#27+'B57R');
      74 : SendString(#27+'B75R');
      100 : SendString(#27+'B00R');
    else
      SendString(#27+'B45R'); {default to 45 if not above}
    end;
  end;

  procedure TAmt.StopEverything;
  begin
    ClearXmitBuffer;
    Transmit(False);
  end;

  constructor TAmt.Init(const Port : ComNameType);
  begin
    inherited InitCom(Port);
    TncNum := bAmt;
    SetMode(GetMode);
    {$IFDEF DEBUG}
    AppendDebugMessage('Amt created');
    {$ENDIF}

  end;

  destructor TAmt.Done;
  begin
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('Amt destroyed');
    {$ENDIF}
  end;

end.
