{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit cCallQue;

interface

type

PCallQueue = ^TCAllQueue;
TCallQueue = object
             Catch_Tbl : array[1..10] of String[12];
             CatchPos  : Byte;
             constructor Init;
             destructor  Done;
             procedure   Edit;
             procedure   Add(Call : String);
             procedure   Scroll(Up : Boolean);
             procedure   Clear;
             procedure   Drop(CallSign : String);
           end;

var
  CallQueue : PCallQueue;

procedure  MakeCallQueue;
procedure  KillCallQueue;


implementation
uses
  TpCrt,
  TpDate,
  TpDos,
  TpEdit,
  TpRarray,
  TpPick,
  TpEntry,
  TpMouse,
  TpWindow,
  TpString,
  cEditWin,
  c_Contest,
  Keys,
  DebugRtns,
  LowLvl,
  RecTypes,
  Routines,
  cRttyWin,
  cColors,
  Diskio;


  constructor TCallQueue.Init;
  begin
    Clear;
    {$IFDEF DEBUG}
    AppendDebugMessage('CallQueue created');
    {$ENDIF}
  end;

  destructor  TCallQueue.Done;
  begin
    {$IFDEF DEBUG}
    AppendDebugMessage('CallQueue destroyed');
    {$ENDIF}
  end;



  procedure TCallQueue.Clear;
  var
    I              : Byte;
  begin
    for I := 1 to 10 do
      Catch_Tbl[I] := '';
    CatchPos := 1;
  end;


  procedure TCallQueue.Edit;
  var
    QueWinPtr      : WindowPtr;
    DoneEditting   : Boolean;
    B              : Byte;
    KeyStroke      : Word;
    Selected       : Byte;

    procedure RedrawWindow;
    var
      B              : Byte;
    begin
      for B := 1 to 10 do
      begin
        FastWriteWindow(Pad(Long2Str(B), 2)+' : '+Pad(Catch_Tbl[B], 12), B+1, 5, Colors^.WindowAttr);
        if B = Selected then FastWriteWindow('', B+1, 3, Colors^.WindowAttr)
        else FastWriteWindow(' ', B+1, 3, Colors^.WindowAttr);
      end;
    end;

    procedure UpdateWindow(Choice : Byte);
    var
      B              : Byte;
    begin
      if Choice in [49..57] then Selected := Choice-48
      else Selected := 10;
      RedrawWindow;
    end;

    procedure CatchErase;
    var
      I              : Byte;
    begin
      for I := Selected to 9 do
        Catch_Tbl[I] := Catch_Tbl[I+1];
      Catch_Tbl[10] := '';
      RedrawWindow;
    end;

    procedure CatchClearAll;
    begin
      Clear;
      RedrawWindow;
    end;

    procedure SendF2;
    begin
      EditW^.EditRecs[1].Call := Catch_Tbl[Selected];
      ThisContest^.FillRec(EditW^.EditRecs[1].Call, EditW^.EditRecs[1]);
      RttyWin^.SendKeys(EsMy14,EditW^.EditRecs[1]);
      DoneEditting := True;
    end;

    procedure SelectCall;
    begin
      EditW^.EditRecs[1].Call := Catch_Tbl[Selected];
      DoneEditting := True;
    end;

    procedure SendF10;
    var
      Call           : String[12];
    begin
      Call := Catch_Tbl[Selected];
      ThisContest^.LogContact(EditW^.EditRecs[1]);
{      LogNewContact(EditW^.EditRecs[1]);  XXX}
      EditW^.EditRecs[1].Call := Call;
      ThisContest^.FillRec(EditW^.EditRecs[1].Call, EditW^.EditRecs[1]);
      RttyWin^.SendKeys(EsMy52,EditW^.EditRecs[1]); {F10}
      DoneEditting := True;
    end;

    procedure LeftClick;
    var
      Row, col       : Byte;
    begin
      col := MouseWhereX;
      Row := MouseWhereY;
      if (Row = ActionBarLine) and (col in [46..48]) then DoneEditting := True;
      case Row of
        4..13 : if col in [5..23] then Selected := Row-3;
        17 : if col in [5..7] then SendF2;
        18 : if col in [5..7] then CatchErase;
        19 : if col in [5..7] then CatchClearAll;
        20 : if col in [5..7] then SendF10;
        21 : if col in [5..7] then DoneEditting := True;
        22 : if col in [5..7] then SelectCall;
      end;
    end;

    procedure RightClick;
    var
      Row, col       : Byte;
    begin
      col := MouseWhereX;
      Row := MouseWhereY;
      if Row in [4..13] then
        if col in [5..23] then
        begin
          Selected := Row-3;
          EditW^.EditRecs[1].Call := Catch_Tbl[Selected];
          SendF2;
        end;
    end;

    procedure ChangeSelected(Factor : Integer);
    begin
      if (Factor = -1) and (Selected > 1) then Dec(Selected);
      if (Factor = +1) and (Selected < 10) then Inc(Selected);
    end;

  begin
    Selected := CatchPos;
    with Colors^ do begin
     if not MakeWindow(QueWinPtr, 2, 2, 26, 23, True, True, False, WindowAttr,
                       FrameAttr, HeaderAttr, 'Call Queue') then Exit;
     DoneEditting := False;
     HideMouse;
     DisplayWindow(QueWinPtr);
     RedrawWindow;
     FastWriteWindow(''+CharStr('', 23)+'', 12, 0, FrameAttr);
     FastWriteWindow('1-0 Select call', 13, 3, WindowAttr);
     FastWriteWindow(Chr(24)+'-'+Chr(25)+' Select call', 14, 3, WindowAttr);
     FastWriteWindow('F2  Send Exchange', 15, 3, WindowAttr);
     FastWriteWindow('F7  Delete Selected', 16, 3, WindowAttr);
     FastWriteWindow('F8  Delete All', 17, 3, WindowAttr);
     FastWriteWindow('F10 Thanks and Next', 18, 3, WindowAttr);
     FastWriteWindow('Esc Exit (& Alt-C)', 19, 3, WindowAttr);
     FastWriteWindow('Enter Select Call', 20, 3, WindowAttr);
    end;
    repeat
      ShowMouse;
      KeyStroke := ReadKeyorButton;
      HideMouse;
      if Lo(KeyStroke) in [48..57] then UpdateWindow(Lo(KeyStroke));
      if KeyStroke = kbEsc then DoneEditting := True;
      if KeyStroke = kbAltC then DoneEditting := True;
      if KeyStroke = kbF2 then SendF2;
      if KeyStroke = kbF7 then CatchErase;
      if KeyStroke = kbF8 then CatchClearAll;
      if KeyStroke = kbF10 then SendF10;
      if KeyStroke = msLeftClick then LeftClick;
      if KeyStroke = msRightClick then RightClick;
      if KeyStroke = kbUp then ChangeSelected(-1);
      if KeyStroke = kbDown then ChangeSelected(+1);
      if KeyStroke = kbEnter then SelectCall;
      if not DoneEditting then RedrawWindow;
    until DoneEditting;
    ShowMouse;
    CatchPos := Selected;
    KillWindow(QueWinPtr);
  end;

  procedure TCallQueue.Drop(CallSign : String);
  var
    I, J           : Byte;
  begin
    J := 11;
    for I := 1 to 10 do
      if Catch_Tbl[I] = CallSign then J := I;
    if J < 11 then                {its in there}
    begin
      for I := J to 9 do
        Catch_Tbl[I] := Catch_Tbl[I+1];
      Catch_Tbl[10] := '';
    end;
  end;

  procedure TCallQueue.Scroll(Up : Boolean);
  var
    I              : Byte;
    Any, OK        : Boolean;
  begin
    Any := False;
    OK := False;
    for I := 1 to 10 do
      if Catch_Tbl[I] <> '' then Any := True;
    if not Any then Exit;         {no calls to select}
    case Up of
      True : begin
               if Trim(EditW^.EditRecs[1].Call) = '' then
                   if CatchPos = 1 then CatchPos := 10 else Dec(CatchPos);
               while not OK do
               begin
                   if CatchPos = 10 then CatchPos := 1 else Inc(CatchPos);
                 if Catch_Tbl[CatchPos] <> '' then OK := True;
               end;
             end;
      False : begin
                if Trim(EditW^.EditRecs[1].Call) = '' then
                    if CatchPos = 10 then CatchPos := 1 else Inc(CatchPos);
                while not OK do
                begin
                    if CatchPos = 1 then CatchPos := 10 else Dec(CatchPos);
                  if Catch_Tbl[CatchPos] <> '' then OK := True;
                end;
              end;
    end;
    EditW^.EditRecs[1].Call := Catch_Tbl[CatchPos];
    ThisContest^.FillRec(EditW^.EditRecs[1].Call, EditW^.EditRecs[1]);
  end;

  procedure TCallQueue.Add(Call : String);
  var
    OK             : Boolean;
    I : Integer;
  begin
    OK := True;                   {assume we need it on list}
    for I := 1 to 10 do
      if Catch_Tbl[I] = Ccall then OK := False; {nope!}
    if OK then begin
      for I := 9 downto 1 do
        Catch_Tbl[I+1] := Catch_Tbl[I]; {bump list}
      Catch_Tbl[1] := Ccall;
    end;
  end;


procedure  MakeCallQueue;
begin
  CallQueue := New(PCallQueue, Init);
end;

procedure  KillCallQueue;
begin
  if Assigned(CallQueue) then Dispose(CallQueue, Done);
  CallQueue := NIL;
end;



end.



