{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
unit CColors;

interface

uses
  TpPick;

type

  PColors = ^TColors;
  TColors = object
              WindowAttr : Byte;
              FrameAttr : Byte;
              HeaderAttr : Byte;
              PromptAttr : Byte;
              StringAttr : Byte;
              CtrlAttr : Byte;
              HiLiteAttr : Byte;
              RIAttr : Byte;
              MessageAttr : Byte;
              CatchGoodAttr : Byte;
              CatchDupeAttr : Byte;
              PickColors : PickColorArray;
              constructor Init;
              function ColorStrToByte(const Clr : String) : Byte;
              function ColorByteToStr(const Clr : Byte) : String;
              procedure SetEntryAttributes;
              destructor Done(const Save : Boolean);
            end;
var
  Colors : PColors;

const
  ColorArray : array[0..$7F] of String[19] = (
    'BlackOnBlack',
    'BlueOnBlack',
    'GreenOnBlack',
    'CyanOnBlack',
    'RedOnBlack',
    'MagentaOnBlack',
    'BrownOnBlack',
    'LtGrayOnBlack',
    'DkGrayOnBlack',
    'LtBlueOnBlack',
    'LtGreenOnBlack',
    'LtCyanOnBlack',
    'LtRedOnBlack',
    'LtMagentaOnBlack',
    'YellowOnBlack',
    'WhiteOnBlack',
    'BlackOnBlue',
    'BlueOnBlue',
    'GreenOnBlue',
    'CyanOnBlue',
    'RedOnBlue',
    'MagentaOnBlue',
    'BrownOnBlue',
    'LtGrayOnBlue',
    'DkGrayOnBlue',
    'LtBlueOnBlue',
    'LtGreenOnBlue',
    'LtCyanOnBlue',
    'LtRedOnBlue',
    'LtMagentaOnBlue',
    'YellowOnBlue',
    'WhiteOnBlue',
    'BlackOnGreen',
    'BlueOnGreen',
    'GreenOnGreen',
    'CyanOnGreen',
    'RedOnGreen',
    'MagentaOnGreen',
    'BrownOnGreen',
    'LtGrayOnGreen',
    'DkGrayOnGreen',
    'LtBlueOnGreen',
    'LtGreenOnGreen',
    'LtCyanOnGreen',
    'LtRedOnGreen',
    'LtMagentaOnGreen',
    'YellowOnGreen',
    'WhiteOnGreen',
    'BlackOnCyan',
    'BlueOnCyan',
    'GreenOnCyan',
    'CyanOnCyan',
    'RedOnCyan',
    'MagentaOnCyan',
    'BrownOnCyan',
    'LtGrayOnCyan',
    'DkGrayOnCyan',
    'LtBlueOnCyan',
    'LtGreenOnCyan',
    'LtCyanOnCyan',
    'LtRedOnCyan',
    'LtMagentaOnCyan',
    'YellowOnCyan',
    'WhiteOnCyan',
    'BlackOnRed',
    'BlueOnRed',
    'GreenOnRed',
    'CyanOnRed',
    'RedOnRed',
    'MagentaOnRed',
    'BrownOnRed',
    'LtGrayOnRed',
    'DkGrayOnRed',
    'LtBlueOnRed',
    'LtGreenOnRed',
    'LtCyanOnRed',
    'LtRedOnRed',
    'LtMagentaOnRed',
    'YellowOnRed',
    'WhiteOnRed',
    'BlackOnMagenta',
    'BlueOnMagenta',
    'GreenOnMagenta',
    'CyanOnMagenta',
    'RedOnMagenta',
    'MagentaOnMagenta',
    'BrownOnMagenta',
    'LtGrayOnMagenta',
    'DkGrayOnMagenta',
    'LtBlueOnMagenta',
    'LtGreenOnMagenta',
    'LtCyanOnMagenta',
    'LtRedOnMagenta',
    'LtMagentaOnMagenta',
    'YellowOnMagenta',
    'WhiteOnMagenta',
    'BlackOnBrown',
    'BlueOnBrown',
    'GreenOnBrown',
    'CyanOnBrown',
    'RedOnBrown',
    'MagentaOnBrown',
    'BrownOnBrown',
    'LtGrayOnBrown',
    'DkGrayOnBrown',
    'LtBlueOnBrown',
    'LtGreenOnBrown',
    'LtCyanOnBrown',
    'LtRedOnBrown',
    'LtMagentaOnBrown',
    'YellowOnBrown',
    'WhiteOnBrown',
    'BlackOnLtGray',
    'BlueOnLtGray',
    'GreenOnLtGray',
    'CyanOnLtGray',
    'RedOnLtGray',
    'MagentaOnLtGray',
    'BrownOnLtGray',
    'LtGrayOnLtGray',
    'DkGrayOnLtGray',
    'LtBlueOnLtGray',
    'LtGreenOnLtGray',
    'LtCyanOnLtGray',
    'LtRedOnLtGray',
    'LtMagentaOnLtGray',
    'YellowOnLtGray',
    'WhiteOnLtGray');

  Color_first = $00;
  BlackOnBlack = $00;
  BlackOnBlue = $10;
  BlackOnBrown = $60;
  BlackOnCyan = $30;
  BlackOnGreen = $20;
  BlackOnLtGray = $70;
  BlackOnMagenta = $50;
  BlackOnRed = $40;
  BlueOnBlack = $01;
  BlueOnBlue = $11;
  BlueOnBrown = $61;
  BlueOnCyan = $31;
  BlueOnGreen = $21;
  BlueOnLtGray = $71;
  BlueOnMagenta = $51;
  BlueOnRed = $41;
  BrownOnBlack = $06;
  BrownOnBlue = $16;
  BrownOnBrown = $66;
  BrownOnCyan = $36;
  BrownOnGreen = $26;
  BrownOnLtGray = $76;
  BrownOnMagenta = $56;
  BrownOnRed = $46;
  CyanOnBlack = $03;
  CyanOnBlue = $13;
  CyanOnBrown = $63;
  CyanOnCyan = $33;
  CyanOnGreen = $23;
  CyanOnLtGray = $73;
  CyanOnMagenta = $53;
  CyanOnRed = $43;
  DkGrayOnBlack = $08;
  DkGrayOnBlue = $18;
  DkGrayOnBrown = $68;
  DkGrayOnCyan = $38;
  DkGrayOnGreen = $28;
  DkGrayOnLtGray = $78;
  DkGrayOnMagenta = $58;
  DkGrayOnRed = $48;
  GreenOnBlack = $02;
  GreenOnBlue = $12;
  GreenOnBrown = $62;
  GreenOnCyan = $32;
  GreenOnGreen = $22;
  GreenOnLtGray = $72;
  GreenOnMagenta = $52;
  GreenOnRed = $42;
  LtBlueOnBlack = $09;
  LtBlueOnBlue = $19;
  LtBlueOnBrown = $69;
  LtBlueOnCyan = $39;
  LtBlueOnGreen = $29;
  LtBlueOnLtGray = $79;
  LtBlueOnMagenta = $59;
  LtBlueOnRed = $49;
  LtCyanOnBlack = $0B;
  LtCyanOnBlue = $1B;
  LtCyanOnBrown = $6B;
  LtCyanOnCyan = $3B;
  LtCyanOnGreen = $2B;
  LtCyanOnLtGray = $7B;
  LtCyanOnMagenta = $5B;
  LtCyanOnRed = $4B;
  LtGrayOnBlack = $07;
  LtGrayOnBlue = $17;
  LtGrayOnBrown = $67;
  LtGrayOnCyan = $37;
  LtGrayOnGreen = $27;
  LtGrayOnLtGray = $77;
  LtGrayOnMagenta = $57;
  LtGrayOnRed = $47;
  LtGreenOnBlack = $0A;
  LtGreenOnBlue = $1A;
  LtGreenOnBrown = $6A;
  LtGreenOnCyan = $3A;
  LtGreenOnGreen = $2A;
  LtGreenOnLtGray = $7A;
  LtGreenOnMagenta = $5A;
  LtGreenOnRed = $4A;
  LtMagentaOnBlack = $0D;
  LtMagentaOnBlue = $1D;
  LtMagentaOnBrown = $6D;
  LtMagentaOnCyan = $3D;
  LtMagentaOnGreen = $2D;
  LtMagentaOnLtGray = $7D;
  LtMagentaOnMagenta = $5D;
  LtMagentaOnRed = $4D;
  LtRedOnBlack = $0C;
  LtRedOnBlue = $1C;
  LtRedOnBrown = $6C;
  LtRedOnCyan = $3C;
  LtRedOnGreen = $2C;
  LtRedOnLtGray = $7C;
  LtRedOnMagenta = $5C;
  LtRedOnRed = $4C;
  MagentaOnBlack = $05;
  MagentaOnBlue = $15;
  MagentaOnBrown = $65;
  MagentaOnCyan = $35;
  MagentaOnGreen = $25;
  MagentaOnLtGray = $75;
  MagentaOnMagenta = $55;
  MagentaOnRed = $45;
  RedOnBlack = $04;
  RedOnBlue = $14;
  RedOnBrown = $64;
  RedOnCyan = $34;
  RedOnGreen = $24;
  RedOnLtGray = $74;
  RedOnMagenta = $54;
  RedOnRed = $44;
  WhiteOnBlack = $0F;
  WhiteOnBlue = $1F;
  WhiteOnBrown = $6F;
  WhiteOnCyan = $3F;
  WhiteOnGreen = $2F;
  WhiteOnLtGray = $7F;
  WhiteOnMagenta = $5F;
  WhiteOnRed = $4F;
  YellowOnBlack = $0E;
  YellowOnBlue = $1E;
  YellowOnCyan = $3E;
  YellowOnGreen = $2E;
  YellowOnLtGray = $7E;
  YellowOnMagenta = $5E;
  YellowOnRed = $4E;
  Color_Last = $7E;
  Blink = $80;
  Color_Error = BlueOnRed+Blink;

implementation

uses
  IniFile,
  TpEntry,
  TpString;

  constructor TColors.Init;

    procedure GetAttr(var attr : Byte; const Name : String; const Default : Byte);
    begin
      attr := ColorStrToByte(RttyIni^.GetProfileString(Name, 'COLORS', ''));
      if attr = Color_Error then  { not found, try getting the "old" number }
        attr := RttyIni^.GetProfileByte(Name, 'COLORS', Color_Error);
      if attr = Color_Error then  { not found, use default }
        attr := Default;
      RttyIni^.SetOrAddProfileString(Name, 'COLORS', ColorByteToStr(attr));
    end;

  begin
    GetAttr(WindowAttr, 'WindowAttr', GreenOnBlack);
    GetAttr(FrameAttr, 'FrameAttr', RedOnBlack);
    GetAttr(HeaderAttr, 'HeaderAttr', LtGreenOnBlack);
    GetAttr(PromptAttr, 'PromptAttr', CyanOnBlack);
    GetAttr(StringAttr, 'StringAttr', DkGrayOnCyan);
    GetAttr(CtrlAttr, 'CtrlAttr', LtCyanOnCyan);
    GetAttr(HiLiteAttr, 'HiLiteAttr', LtGrayOnBlack);
    GetAttr(MessageAttr, 'Message', DkGrayOnCyan);
    GetAttr(CatchGoodAttr, 'CatchGood', LtGrayOnBlack);
    GetAttr(CatchDupeAttr, 'CatchDupe', RedOnBlack);
    GetAttr(RIAttr, 'RI', YellowOnBlack);
    PickColors[TpPick.WindowAttr] := WindowAttr;
    PickColors[TpPick.FrameAttr] := FrameAttr;
    PickColors[TpPick.HeaderAttr] := HeaderAttr;
    PickColors[TpPick.SelectAttr] := HeaderAttr;
    PickColors[TpPick.AltNormal] := HiLiteAttr;
    PickColors[TpPick.AltHigh] := HeaderAttr;
  end;

  destructor TColors.Done(const Save : Boolean);
  begin
    if Save then begin
      RttyIni^.SetOrAddProfileString('WindowAttr', 'COLORS', ColorByteToStr(WindowAttr));
      RttyIni^.SetOrAddProfileString('FrameAttr', 'COLORS', ColorByteToStr(FrameAttr));
      RttyIni^.SetOrAddProfileString('HeaderAttr', 'COLORS', ColorByteToStr(HeaderAttr));
      RttyIni^.SetOrAddProfileString('PromptAttr', 'COLORS', ColorByteToStr(PromptAttr));
      RttyIni^.SetOrAddProfileString('StringAttr', 'COLORS', ColorByteToStr(StringAttr));
      RttyIni^.SetOrAddProfileString('CtrlAttr', 'COLORS', ColorByteToStr(CtrlAttr));
      RttyIni^.SetOrAddProfileString('HiLiteAttr', 'COLORS', ColorByteToStr(HiLiteAttr));
      RttyIni^.SetOrAddProfileString('Message', 'COLORS', ColorByteToStr(MessageAttr));
      RttyIni^.SetOrAddProfileString('CatchDupe', 'COLORS', ColorByteToStr(CatchDupeAttr));
      RttyIni^.SetOrAddProfileString('CatchGood', 'COLORS', ColorByteToStr(CatchGoodAttr));
      RttyIni^.SetOrAddProfileString('RI', 'COLORS', ColorByteToStr(RIAttr));
    end;
  end;

  function TColors.ColorStrToByte(const Clr : String) : Byte;
  var
    Result : Byte;
  begin
    for Result := Color_first to Color_Last do
      if StUpCase(ColorArray[Result]) = StUpCase(Clr) then begin
        ColorStrToByte := Result;
        Exit;
      end;
    ColorStrToByte := Color_Error;
  end;


  function TColors.ColorByteToStr(const Clr : Byte) : String;
  begin
    if (Clr >= Color_first) and (Clr <= Color_Last) then
      ColorByteToStr := ColorArray[Clr]
    else
      ColorByteToStr := 'ERROR';
  end;

  procedure TColors.SetEntryAttributes;
  begin
    SetCtrlAttr(CtrlAttr);
    SetFieldAttr(PromptAttr);
    SetPromptAttr(PromptAttr);
    SetStringAttr(StringAttr);
  end;


end.
