{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$F+,O+}
unit cDist_ja;
interface

  {* FUNCTIONS AVAILABLE FROM THIS UNIT *}

uses
  cDist,
  Rectypes;

type

  PJADistList = ^TJADistList;
  TJADistList = object(TDistList)
                 public
                   constructor Init;
                   Destructor  Done; virtual;
                 end;

var
  JADistList : PDistList;  { point to parent type for polymorphism}

procedure MakeJADistList;
procedure KillJADistList;

implementation

uses
  DebugRtns,
  OneTimers;


  constructor TJADistList.Init;
  begin
    inherited Init('JA');
    {$IFDEF DEBUG}
    AppendDebugMessage('JADistList created');
    {$ENDIF}
  end;

  Destructor  TJADistList.Done;
  begin
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('JADistList destroyed');
    {$ENDIF}
  end;

  procedure MakeJADistList;
  begin
    JADistList := New(PJADistList, Init);
    if not assigned(JADistList) then begin
      MessageBox('Severe Error!',
                 'Unable to create JA District list',
                 'Contact Wyvern Technology',
                 'Consider reinstalling from diskette');
      CloseDownScreen;
      Halt;
    end;
  end;

  procedure KillJADistList;
  begin
    if Assigned(JADistList) then Dispose(JADistList, Done);
    JADistList := NIL;
  end;

end.
