{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$F+,O+}
unit cDist_ve;
interface

  {* FUNCTIONS AVAILABLE FROM THIS UNIT *}

uses
  cDist,
  Rectypes;

type

  PVEDistList = ^TVEDistList;
  TVEDistList = object(TDistList)
                 public
                   constructor Init;
                   Destructor  Done; virtual;
                 end;

var
  VEDistList : PDistList;  { point to parent type for polymorphism}

procedure MakeVEDistList;
procedure KillVEDistList;

implementation

uses
  DebugRtns,
  OneTimers;


  constructor TVEDistList.Init;
  begin
    inherited Init('VE');
    {$IFDEF DEBUG}
    AppendDebugMessage('VEDistList created');
    {$ENDIF}
  end;

  Destructor  TVEDistList.Done;
  begin
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('VEDistList destroyed');
    {$ENDIF}
  end;

  procedure MakeVEDistList;
  begin
    VEDistList := New(PVEDistList, Init);
    if not assigned(VEDistList) then begin
      MessageBox('Severe Error!',
                 'Unable to create VE District list',
                 'Contact Wyvern Technology',
                 'Consider reinstalling from diskette');
      CloseDownScreen;
      Halt;
    end;
  end;

  procedure KillVEDistList;
  begin
    if Assigned(VEDistList) then Dispose(VEDistList, Done);
    VEDistList := NIL;
  end;

end.
