{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$F+,O+}
unit cDist_w;
interface

  {* FUNCTIONS AVAILABLE FROM THIS UNIT *}

uses
  cDist,
  Rectypes;

type

  PWDistList = ^TWDistList;
  TWDistList = object(TDistList)
                 public
                   constructor Init;
                   Destructor  Done; virtual;
                   function    GetZoneByCall(const Cl : string) : byte;
                 end;

var
  WDistList : PDistList;  { point to parent type for polymorphism}

procedure MakeWDistList;
procedure KillWDistList;

implementation

uses
  DebugRtns,
  OneTimers;


  constructor TWDistList.Init;
  begin
    inherited Init('W');
    {$IFDEF DEBUG}
    AppendDebugMessage('WDistList created');
    {$ENDIF}
  end;

  Destructor  TWDistList.Done;
  begin
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('WDistList destroyed');
    {$ENDIF}
  end;

  function    TWDistList.GetZoneByCall(const Cl : string) : byte;
  begin

  end;



  procedure MakeWDistList;
  begin
    WDistList := New(PWDistList, Init);
    if not assigned(WDistList) then begin
      MessageBox('Severe Error!',
                 'Unable to create W District list',
                 'Contact Wyvern Technology',
                 'Consider reinstalling from diskette');
      CloseDownScreen;
      Halt;
    end;
  end;

  procedure KillWDistList;
  begin
    if Assigned(WDistList) then Dispose(WDistList, Done);
    WDistList := NIL;
  end;

end.
