{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$F+,O+}
unit cDist_zl;
interface

  {* FUNCTIONS AVAILABLE FROM THIS UNIT *}

uses
  cDist,
  Rectypes;

type

  PZLDistList = ^TZLDistList;
  TZLDistList = object(TDistList)
                 public
                   constructor Init;
                   Destructor  Done; virtual;
                 end;

var
  ZLDistList : PDistList;  { point to parent for polymorpism!}

procedure MakeZLDistList;
procedure KillZLDistList;

implementation

uses
  DebugRtns,
  OneTimers;


  constructor TZLDistList.Init;
  begin
    inherited Init('ZL');
    {$IFDEF DEBUG}
    AppendDebugMessage('ZLDistList created');
    {$ENDIF}
  end;

  Destructor  TZLDistList.Done;
  begin
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('ZLDistList destroyed');
    {$ENDIF}
  end;

  procedure MakeZLDistList;
  begin
    ZLDistList := New(PZLDistList, Init);
    if not assigned(ZLDistList) then begin
      MessageBox('Severe Error!',
                 'Unable to create ZL District list',
                 'Contact Wyvern Technology',
                 'Consider reinstalling from diskette');
      CloseDownScreen;
      Halt;
    end;
  end;

  procedure KillZLDistList;
  begin
    if Assigned(ZLDistList) then Dispose(ZLDistList, Done);
    ZLDistList := NIL;
  end;

end.
