{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit CKam;
interface
uses RecTypes,
  tncobject,
  ApPort;
type
  PKam         = ^TKam;
  TKam         = object(TTnc)
                     constructor Init(const Port : ComNameType);
                     procedure Transmit(const Xmit : Boolean); virtual;
                     procedure SetUsos(const USOS : Boolean); virtual;
                     procedure SetBaudRate(const Rate : Byte); virtual;
                     procedure SetMode(const Mode : String);virtual;
                     procedure Letters; virtual;
                     procedure Figures; virtual;
                     procedure ClearXmitBuffer; virtual;
                     procedure StopEverything; virtual;
                     destructor Done; virtual;
                     procedure ToggleTncTalk ; Virtual;
                   end;

implementation

uses
  DebugRtns,
  IniFile,
  ApTimer,
  TpCrt;

  procedure TKam.Transmit(const Xmit : Boolean);
  begin
    if Xmit then SendString(^C+'T')
    else SendString(^C+'E');
  end;

  procedure TKam.SetUsos(const USOS : Boolean);
  begin
    inherited Setusos(Usos);
    case Usos of
      True : SendString(^C+'USO ON'+^M);
      False: SendString(^C+'USO OFF'+^M);
    end;
  end;

  procedure TKam.Letters;
  begin
    SendChar(^L);
  end;

  procedure TKam.Figures;
  begin
    SendChar(^N);
  end;

  procedure TKam.ClearXmitBuffer;
  begin
    SendChar(^X);
  end;

  procedure TKam.SetMode(const Mode : String);
  begin
    if Mode = 'RTTY' then begin
      inherited SetMode(Mode);
      SendString('RTTY'+^M);
    end;
  end;

  procedure TKam.SetBaudRate(const Rate : Byte);
  begin
    case Rate of
      45 : SendString(^C+'1');
      50 : SendString(^C+'2');
      57 : SendString(^C+'3');
      74 : SendString(^C+'4');
      100 : SendString(^C+'5');
      110 : SendString(^C+'6');
    else
      SendString(^C+'1');  {default to 45 if not above}
    end;
  end;

  procedure TKam.StopEverything;
  begin
    ClearXmitBuffer;
    Transmit(False);
  end;

  constructor TKam.Init(const Port : ComNameType);
  var
    et : EventTimer;
    s  : String[80];
  begin
    inherited InitCom(Port);
    TncNum := bKam;
    SendString(^M);
    SendString(#$C0+'Q'+#$C0);
    NewTimer(et, 36);
    repeat
      GetString(80,S);
    until TimerExpired(Et) or (Pos('KANTRONICS',S)>0) or (Pos('cmd:',S)>0);
    SendString(^M);
    Delay(100);
    SendString('FLOW OFF'^M);
    Delay(100);
    SendString('XMITECHO ON'^M);
    Delay(100);
    SendString('ECHO ON'^M);
    Delay(100);
    SetUsos(GetUsos);
    Delay(100);
    SetSense(GetSense);
    Delay(100);
    SendString(^M);
    Delay(100);
    SetMode(GetMode);
    Delay(100);
    {$IFDEF DEBUG}
    AppendDebugMessage('KAM created');
    {$ENDIF}
  end;

  destructor TKam.Done;
  begin
    SendString(^C+'X');
    Delay(300);
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('KAM destroyed');
    {$ENDIF}
  end;

  procedure TKam.ToggleTncTalk;
  begin
    if TncTalk then SetMode('RTTY')
               else SendString(^C+'X');
    TncTalk := not TncTalk;
  end;


end.
