{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit cLogArrl;

interface

uses
  Diskio;

type

PARRLLogFile = ^TARRLLOgFile;
TARRLLogFile = object(TLogFile)
  procedure BuildEditScreen; virtual;
  function  CabrilloDetail(var R : log_rec) : string; virtual;
end;

implementation
uses
  TpString,
  TpEntry;

  procedure TARRLLogFile.BuildEditScreen;
  begin
    inherited BuildEditScreen;
    AddStringField(EditEsr, 'State/Prov', 16, 3, '!!!',
                                          16, 15, 3, 0, nil, Work.his_qth);
    AddWordField(EditEsr,   'Rec''d Ser#',17, 3, '9999',
                                          17, 15, 0, 0, 9999, Work.His_Serno);
    AddStringField(EditEsr, 'Comments',   18, 3, '',
                                          18, 15, 25, 0, nil, Work.comment);
  end;

 function TARRLLogFile.CabrilloDetail(var R : log_rec) : string;
 var
   s : string;
 begin
   s := inherited CabrilloDetail(R);
   { builds up to callsign (including the space after it) }
{                              --------info sent------- -------info rcvd--------
 QSO: freq  mo date       time call          rst exch   call          rst exch   t
 QSO: ***** ** yyyy-mm-dd nnnn ************* nnn ****** ************* nnn ****** n
 QSO:  3799 PH 1999-03-06 0711 HC8N          59  700    W1AW          59  CT     0
 000000000111111111122222222223333333333444444444455555555556666666666777777777788
 123456789012345678901234567890123456789012345678901234567890123456789012345678901
}
   S := S + Long2Str(r.His_RST)+'9 ';
   if trim(r.my_qth) <> '' then
     { exchange ****** } S := S + copy(r.my_qth+'       ',1,7)
   else
      { exchange ****** } S := S + copy(long2str(r.my_serno)+'       ',1,7);
   S := S + Copy(Pad(r.Call, 13), 1, 13) + ' ';
   S := S + Long2Str(r.my_RST)+'9 ';
   if trim(r.his_qth) <> '' then
     { exchange ****** } S := S + copy(r.his_qth+'       ',1,7)
   else
      { exchange ****** } S := S + copy(long2str(r.his_serno)+'       ',1,7);
   CabrilloDetail := s;
  end;


end.