{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$F+,O+}
unit ClstrNet;

interface

uses OoCom, ApPort, TpWIndow,ClusterTerm;

type


  PNetClusterTerminal = ^TnetClusterTerminal;
  TNetClusterTerminal = object(TClusterTerminal)
                       constructor Init;
                       destructor Done; virtual;
                       procedure Idle; virtual;
                       procedure SendMessageToCluster(const AMsg : string);virtual;
                       procedure AcceptDataFromNetCluster(const AData : string); virtual;
                     end;



implementation

uses
  Dos,
  TpDos,
  TpString,
  TpCrt,
  ApTimer,
  NetWork,
  cCountry,
  RecTypes,
  ClusterMon,
  lowlvl,
  TpEdit,
  DebugRtns,
  IniFile;


  constructor TNetClusterTerminal.Init;
  begin
    inherited Init;
    {$IFDEF DEBUG}
    AppendDebugMessage('NetClusterTerminal created');
    {$ENDIF}
  end;

  destructor TNetClusterTerminal.Done;
  begin
    {$IFDEF DEBUG}
    AppendDebugMessage('NetClusterTerminal destroyed');
    {$ENDIF}
    inherited Done;
  end;

  procedure TNetClusterTerminal.Idle;
  begin
    ClusterMonitor^.Idle(False);
  end;

  procedure TNetClusterTerminal.SendMessageToCluster(const AMsg : string);
  begin
    if Assigned(Net) then begin
      Net^.SendClusterTxData(AMsg);
      {$IFDEF DEBUG}
      AppendDebugMessage('TNetClusterTerminal.SendMessageToCluster=>'+AMsg);
      {$ENDIF}
    end;
  end;

  procedure TNetClusterTerminal.AcceptDataFromNetCluster(const AData : string);
  begin
    {$IFDEF DEBUG}
    AppendDebugMessage('TNetClusterTerminal.AcceptDataFromNetCluster=>'+AData);
    {$ENDIF}
    with ClusterMonitor^ do begin
      AppendStrToLine(aData);
      Idle(False);
    end;
    LineIn := aData;
    while Pos(#$0D,LineIn) > 0 do
      Delete(LineIn, Pos(#$0D,LineIn), 1);
    while Pos(#$0A,LineIn) > 0 do
      Delete(LineIn, Pos(#$0A,LineIn), 1);
    while Length(LineIn) > 1 do begin
      ScrollInLines;
      LinesIn[20] := Copy(LineIn,1,78);
      NeedRefresh := True;
      Delete(LineIn,1,78);
    end;
    LineIn := '';
  end;


end.
