{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit CMfj1278;
interface
uses RecTypes,
  tncobject,
  TpCrt,
  ApPort;
type
  PMfj1278         = ^TMfj1278;
  TMfj1278         = object(TTnc)
                     constructor Init(const Port : ComNameType);
                     procedure Transmit(const Xmit : Boolean); virtual;
                     procedure SetUsos(const USOS : Boolean);virtual;
                     procedure SetBaudRate(const Rate : Byte); virtual;
                     procedure SetMode(const Mode : string);virtual;
                     procedure ClearXmitBuffer; virtual;
                     procedure SetSense(const Sense : Boolean); virtual;
                     procedure StopEverything; virtual;
                     procedure  ToggleTncTalk; virtual;
                     destructor Done; virtual;
                   end;

implementation

  uses
    ApUart,
    DebugRtns,
    IniFile;

  procedure TMfj1278.Transmit(const Xmit : Boolean);
  begin
    if Xmit then SendChar(^T)
    else SendChar(^R);
  end;

  procedure TMfj1278.SetUsos(const USOS : Boolean);
  begin
    inherited Setusos(usos);
    if USOS then SendString('UNSHIFT ON'+^M)
    else SendString('UNSHIFT OFF'+^M)
  end;

  procedure TMfj1278.ClearXmitBuffer;
  begin
    SendChar(^X);
  end;

  procedure TMfj1278.SetMode(const Mode : String);
  begin
    inherited Setmode(Mode);
    if Mode = 'RTTY' then SendString(^C+'MODE HB,45');
    SendChar(^M);
  end;

  procedure TMfj1278.SetBaudRate(const Rate : Byte);
  begin
    case Rate of
      45 : SendString(^C+'MODE HB,45');
      50 : SendString(^C+'MODE HB,50');
      57 : SendString(^C+'MODE HB,57');
      74 : SendString(^C+'MODE HB,74');
      100 : SendString(^C+'MODE HB,100');
      110 : SendString(^C+'MODE HB,110');
    else
      SendString(^C+'MODE HB,45');
    end;
    SendCHar(^M);
  end;

  procedure TMfj1278.StopEverything;
  begin
    sendlongbreak(UP^.GetBaseAddr,2);
    Delay(1000);
    ClearUP;
    SendString(^M);
    Delay(100);
    SendString('K'^M);
  end;

  procedure TMfj1278.ToggleTncTalk;
  begin
    if TncTalk then SendString('K'^M)
               else SendString(^C);
    TncTalk := not TncTalk;
  end;

  procedure TMfj1278.SetSense(const Sense : Boolean);
  begin
    case Sense of
      True : begin
               SendString(^C);
               Delay(50);
               SendString(^M);
               Delay(50);
               SendString('RXINVERT OFF'^M);
               Delay(50);
               SendString('K'^M);
             end;
      False : begin
               SendString(^C);
               Delay(50);
               SendString(^M);
               Delay(50);
               SendString('RXINVERT ON'^M);
               Delay(50);
               SendString('K'^M);
             end;
    end;
    inherited SetSense(Sense);
  end;

  constructor TMfj1278.Init(const Port : ComNameType);
  var
    I  : Word;
  begin
    inherited InitCom(Port);
    TncNum := bMfj1278;
    for I := 1 to 10 do begin
      Delay(400);
      SendChar(^M);
    end;
    SetMode(GetMode);
    SetUsos(GetUsos);
    SendString(^C+^M+'K'+^M);
    {$IFDEF DEBUG}
    AppendDebugMessage('MFJ1278 created');
    {$ENDIF}
  end;

  destructor TMfj1278.Done;
  begin
    SendString(^C);
    Delay(100);
    SendString(^M);
    Delay(100);
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('MFJ1278 destroyed');
    {$ENDIF}
  end;

end.
