{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit CNoTnc;
interface
uses
  TncObject,
  LowLvl,
  RecTypes;
type
  PNoTnc       = ^TNoTnc;
  TNoTnc       = object(TTnc)
                     constructor Init;
                     procedure Sendbyte(const Data : Byte); virtual;
                     procedure SendChar(const Data : Char); virtual;
                     procedure SendString(const Data : String); virtual;
                     procedure Transmit(const Xmit : Boolean); virtual;
                     procedure Receive(var Ch : Char); virtual;
                     destructor Done; virtual;
                   end;

implementation

  uses
    cRttyWin,
    DebugRtns;

  procedure TNoTnc.SendByte(const Data : Byte);
  begin
    RttyWin^.PutChar(Chr(Data));
  end;

  procedure TNoTnc.SendChar(const Data : Char);
  begin
    RttyWin^.PutChar(Data);
  end;

  procedure TNoTnc.SendString(const Data : String);
  begin
    RttyWin^.PutString(Data);
  end;

  procedure TNoTnc.Transmit(const Xmit : Boolean);
  begin
    Case XMIT of
      TRUE : RttyWin^.HilightOn;
      FALSE: RttyWin^.HilightOff;
    end;
  end;

  procedure TNoTnc.Receive(var Ch : Char);
  begin
    Ch := #00;
  end;

  constructor TNoTnc.Init;
  begin
    inherited Init;
    TncNum := bNone;
    {$IFDEF DEBUG}
    AppendDebugMessage('NOTNC created');
    {$ENDIF}
  end;

  destructor TNoTnc.Done;
  begin
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('NOTNC destroyed');
    {$ENDIF}
  end;

end.
