{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program Colorset;
uses
  TpEnhKbd,
  TpString,
  TpDos,
  TpCrt,
  TpCmd,
  TpEntry,
  TpWindow,
  IniFile,
  cColors;

const
  cWindowAttr    : Byte = BlueOnLtGray;
  cFrameAttr     : Byte = BlueOnLtGray;
  cHeaderAttr    : Byte = LtGrayOnBlue;
  cPromptAttr    : Byte = BlueOnLtGray;
  cStringAttr    : Byte = LtGrayOnBlue;
  cCtrlAttr      : Byte = LtGrayOnBlue;
  cHiLiteAttr    : Byte = LtBlueOnLtGray;

var
  B              : Byte;
  L              : Byte;
  KW             : Word;
  GetOut         : Boolean;
  Escaped        : Boolean;
  ZoneWin        : WindowPtr;
  EditWin        : WindowPtr;
  Num            : Byte;

  procedure ColorSetScreenColors;
    { these are attr for all but sample windows }
  begin
    MapColors := False;
    if LastMode in [BW80, MONO] then
    begin
      cWindowAttr := LtGrayOnBlack;
      cFrameAttr := LtGrayOnBlack;
      cHeaderAttr := BlackOnLtGray;
      cPromptAttr := LtGrayOnBlack;
      cStringAttr := BlackOnLtGray;
      cCtrlAttr := LtGrayOnBlack;
      cHiLiteAttr := BlackOnLtGray;
    end
    else
    begin
      cWindowAttr := BlueOnLtGray;
      cFrameAttr := BlueOnLtGray;
      cHeaderAttr := LtGrayOnBlue;
      cPromptAttr := BlueOnLtGray;
      cStringAttr := LtGrayOnBlue;
      cCtrlAttr := BlueOnLtGray;
      cHiLiteAttr := LtBlueOnLtGray;
    end;

  end;

  procedure DefaultColors;  {alt-d}
    { these are attr for all sample windows }
  begin
    MapColors := False;
    if LastMode in [BW80, MONO] then begin
      Colors^.WindowAttr := LtGrayOnBlack;
      Colors^.FrameAttr := LtGrayOnBlack;
      Colors^.HeaderAttr := LtGrayOnBlack;
      Colors^.PromptAttr := LtGrayOnBlack;
      Colors^.StringAttr := BlackOnLtGray;
      Colors^.CtrlAttr := LtGrayOnBlack;
      Colors^.HiLiteAttr := BlackOnLtGray;
    end
    else begin
      Colors^.WindowAttr := 2;
      Colors^.FrameAttr := 4;
      Colors^.HeaderAttr := 10;
      Colors^.PromptAttr := 3;
      Colors^.StringAttr := 56;
      Colors^.CtrlAttr := 59;
      Colors^.HiLiteAttr := 7;
    end;
  end;

  procedure Old_Colors; {ALT-A}
    { these are attr for all sample windows }
  begin
      MapColors := False;
      Colors^.WindowAttr := BlueOnLtGray;
      Colors^.FrameAttr := BlueOnLtGray;
      Colors^.HeaderAttr := LtGrayOnBlue;
      Colors^.PromptAttr := BlueOnLtGray;
      Colors^.StringAttr := LtGrayOnBlue;
      Colors^.CtrlAttr := BlueOnLtGray;
      Colors^.HiLiteAttr := LtBlueOnLtGray;
  end;

  procedure ZoneMap;
  begin
    with Colors^ do begin
    MakeWindow(ZoneWin, 3, 1, 49, 9, True, True, False, WindowAttr,
                  FrameAttr, HeaderAttr, 'Sample Info Window');
    DisplayWindow(ZoneWin);
    FastWriteWindow('1111111111222222222233333333334',
                    1, 14, WindowAttr);
    FastWriteWindow('1234567890123456789012345678901234567890',
                    2, 5, WindowAttr);
    FastWriteWindow('80 ..*...............*............*........', 3, 2, WindowAttr);
    FastWriteWindow('40 ..........*.......*.........*...........', 4, 2, WindowAttr);
    FastWriteWindow('20 ..*.......*..........*..................', 5, 2, HiLiteAttr);
    FastWriteWindow('15 ....*.....*.....................*.......', 6, 2, WindowAttr);
    FastWriteWindow('10 ..***.........***.*.....*.*........***..', 7, 2, WindowAttr);
    MakeWindow(EditWin, 55, 1, 79, 9, True, True, False, WindowAttr,
                  FrameAttr, HeaderAttr, 'Sample Edit Window');
    DisplayWindow(EditWin);
    FastWriteWindow('F1', 2, 2, PromptAttr);
    FastWriteWindow('F2', 3, 2, PromptAttr);
    FastWriteWindow('F3', 4, 2, PromptAttr);
    FastWriteWindow('F4', 5, 2, PromptAttr);
    FastWriteWindow('F5', 6, 2, PromptAttr);
    FastWriteWindow('CQ TEST DE WF1B K', 2, 5, PromptAttr);
    FastWriteWindow('D', 2, 22, CtrlAttr);
    FastWriteWindow('QRZ DE WF1B WF1B K', 3, 5, StringAttr);
    FastWriteWindow('D', 3, 23, CtrlAttr);
    FastWriteWindow('EMPTY', 4, 5, PromptAttr);
    FastWriteWindow('EMPTY', 5, 5, PromptAttr);
    FastWriteWindow('EMPTY', 6, 5, PromptAttr);
    end;
  end;

  procedure ScreenLines;
  begin
    with Colors^ do begin
      FastFill(ScreenWidth*13, ' ', 1, 1, WindowAttr);
      Fastwrite('CQ CQ DE ',11, 1,WindowAttr);
      FastWrite('WF1B'     ,11,10,CatchGoodAttr);
      Fastwrite('WF1B DE'  ,11,16,WindowAttr);
      FastWrite('XX3XX'    ,11,24,CatchDupeAttr);
      Fastwrite('-DUPE'    ,11,30,WindowAttr);
      FastWrite('K6STI RI K6STI RI' ,11,60,RIAttr);
      FastWrite('Exit to DOS (Y/N) ?',13,2,MessageAttr);
    end;
  end;

  procedure UpdateAttributes;
  begin
    with Colors^ do begin
    if (Lo(KW) = $1B) and (Hi(KW) = $01) then Escaped := True;
    if Lo(KW) <> $00 then Exit;
    case Hi(KW) of
{f1}      $3B : if WindowAttr < 127 then Inc(WindowAttr) else WindowAttr := 0;
{f2}      $3C : if FrameAttr < 127 then Inc(FrameAttr) else FrameAttr := 0;
{f3}      $3D : if HeaderAttr < 127 then Inc(HeaderAttr) else HeaderAttr := 0;
{f4}      $3E : if PromptAttr < 127 then Inc(PromptAttr) else PromptAttr := 0;
{f5}      $3F : if StringAttr < 127 then Inc(StringAttr) else StringAttr := 0;
{f6}      $40 : if CtrlAttr < 127 then Inc(CtrlAttr) else CtrlAttr := 0;
{f7}      $41 : if HiLiteAttr < 127 then Inc(HiLiteAttr) else HiLiteAttr := 0;
{f8}      $42 : if CatchGoodAttr < 127 then Inc(CatchGoodAttr) else CatchGoodAttr := 0;
{f9}      $43 : if CatchDupeAttr < 127 then Inc(CatchDupeAttr) else CatchDupeAttr := 0;
{f10}     $44 : if RIAttr < 127 then Inc(RIAttr) else RIAttr := 0;
{f11}     $85 : if MessageAttr < 127 then Inc(MessageAttr) else MessageAttr := 0;
{f12}     $86 : {};

{sf1}     $54 : if WindowAttr > 0 then Dec(WindowAttr) else WindowAttr := 127;
{sf2}     $55 : if FrameAttr > 0 then Dec(FrameAttr) else FrameAttr := 127;
{sf3}     $56 : if HeaderAttr > 0 then Dec(HeaderAttr) else HeaderAttr := 127;
{sf4}     $57 : if PromptAttr > 0 then Dec(PromptAttr) else PromptAttr := 127;
{sf5}     $58 : if StringAttr > 0 then Dec(StringAttr) else StringAttr := 127;
{sf6}     $59 : if CtrlAttr > 0 then Dec(CtrlAttr) else CtrlAttr := 127;
{sf7}     $5A : if HiLiteAttr > 0 then Dec(HiLiteAttr) else HiLiteAttr := 127;
{sf8}     $5B : if CatchGoodAttr > 0 then Dec(CatchGoodAttr) else CatchGoodAttr := 127;
{sf9}     $5C : if CatchDupeAttr > 0 then Dec(CatchDupeAttr) else CatchDupeAttr := 127;
{sf10}    $5D : if RIAttr > 0 then Dec(RIAttr) else RIAttr := 127;
{sf11}    $87 : if MessageAttr > 0 then Dec(MessageAttr) else MessageAttr := 127;
{sf12}    $8A : {};

{alt-s}   $1F : GetOut := True; { save & exit ALT-S }
{alt-a}   $1E : Old_Colors;
{alt-d}   $20 : DefaultColors;
    end;
    end;
  end;

  procedure SetUpScreen;
  begin
    TextAttr := cWindowAttr;
    ClrScr;
    FastFill(ScreenWidth, #205, 1, 1, cFrameAttr);
    FastWrite('Wyvern Technology, Inc.  Color Selection Utility', 1, 15, cWindowAttr);
    FastFill(ScreenWidth, #205, 14, 1, cFrameAttr);
    FastFill(ScreenWidth*10, ' ', 15, 1, cWindowAttr);
    FastWrite('F1-F11       Increase Attribute', 23, 1, cWindowAttr);
    FastWrite('Shift F1-F11 Decrease Attribute', 23, 40, cWindowAttr);
    FastWrite('Alt-S        Save and Exit',      24, 1, cWindowAttr);
    FastWrite('Alt-A        Alternate Colorset', 24, 40, cWindowAttr);
    FastWrite('ESC          Cancel and Exit',    25, 1, cWindowAttr);
    FastWrite('Alt-D        Reset to Default',   25, 40, cWindowAttr);
  end;

  procedure UpdateAttributeNumbers;
  begin
    FastFill(ScreenWidth*7, ' ', 15, 1, cWindowAttr);
    FastWrite('F1  Window'    , 15,  1, cFrameAttr);
    FastWrite('F2  Frame '    , 16,  1, cFrameAttr);
    FastWrite('F3  Header'    , 17,  1, cFrameAttr);
    FastWrite('F4  Prompt'    , 18,  1, cFrameAttr);
    FastWrite('F5  String'    , 19,  1, cFrameAttr);
    FastWrite('F6  Control'   , 20,  1, cFrameAttr);
    FastWrite('F7  HiLite'    , 15, 40, cFrameAttr);
    FastWrite('F8  Good Call' , 16, 40, cFrameAttr);
    FastWrite('F9  Dupe Call' , 17, 40, cFrameAttr);
    FastWrite('F10 K6STI RI'  , 18, 40, cFrameAttr);
    FastWrite('F11 Message'   , 19, 40, cFrameAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.WindowAttr)   , 15, 13, cWindowAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.FrameAttr)    , 16, 13, cWindowAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.HeaderAttr)   , 17, 13, cWindowAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.PromptAttr)   , 18, 13, cWindowAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.StringAttr)   , 19, 13, cWindowAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.CtrlAttr)     , 20, 13, cWindowAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.HiLiteAttr)   , 15, 53, cWindowAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.CatchGoodAttr), 16, 53, cWindowAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.CatchDupeAttr), 17, 53, cWindowAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.RIAttr)       , 18, 53, cWindowAttr);
    FastWrite(Colors^.ColorByteToStr(Colors^.MessageAttr)  , 19, 53, cWindowAttr);
  end;


begin
  InitIni;
  Colors := New(PColors, Init);
  ColorSetScreenColors;
  SetUpScreen;
  UpdateAttributeNumbers;
  CheckBreak := False;
  GetOut := False;
  Escaped := False;
  UpdateAttributeNumbers;
  ScreenLines;
  ZoneMap;
  repeat
    if KeyPressed then begin
      KW := ReadKeyWord;
      UpdateAttributes;
      UpdateAttributeNumbers;
      KillWindow(EditWin);
      KillWindow(ZoneWin);
      ScreenLines;
      ZoneMap;
    end;
  until GetOut or Escaped;
  KillWindow(EditWin);
  KillWindow(ZoneWin);
  Dispose(Colors, Done(NOT Escaped));
  ClrScr;
  NormalCursor;
end.
