{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program Convert;

uses
  TpString,
  TpDate,
  TpPick,
  TpDos,
  TPdir,
  TpCrt,
  TAHigh,
  TAccess,
  Diskio,
  RecTypes,
  cCountry,
  ColorDef;

var
  PrintFile      : Text;
  BinFile, IndexFile, OutFile : String[12];
  HisCall        : string[8];
  HisDx          : Boolean;
  DBase          : DataSet;
  Found          : Boolean;
  Scrap          : Log_Rec;
  PickColors     : PickColorArray;
  Index          : String[8];
  Choice         : Char;
  Junk           : string[9];

  procedure WriteDXBaseRecord;
  var
    T              : String[92];
  begin
    T := Copy(Pad(Scrap.Call, 12), 1, 11); { callsign  1-11}
    T := T+'    ';                { prefix   12-15}
    T := T+'  ';                  { zone     16-17}
    T := T+Copy(BandS[Scrap.Band], 1, 2); { band     18-19}
    T := T+'2';                   { mode     20-20}
    T := T+'N';                   { confirm  21-21}
    T := T+DateToDateString('yymmdd', Scrap.Date); { date 22-27}
    T := T+TimeToTimeString('hhmm', Scrap.Ts); { time    28-31}
    T := T+Long2Str(Scrap.His_RST)+'9'; { rec rst 32-34}
    T := T+Long2Str(Scrap.My_Rst)+'9'; { snd rst 35-37}
    T := T+'N';                   { prtqsl  38-38}
    T := T+Pad(Scrap.Comment, 30); { note    39-68}
    T := T+'               ';
    if (Trim(Scrap.His_Country) = 'W') and (Trim(Scrap.His_Qth) <> '')
    then T := T+Copy(Pad(Scrap.His_Qth, 2), 1, 2)
    else T := T+'  ';
    T := Pad(T, 92);              { to end  ---92}
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;

  procedure WriteDXBaseRecord4;
  var
    T              : String[127];
  begin
    T := Copy(Pad(Scrap.Call, 12), 1, 11); { callsign  1-11}
    T := T+'    ';                { prefix   12-15}
    T := T+'  ';                  { zone     16-17}
    T := T+Copy(BandS[Scrap.Band], 1, 2); { band     18-19}
    T := T+'2';                   { mode     20-20}
    T := T+'N';                   { confirm  21-21}
    T := T+DateToDateString('yymmdd', Scrap.Date); { date 22-27}
    T := T+TimeToTimeString('hhmm', Scrap.Ts); { time    28-31}
    T := T+Long2Str(Scrap.His_RST)+'9'; { rec rst 32-34}
    T := T+Long2Str(Scrap.My_Rst)+'9'; { snd rst 35-37}
    T := T+'N';                   { prtqsl  38-38}
    T := T+Pad(Scrap.Comment, 30); { note    39-68}
    T := T+'              ';
    if (Trim(Scrap.His_Country) = 'W') and (Trim(Scrap.His_Qth) <> '')
    then T := T+Copy(Pad(Scrap.His_Qth, 2), 1, 2)
    else T := T+'  ';
    T := Pad(T, 127);              { to end  ---92}
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;

  {************************ Write quite delimited file *****************}
  {*  'WF1B','0100','92/08/12', ... etc etc *}
  procedure WriteDelimitedRecord;
  var
    S              : String[11];
    Q              : Char;
    Q2             : String[2];
    T              : String[200];
  begin
    Q := Chr(39);
    Q2 := Chr(39)+',';
    T := Q+BandS[Scrap.Band]+Q2;
    T := T+Q+DateToDateString('yymmdd', Scrap.Date)+Q2;
    T := T+Q+TimeToTimeString('hhmm', Scrap.Ts)+Q2;
    T := T+Q+Trim(Scrap.Call)+Q2;
    T := T+Q+Long2Str(Scrap.My_Rst)+Q2;
    T := T+Q+Trim(Scrap.My_Qth)+Q2;
    T := T+Q+LeftPadCh(Long2Str(Scrap.My_Zone), '0', 2)+Q2;
    T := T+Q+LeftPadCh(Long2Str(Scrap.My_Serno), '0', 4)+Q2;
    T := T+Q+TimeToTimeString('hhmm', Scrap.My_Time)+Q2;
    T := T+Q+Long2Str(Scrap.His_RST)+Q2;
    T := T+Q+Trim(Scrap.His_Qth)+Q2;
    T := T+Q+LeftPadCh(Long2Str(Scrap.His_Zone), '0', 2)+Q2;
    T := T+Q+LeftPadCh(Long2Str(Scrap.His_Serno), '0', 4)+Q2;
    T := T+Q+TimeToTimeString('hhmm', Scrap.His_Time)+Q2;
    T := T+Q+Trim(Scrap.His_Country)+Q2;
    if Scrap.New_Zone then T := T+Q+'*'+Q2
    else T := T+Q+' '+Q2;
    if Scrap.New_Country then T := T+Q+'*'+Q2
    else T := T+Q+' '+Q2;
    if Scrap.New_Qth then T := T+Q+'*'+Q2
    else T := T+Q+' '+Q2;
    if Scrap.New_Continent then T := T+Q+'*'+Q2
    else T := T+Q+' '+Q2;
    T := T+Q+Long2Str(Scrap.Point)+Q2;
    T := T+Q+Trim(Scrap.Comment)+Q;
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;

  procedure WriteDelimitedRecord2;
  var
    S              : String[11];
    Q2             : String[1];
    T              : String[200];
  begin
    Q2 := ',';
    T := BandS[Scrap.Band]+Q2;
    T := T+DateToDateString('yymmdd', Scrap.Date)+Q2;
    T := T+TimeToTimeString('hhmm', Scrap.Ts)+Q2;
    T := T+Trim(Scrap.Call)+Q2;
    T := T+Long2Str(Scrap.My_Rst)+Q2;
    T := T+Trim(Scrap.My_Qth)+Q2;
    T := T+LeftPadCh(Long2Str(Scrap.My_Zone), '0', 2)+Q2;
    T := T+LeftPadCh(Long2Str(Scrap.My_Serno), '0', 4)+Q2;
    T := T+TimeToTimeString('hhmm', Scrap.My_Time)+Q2;
    T := T+Long2Str(Scrap.His_RST)+Q2;
    T := T+Trim(Scrap.His_Qth)+Q2;
    T := T+LeftPadCh(Long2Str(Scrap.His_Zone), '0', 2)+Q2;
    T := T+LeftPadCh(Long2Str(Scrap.His_Serno), '0', 4)+Q2;
    T := T+TimeToTimeString('hhmm', Scrap.His_Time)+Q2;
    T := T+Trim(Scrap.His_Country)+Q2;
    if Scrap.New_Zone then T := T+'*'+Q2
    else T := T+' '+Q2;
    if Scrap.New_Country then T := T+'*'+Q2
    else T := T+' '+Q2;
    if Scrap.New_Qth then T := T+'*'+Q2
    else T := T+' '+Q2;
    if Scrap.New_Continent then T := T+'*'+Q2
    else T := T+' '+Q2;
    T := T+Long2Str(Scrap.Point)+Q2;
    T := T+'''+Trim(Scrap.Comment)+''';
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;




  {************************ Write logbook format file *****************}

  procedure WriteWF1BRecord;
  var
    S              : String[11];
    T              : String[200];
  begin
    T := DateToDateString('mm/dd/yy', Scrap.Date)+' ';
    T := T+BandS[Scrap.Band]+' ';
    T := T+Modes[Scrap.Mode]+' ';
    T := T+TimeToTimeString('hh:mmZ', Scrap.Ts)+' ';
    T := T+Pad(Scrap.Call, 12)+' ';
    T := T+Long2Str(Scrap.My_Rst)+'9 ';
    T := T+Long2Str(Scrap.His_RST)+'9'+' ';
    T := T+Pad(Scrap.His_Qth, 3)+' ';
    T := T+LeftPadCh(Long2Str(Scrap.His_Zone), '0', 2)+' ';
    T := T+Pad(Trim(Scrap.His_Country), 5)+' ';
    T := T+Trim(Scrap.Comment);
    if Scrap.New_Zone and Scrap.New_Country then T := T+' New Zone & Country'
    else if Scrap.New_Country then T := T+' New Country'
    else if Scrap.New_Zone then T := T+' New Zone';
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;


  procedure WriteN1SWRecord;
  var
    T              : String[132];
  begin
    T := BandS[Scrap.Band]+' ';
    T := T+DateToDateString('yymmdd', Scrap.Date)+' ';
    T := T+TimeToTimeString('hhmm', Scrap.Ts)+' ';
    T := T+Pad(Scrap.Call, 12)+' ';
    T := T+Long2Str(Scrap.My_Rst)+'9 ';
    T := T+LeftPadCh(Long2Str(Scrap.My_Serno), '0', 4)+' ';
    T := T+TimeToTimeString('hhmm', Scrap.My_Time)+' ';
    T := T+Long2Str(Scrap.His_RST)+'9'+' ';
    T := T+Pad(Scrap.His_Qth, 3)+' ';
    T := T+LeftPadCh(Long2Str(Scrap.His_Zone), '0', 2)+' ';
    T := T+LeftPadCh(Long2Str(Scrap.His_Serno), '0', 4)+' ';
    T := T+TimeToTimeString('hhmm', Scrap.His_Time)+' ';
    T := T+Pad(Trim(Scrap.His_Country), 5)+' ';
    if Scrap.New_Zone then T := T+'* '
    else T := T+'  ';
    if Scrap.New_Country then T := T+'* '
    else T := T+'  ';
    if Scrap.New_Qth then T := T+'* '
    else T := T+'  ';
    if Scrap.New_Continent then T := T+'* '
    else T := T+'  ';
    T := T+LeftPadCh(Long2Str(Scrap.Point), '0', 2)+' ';
    T := T+Trim(Scrap.Comment);
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;

  {************************ Write k1ea format file *****************}

  procedure WriteK1EARecord;
  var
    S              : String[11];
    T              : String[132];
  begin
    T := DateToDateString('mm/dd/yy ', Scrap.Date);
    T := T+TimeToTimeString('hhmm', Scrap.Ts);
    T := T+LeftPad(Long2Str(Scrap.My_Serno), 5);
    T := T+'  '+BandS[Scrap.Band]+' RTTY ';
    T := T+Pad(Scrap.Call, 15);
    T := T+Long2Str(Scrap.My_Rst)+'  ';
    T := T+LeftPadCh(Long2Str(Scrap.His_Zone), '0', 2)+'          ';
    T := T+'0        0 00    0 ';
    T := T+Long2Str(Scrap.Point);
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;

  {************************ Write k1ea v9 format file *****************}
{...+....1....+....2....+....3....+....4....+....5....+....6....+....7....+....8....+
20-Mar-00 2243    1  20 RTTY G0AZT         599  14   14000000 14000000 00    0 49 0 0
20-Mar-00 2243    2  20 RTTY AL7BB         599  01   14000000 14000000 00    0 49 0 0
20-Mar-00 2244    3  20 RTTY WF1B          599  05   14000000 14000000 00    0 49 0 0
20-Mar-00 2244    4  20 RTTY PY0FF         599  11   14000000 14000000 00    0 49 0 0
20-Mar-00 2246    5  80 RTTY W4AAA         599  05    3500000 14000000 00    0 49 0 0
20-Mar-00 2246    6  40 RTTY W5TRE         599  04    7000000 14000000 00    0 49 0 0
20-Mar-00 2246    7  15 RTTY W3LPL         599  05   21000000 14000000 00    0 49 0 0
20-Mar-00 2246    8  10 RTTY W1WWW         599  05   28000000 14000000 00    0 49 0 0
20-Mar-00 2249    9  20 RTTY TY1PS         599  35   14000000 14000000 00    0 49 0 0
20-Mar-00 2249   10  20 RTTY DL4ARR        599  14   14000000 14000000 00    0 49 0 0
20-Mar-00 2249   11  20 RTTY DL1AAA        599  14   14000000 14000000 00    0 49 0 0
}
  procedure WriteK1EAv9Record;
  const
    Mon : array[1..12] of string[3] = ('Jan','Feb','Mar','Apr','May','Jun',
                                       'Jul','Aug','Sep','Oct','Nov','Dec');
  var
    S              : String[11];
    T              : String[132];
    Mo,Da,Yr       : Integer;
  begin
    DateToDMY(Scrap.Date, Da, Mo, Yr);
    T := DateToDateString('dd-', Scrap.Date);
    T := T+Mon[Mo];
    T := T+DateToDateString('-yy ', Scrap.Date);
    T := T+TimeToTimeString('hhmm', Scrap.Ts);
    T := T+LeftPad(Long2Str(Scrap.My_Serno), 5);
    T := T+'  '+BandS[Scrap.Band]+' RTTY ';
    T := T+Pad(Scrap.Call, 14);
    T := T+Long2Str(Scrap.My_Rst)+'9  ';
    T := T+LeftPadCh(Long2Str(Scrap.His_Zone), '0', 2);
    T := T + '   ';
    case Scrap.Band of
      B80 : t := t + ' 3500000  3500000';
      B40 : t := t + ' 7000000  7000000';
      B20 : t := t + '14000000 14000000 ';
      B15 : t := t + '21000000 21000000 ';
      B10 : t := t + '28000000 28000000 ';
    else
      t := t + '14000000 14000000 ';
    end;
    T := T + '00    0 49 0 0';
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;


  procedure WriteCallRecord;
  var
    T              : String[12];
  begin
    T := Trim(Scrap.Call);
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;
  {************************ Write logbook format file *****************}

  procedure WriteARRLRecord;
  var
    S              : String[11];
    T              : String[200];
  begin
{ File format for the ARRL disk submission...}
{10  CW  11/12/93 1954 14    WE9A           599 CA    599 IL      4  0
 10  CW  11/12/93 1955 15    KS9O           599 CA    599 IL      4  0
 10  CW  11/12/93 2002 16    NA1R           599 CA    599 IL      4  0
 10  SSB 12/12/93 2003 17    AA5MH          59  CA    59  MS    * 2  0
 10  SSB 12/12/93 2005 18    WA1HFN         59  CA    59  CA    * 2  0 }

    T := BandS[scrap.Band]+' RTTY ';
    T := T+DateToDateString('mm/dd/yy ', scrap.Date);
    T := T + '     '; {place for time on- time off indicated}
    T := T+TimeToTimeString('hhmm ', scrap.Ts);
    T := T+Pad(scrap.Call, 12)+' ';

    T := T+Long2Str(scrap.My_Rst)+'9 ';
    if HisDX then
      T := T+Pad(Long2Str(scrap.My_Serno), 4)+' '
    else
      T := T+Pad(scrap.my_qth,5);

    T := T+Long2Str(scrap.His_RST)+'9'+' ';
    if Scrap.His_Serno > 0 then
      T := T+Pad(Long2Str(scrap.His_Serno), 4)+' '
    else
      T := T+Pad(scrap.his_qth,5);

    if (scrap.New_Country) or (scrap.New_Qth) then T := T+'*'
                     else T := T+' ';
    T := T+' '+Long2Str(scrap.Point);
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;

  procedure WriteSummaryRecord;
  var
    S              : String[11];
    T              : String[200];
    cn             : word;
  begin
    cn := CountryList^.Identify(Scrap);

    T := BandS[scrap.Band];
    T := T+DateToDateString(' dd ', scrap.Date);
    T := T+TimeToTimeString('hh ', scrap.Ts);
    T := T+Pad(CountryList^.Ct.Code,7);
    T := T+Pad(CountryList^.Ct.Continent,3);
    T := T+Pad(Scrap.Call,13);
    T := T+Pad(long2str(Scrap.His_Zone),3);
    t := t+pad(scrap.his_qth,4);
    T := T+pad(Long2Str(scrap.Point),3);
    {$I-}
    WriteLn(PrintFile, T);
    {$I+}
  end;

  function Get_Bin_File : String;
  var
    Result         : Integer;
    BinFile        : String[12];
  begin
    TPdir.ShowSizeDateTime := True;
    Result := GetFileName('*.BIN', 0, 1, 13, 20, 1, PickColors, BinFile);
    if ((Result = 0) and (BinFile = '')) or ((Result > 0)) then BinFile := '';
    Get_Bin_File := BinFile;
  end;

  function MenuSelect : Char;
  begin
    ClrScr;
    WriteLn('RTTY by WF1B, Wyvern Technology Inc.');
    WriteLn('------------------------------------');
    WriteLn;
    WriteLn('Utility to convert to .BIN to various formats');
    WriteLn;
    WriteLn('1.  DX-Base by Scientific Solutions, Inc. v3');
    WriteLn('2.  DX-Trak by Earnie Piche, N1SW');
    WriteLn('3.  Callsign only.');
    WriteLn('4.  xBase - for database programs');
    WriteLn('5.  K1EA v8 .RES');
    WriteLn('6.  Logbook format');
    WriteLn('7.  ARRL Disk File submission log format');
    WriteLn('8.  DX-Base by Scientific Solutions, Inc. v4');
    WriteLn('9.  K1EA v9 .RES');
    WriteLn('A.  Summarized data');
    Writeln('B.  Comma Seperated Values');
    WriteLn;
    WriteLn(' Please consider using ADIFCONV for data conversion');
    WriteLn;
    WriteLn('Q.  Quit');
    MenuSelect := Chr(Lo(ReadKeyWord));
  end;

begin
  PickColors[TpPick.WindowAttr] := LtGrayOnBlack;
  PickColors[TpPick.FrameAttr] := LtGrayOnBlack;
  PickColors[TpPick.HeaderAttr] := BlackOnLtGray;
  PickColors[TpPick.SelectAttr] := BlackOnLtGray;
  PickColors[TpPick.AltNormal] := LtGrayOnBlack;
  PickColors[TpPick.AltHigh] := LtGrayOnBlack;
  SetVerticalPick;
  ReturnCompletePath := False;
  MakeCountryList('CQWW.CTY','CQWW.PFX');
  Choice := MenuSelect;
  while not(Choice in ['Q', 'q']) do begin
    BinFile := Get_Bin_File;
    if BinFile <> '' then begin
      case Choice of
        '1' : OutFile := Copy(BinFile, 1, Pos('.', BinFile))+'SDF';
        '2' : OutFile := Copy(BinFile, 1, Pos('.', BinFile))+'FIX';
        '3' : OutFile := Copy(BinFile, 1, Pos('.', BinFile))+'CAL';
        '4' : OutFile := Copy(BinFile, 1, Pos('.', BinFile))+'TXT';
        '5' : OutFile := Copy(BinFile, 1, Pos('.', BinFile))+'RES';
        '6' : OutFile := Copy(BinFile, 1, Pos('.', BinFile))+'TXT';
        '7' : begin
                write('Your callsign? ');
                readln(hiscall);
                HisCall := Trim(HisCall);
                if (HisCall = ''  ) or
                   (Pos('.',HisCall) > 0) or
                   (Pos(' ',HisCall) > 0) or
                   (Pos('/',HisCall) > 0)
                   then begin
                     Writeln('Enter just your callsign: No slashes, periods, etc');
                     halt;
                     end;
                OutFile := HisCall+'.LOG';
                write('Are you DX station(Y/N)? ');
                readln(HisCall);
                HisDX := HisCall[1] in ['y','Y'];
              end;
        '8' : OutFile := Copy(BinFile, 1, Pos('.', BinFile))+'SDF';
        '9' : OutFile := Copy(BinFile, 1, Pos('.', BinFile))+'RES';
        'A','a' : OutFile := Copy(BinFile, 1, Pos('.', BinFile))+'STR';
        'B','b' : OutFile := Copy(BinFile, 1, Pos('.', BinFile))+'CSV';
      end;
      WriteLn('Creating...'+OutFile);
      IndexFile := Copy(BinFile, 1, Pos('.', BinFile))+'NDX';
      TAOpen(DBase, BinFile, SizeOf(Log_Rec), IndexFile, SizeOf(Index)-1);
      TAReset(DBase);
      Assign(PrintFile, OutFile);
      {$I-} Rewrite(PrintFile); {$I+}
      TANext(DBase, Scrap, Index);
      while OK do begin
        case Choice of
          '1' : if Scrap.ToolBoxNumber = 0 then WriteDXBaseRecord;
          '2' : if Scrap.ToolBoxNumber = 0 then WriteN1SWRecord;
          '3' : if Scrap.ToolBoxNumber = 0 then WriteCallRecord;
          '4' : if Scrap.ToolBoxNumber = 0 then WriteDelimitedRecord;
          '5' : if Scrap.ToolBoxNumber = 0 then WriteK1EARecord;
          '6' : if Scrap.ToolBoxNumber = 0 then WriteWF1BRecord;
          '7' : if Scrap.ToolBoxNumber = 0 then WriteARRLRecord;
          '8' : if Scrap.ToolBoxNumber = 0 then WriteDXBaseRecord4;
          '9' : if Scrap.ToolBoxNumber = 0 then WriteK1EAv9Record;
          'A','a' : if Scrap.ToolBoxNumber = 0 then WriteSummaryRecord;
          'B','b' : if Scrap.ToolBoxNumber = 0 then WriteDelimitedRecord2;
        end;
        TANext(DBase, Scrap, Index);
      end;
      Close(PrintFile);
      TAClose(DBase);
      WriteLn('Conversion complete.');
    end
    else
      WriteLn('Conversion cancelled');
    Choice := MenuSelect;
  end;
  KillCountryList;
end.


