{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$F+,O+}
unit cProvince;
interface

  {* FUNCTIONS AVAILABLE FROM THIS UNIT *}

uses
  TpRarray,
  Rectypes;


type

  PProvList = ^TProvList;
  TProvList = object
                 private
                   Num_Provs : word;
                   Tbl    : array[1..13] of Mult_Rec;
                   Wh_Test : string[4];
                 public
                   constructor Init(const which : string);
                   Destructor  Done;
                   function    GetProv(const Pv : Byte; const Band : BandType) : boolean;
                   function    GetprovByName(const Pv : String; const Band : BandType) : boolean;
                   procedure   Setprov(const Pv : Byte; const Band : BandType);
                   procedure   SetprovByName(const Pv : String; const Band : BandType);
                   procedure   ReSetprov(const Pv : Byte; const Band : BandType);
                   function    HowMany(const Band : BandType) : longint;
                   function    BandString(const Pv : Byte) : string;
                   function    GetProvNo(const Pv : String) : Byte;
                   function    GetZoneByName(const Pv : String) : Byte;
                   function    GetZoneByCall(const Call : String) : Byte;
                   function    Name(const Pv : Byte) : string;
                   function    NumProvs : word;
                   function    AdjustQth(const S : string) : string;
                   function    Load(const Qth : string; const Band : BandType) : Boolean;
                   function    GetProvByCall(const Call : String) : string;
                 end;

  {* NOW DEFINE THE FUNCTIONS *}

var
  ProvList : PProvList;

procedure MakeProvList(const ContestID : string);
procedure KillProvList;

implementation

uses
  DebugRtns,
  TpString,
  TpCrt,
  TpMouse,
  TpSort,
  TpWindow,
  Keys,
  cEditWin,
  c_Contest,
  cDist_ve,
  cDist_w,
  Routines,
  OneTimers;

  const

  Names : array[1..13] of String[3] = (
  '   ','   ','   ','   ','   ','   ','   ','   ','   ','   ','   ','   ','   ');

  CQZones  : array[1..13] of Byte = (
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);


  function TProvList.AdjustQth(const S : string) : string;

  function AdjustCqww(const S : string) : string;
  begin
{    if S = 'PEI' then AdjustCqww := 'PE'
      else
    if S = 'QC' then AdjustCqww := 'VE2'
      else
    if S = 'ON' then AdjustCqww := 'VE3'
      else
    if S = 'MB' then AdjustCqww := 'VE4'
      else
    if S = 'SK' then AdjustCqww := 'VE5'
      else
    if S = 'SAS' then AdjustCqww := 'VE5'
      else
    if S = 'AB' then AdjustCqww := 'VE6'
      else
    if S = 'ALB' then AdjustCqww := 'VE6'
      else
    if S = 'BC' then AdjustCqww := 'VE7'
      else
    if S = 'NWT' then AdjustCqww := 'VE8'
      else
    if S = 'NT' then AdjustCqww := 'VE8'
      else
    if S = 'YT' then AdjustCqww := 'VY1'
      else
    if S = 'YUK' then AdjustCqww := 'VY1'
      else }
        AdjustCqww := S;
  end;

  function AdjustOthers(const S : string) : string;
  begin
      if S = 'NFL' then AdjustOthers := 'NF'
      else
        if S = 'VO1' then AdjustOthers := 'NF'
      else
        if S = 'VO2' then AdjustOthers := 'NF'
      else
        if S = 'LAB' then AdjustOthers := 'NF'
      else
        if S = 'VE2' then AdjustOthers := 'QC'
      else
        if S = 'VE3' then AdjustOthers := 'ON'
      else
        if S = 'VE4' then AdjustOthers := 'MB'
      else
        if S = 'VE5' then AdjustOthers := 'SK'
      else
        if S = 'VE6' then AdjustOthers := 'AB'
      else
        if S = 'VE7' then AdjustOthers := 'BC'
      else
        if S = 'VE8' then AdjustOthers := 'NT'
      else
        if S = 'VE9' then AdjustOthers := 'NB'
      else
        if S = 'VY1' then AdjustOthers := 'YT'
      else
        if S = 'VY2' then AdjustOthers := 'PE'
      else
        AdjustOthers := S;
  end;

  begin
    if Wh_Test = 'CQWW' then
      AdjustQth := AdjustCqww(S)
    else
      AdjustQth := AdjustOthers(S);
  end;


  constructor TProvList.Init(const which : string);
  var
    I : Integer;
    Mult : Mult_Rec;
    Band : BandType;

    procedure InitCqww;
    const
      C_Provs : array[1..13] of String[3] = (
              'VO1', 'NB' , 'NS' , 'PE',  'VE2',
              'VE3', 'VE4', 'VE5', 'VE6', 'VE7',
              'VE8', 'VY1', 'VY0');
      C_CQZones : array[1..13] of Byte = (
              5, 5, 5, 5, 5,
              4, 4, 4, 4, 3,
              3, 1, 2);
    var
      i : byte;
    begin
      Num_Provs := 13;
      for i := 1 to Num_Provs do begin
        names[i] := C_Provs[i];
        CqZones[i] := C_CQZones[i];
      end;
    end;

    procedure InitOthers;
    const
      Provs : array[1..13] of String[3] = (
            'NF', 'NB', 'NS', 'QC', 'ON',
            'MB', 'SK', 'AB', 'BC', 'NT',
            'YT', 'PE', 'NU');
      CQ_Zones   : array[1..13] of Byte = (
        5, 5, 5, 5, 5,
        4, 4, 4, 4, 3,
        1, 1, 2);
    var
      i : byte;
    begin
      Num_Provs := 13;
      for i := 1 to Num_Provs do begin
        names[i] := Provs[i];
        CqZones[i] := CQ_Zones[i];
      end;
    end;

  begin
    for Band := B80 to TOT do
      Mult.Band[Band] := False;
    for I := 1 to 13 do
      Tbl[I] := Mult;
    wh_Test := stUpCase(Which);
    if Wh_Test = 'CQWW' then
      InitCqww
    else
      InitOthers;
    {$IFDEF DEBUG}
    AppendDebugMessage('ProvList created');
    {$ENDIF}
  end;

  Destructor  TProvList.Done;
  begin
    {$IFDEF DEBUG}
    AppendDebugMessage('ProvList destroyed');
    {$ENDIF}
  end;

  function    TProvList.NumProvs : word;
  begin
    NumProvs := num_Provs;
  end;

  function    TProvList.GetProv(const Pv : Byte; const Band : BandType) : boolean;
  begin
    {$IFDEF DEBUG}
    if (Pv = 0) or (Pv > Num_Provs) then
      AppendDebugMessage('CProvList.GetProv, invalid Prov# :'+long2str(Pv));
    {$ENDIF}
    if (Pv = 0) or (Pv > Num_Provs) then begin
      GetProv := False;
      Exit;
    end;
    GetProv := Tbl[Pv].Band[Band]
  end;

  function    TProvList.GetProvByName(const Pv : string; const Band : BandType) : boolean;
  begin
    GetProvByName := GetProv(GetProvNo(Pv),Band);
  end;

  procedure   TProvList.SetProv(const Pv : Byte; const Band : BandType);
  begin
    {$IFDEF DEBUG}
    if (Pv = 0) or (Pv > Num_Provs) then
      AppendDebugMessage('CProvList.SetState, invalid Prov# :'+long2str(Pv));
    {$ENDIF}
    if (Pv = 0) or (Pv > Num_Provs) then Exit;
    Tbl[Pv].Band[Band] := True;
    Tbl[Pv].Band[TOT]  := True;
  end;

  procedure   TProvList.SetProvByName(const Pv : String; const Band : BandType);
  begin
    SetProv(GetProvNo(Pv),Band);
  end;

  procedure   TProvList.ReSetProv(const Pv : Byte; const Band : BandType);
  var
    b : bandType;
  begin
    {$IFDEF DEBUG}
    if (Pv = 0) or (Pv > Num_Provs) then
      AppendDebugMessage('CProvList.ReSetProv, invalid Prov# :'+long2str(Pv));
    {$ENDIF}
    if (Pv = 0) or (Pv > Num_Provs) then Exit;
    Tbl[Pv].Band[Band] := False;
    Tbl[Pv].Band[TOT] := False;
    for B := B80 to B10 do begin
      if GetProv(Pv,B) then
        Tbl[Pv].Band[TOT]  := True;
    end;
  end;

  function    TProvList.HowMany(const Band : BandType) : longint;
  var
    L       : longint;
    Pv      : Word;
  begin
    L := 0;
    for Pv := 1 to Num_Provs do
      if GetProv(Pv,Band) then Inc(L);
    HowMany := L;
    {$IFDEF DEBUG}
    AppendDebugMessage('TProvList.HowMany = '+Bands[Band]+'M '+long2str(l));
    {$ENDIF}
  end;

  function  TProvList.BandString(const Pv : Byte) : string;
  var
    s : string[5];
    Band : BandType;
  begin
    S := '.....';
    for Band := B80 to B10 do
      if GetProv(Pv,Band) then S[Ord(Band)+1] := '*';
    BandString := S;
  end;

  function TProvList.GetProvNo(const Pv : String) : Byte;
  var
    P : String[3];
    ix : Byte;
  begin
    P := Trim(Pv);
    for ix := 1 to Num_Provs do
      if P = Trim(Names[ix]) then begin
        GetProvNo := ix;
        Exit;
      end;
    GetProvNo := 0;
  end;

  function    TProvList.GetZoneByName(const Pv : String) : Byte;
  var
    ix : byte;
  begin
    ix := GetProvNo(Pv);
    if ix > 0 then GetZoneByName := CqZones[Ix]
              else GetZoneByName := 0;
  end;

  function    TProvList.GetZoneByCall(const Call : String) : Byte;
  var
    Zone : byte;
    Dist : byte;
  begin
    Zone := 0;
    if Copy(Call, 1, 3) = 'VO2' then Zone := 2;
    if Copy(Call, 1, 3) = 'VO1' then Zone := 5;
    if Copy(Call, 1, 3) = 'VY1' then Zone := 1;
    if Copy(Call, 1, 3) = 'VE8' then Zone := 1;
    if Copy(Call, 1, 3) = 'VE9' then Zone := 5;
    if Copy(Call, 1, 3) = 'VE1' then Zone := 5;
    if Zone = 0 then begin { if none above, go by the district }
      Dist := 0;
      if Assigned(VeDistList) then Dist := VEDistList^.GetDistNo(Call)
      else if Assigned(WDistList)  then Dist := WDistList^.GetDistNo(Call);
      case Dist of
        1 : Zone := 5;
        2 : Zone := 5;
        3 : Zone := 4;
        4 : Zone := 4;
        5 : Zone := 4;
        6 : Zone := 4;
        7 : Zone := 3;
        8 : Zone := 2;
        9 : Zone := 5;
      end;
    end;
    GetZoneByCall := Zone;
  end;

  function    TProvList.GetProvByCall(const Call : String) : string;
  var
    f3 : string[3];
    Temp_qth : string[3];
    Dist : byte;
  begin
    if Wh_Test = 'CQWW' then begin
      Temp_Qth := '';
      F3 := Copy(Call, 1, 3);
      if F3 = 'VO1' then Temp_Qth := 'VO1' else
      if F3 = 'VO2' then Temp_Qth := 'VO2' else
      if F3 = 'VY2' then Temp_Qth := 'PE' else
      if F3 = 'VE2' then Temp_Qth := 'VE2' else
      if F3 = 'VE3' then Temp_Qth := 'VE3' else
      if F3 = 'VE4' then Temp_Qth := 'VE4' else
      if F3 = 'VE5' then Temp_Qth := 'VE5' else
      if F3 = 'VE6' then Temp_Qth := 'VE6' else
      if F3 = 'VE7' then Temp_Qth := 'VE7' else
      if F3 = 'VE8' then Temp_Qth := 'VE8' else
      if F3 = 'VE9' then Temp_Qth := 'NB' else
      if F3 = 'VY1' then Temp_Qth := 'VY1' else
      if Temp_Qth = '' then begin { if none above, go by the district }
        Dist := 0;
        if Assigned(VeDistList) then Dist := VEDistList^.GetDistNo(Call)
        else if Assigned(WDistList)  then Dist := WDistList^.GetDistNo(Call);
        case Dist of
          1 : Temp_Qth := ''; { can't tell easily }
          2 : Temp_Qth := 'VE2'; { mni more qc than pe, so default to qc }
          3 : Temp_Qth := 'VE3';
          4 : Temp_Qth := 'VE4';
          5 : Temp_Qth := 'VE5';
          6 : Temp_Qth := 'VE6';
          7 : Temp_Qth := 'VE7';
          8 : Temp_Qth := 'VE8';
          9 : Temp_Qth := ''; { can't tell easily }
        end;
      end;
      GetProvByCall := Temp_Qth;
    end
    else begin
      Temp_Qth := '';
      F3 := Copy(Call, 1, 3);
      if F3 = 'VE9' then Temp_Qth := 'NB' else
      if F3 = 'VE8' then Temp_Qth := 'NT' else
      if F3 = 'VY1' then Temp_Qth := 'YT' else
      if F3 = 'VY2' then Temp_Qth := 'PE' else
      if F3 = 'VE7' then Temp_Qth := 'BC' else
      if F3 = 'VE6' then Temp_Qth := 'AB' else
      if F3 = 'VE5' then Temp_Qth := 'SK' else
      if F3 = 'VE4' then Temp_Qth := 'MB' else
      if F3 = 'VE3' then Temp_Qth := 'ON' else
      if F3 = 'VE2' then Temp_Qth := 'QC' else
      if F3 = 'VE1' then Temp_Qth := 'NS' else
      if F3 = 'VO2' then Temp_Qth := 'NF' else
      if F3 = 'VO1' then Temp_Qth := 'NF';
      if Temp_Qth = '' then begin { if none above, go by the district }
        Dist := 0;
        if Assigned(VeDistList) then Dist := VEDistList^.GetDistNo(Call)
        else if Assigned(WDistList)  then Dist := WDistList^.GetDistNo(Call);
        case Dist of
          1 : Temp_Qth := ''; { can't tell easily }
          2 : Temp_Qth := 'QC'; { mni more qc than pe, so default to qc }
          3 : Temp_Qth := 'ON';
          4 : Temp_Qth := 'MB';
          5 : Temp_Qth := 'SK';
          6 : Temp_Qth := 'AB';
          7 : Temp_Qth := 'BC';
          8 : Temp_Qth := 'NT';
          9 : Temp_Qth := ''; { can't tell easily }
        end;
      end;
      GetProvByCall := Temp_Qth;
    end;
  end;


  function    TProvList.Name(const Pv : Byte) : string;
  begin
    if Pv > 0 then Name := Names[Pv]
              else Name := '';
  end;

  function TProvList.Load(const Qth : string; const Band : BandType) : Boolean;
  var
    T  : Boolean;
    ix : Byte;
  begin
    T := False;
    ix := GetProvNo(Qth);
    if ix > 0 then T := not GetProv(ix,Band);
    SetProv(ix,Band);
    SetProv(ix,TOT);
    Load := T;
  end;






  procedure MakeProvList(const ContestID : string);
  begin
    ProvList := New(PProvList, Init(ContestId));
    if not assigned(ProvList) then begin
      MessageBox('Severe Error!',
                 'Unable to create VE Province list',
                 'Contact Wyvern Technology',
                 'Consider reinstalling from diskette');
      CloseDownScreen;
      Halt;
    end;
    {$IFDEF DEBUG}
    AppendDebugMessage('ProvList created');
    {$ENDIF}
  end;

  procedure KillProvList;
  begin
    if Assigned(ProvList) then begin
      Dispose(ProvList, Done);
      ProvList := NIL;
      {$IFDEF DEBUG}
      AppendDebugMessage('ProvList destroyed');
      {$ENDIF}
    end;
  end;



end.
