{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
unit cScoreWin;

interface

uses
  TpWindow;

type

PScoreWin = ^TScoreWin;
TScoreWin = object
             Win : WindowPtr;
             xlow,
             ylow,
             xhigh,
             yhigh : Byte; { tpcrt standard }
             constructor Init;
             destructor  Done; virtual;
             procedure   Update; virtual;
             procedure   CheckForMessage(SomeScore : Longint);
           end;

var
  ScoreWin : PScoreWin;

implementation

uses
  IniFile,
  DebugRtns,
  RecTypes,
  c_Contest,
  cMsgWin,
  cColors,
  TpString,
  TpMouse,
  TpCrt;


constructor TScoreWin.Init;
const
  NoFrame = False;
  ClearWindow = True;
  SaveWindow = True;
begin
  xlow  := MW_xhi+1; { just to right of main window }
  ylow  := MW_Yhi-3;
  xhigh := ScreenWidth;
  yhigh := MW_Yhi-3;
  with Colors^ do
  if not MakeWindow(Win, xlow, ylow, xhigh, yhigh,
      NoFrame, ClearWindow, SaveWindow,
      WindowAttr, FrameAttr, HeaderAttr, '') then
    AppendDebugMessage('TScoreWin.Init, MakeWindow(Win) failed');
  DisplayWindow(Win);
  {$IFDEF DEBUG}
  AppendDebugMessage('ScoreWin created');
  {$ENDIF}
end;

destructor  TScoreWin.Done;
begin
  KillWindow(Win);
  {$IFDEF DEBUG}
  AppendDebugMessage('ScoreWin destroyed');
  {$ENDIF}
end;

procedure   TScoreWin.Update;
begin
  ThisContest^.Rescore;
  HideMouse;
  FastWriteStack(Win,LeftPad(long2str(ThisContest^.Score),12), 1, 1, Colors^.WindowAttr);
  ShowMouse;
  CheckForMessage(ThisContest^.Score);
end;

Procedure TScoreWin.CheckForMessage(SomeScore : longint);
var
  MessageNum : integer;
  Tag        : string[9];
begin
  For MessageNum := 1 to 10 do begin
    Tag := RttyIni^.GetProfileString('M'+long2str(MessageNum),'SCORE MESSAGES','');
    if Tag <> '' then begin
      if not RttyIni^.GetProfileBool('USED',Tag,True) then begin {wasnt sent yet}
        if RttyIni^.GetProfileLong('Score',Tag,99999999) < ThisContest^.Score then begin {we have a message!}
          MsgWin^.Display(RttyIni^.GetProfileString('MSG',Tag,'Great job!'));
          RttyIni^.SetOrAddProfileString('Used',Tag,'Yes');
        end; {of sending a message}
      end;
    end; {M# not blank }
  end; {for 1 to 10 loop}

end;


end.