{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
unit cTopWin;

interface

uses
  TpWindow;

type

PTopWin = ^TTopWin;
TTopWin = object
             Win : WindowPtr;
             xlow,
             ylow,
             xhigh,
             yhigh : Byte; { tpcrt standard }
             constructor Init;
             destructor  Done; virtual;
             procedure   Update(Who : String); virtual;
           end;

var
  TopWin : PTopWin;

implementation

uses
  IniFile,
  LowLvl,
  DebugRtns,
  RecTypes,
  cDupeTbl,
  TpString,
  TpMouse,
  TpDate,
  cColors,
  TpCrt;


constructor TTopWin.Init;
const
  NoFrame = False;
  ClearWindow = True;
  SaveWindow = True;
begin
  xlow  := MW_xhi+1; { just to right of main window }
  ylow  := MW_Ylo;
  xhigh := ScreenWidth;
  yhigh := MW_Ylo+5;
  with Colors^ do
  if not MakeWindow(Win, xlow, ylow, xhigh, yhigh,
      NoFrame, ClearWindow, SaveWindow,
      WindowAttr, FrameAttr, HeaderAttr, '') then
    AppendDebugMessage('TTopWin.Init, MakeWindow(Win) failed');
  DisplayWindow(Win);
  {$IFDEF DEBUG}
  AppendDebugMessage('TopWin created');
  {$ENDIF}
end;

destructor  TTopWin.Done;
begin
  KillWindow(Win);
  {$IFDEF DEBUG}
  AppendDebugMessage('TopWin destroyed');
  {$ENDIF}
end;

procedure   TTopWin.Update(Who : String);
var
  Band : BandType;
  Info : array[BandType] of Boolean;
  Slot : Word;
begin
  if Trim(Who) = '' then Exit;
  for Band := B80 to B10 do
    Info[Band] := False;
  HideMouse;
  with Colors^ do begin
   FastWriteStack(Win, Pad(Who, 11), 1, 2, HiLiteAttr);
   if DupeTbl^.GetDupeByCall(Who, Slot) then begin
     FastWriteStack(Win, '80 - '+TimeToTimeString('hhmm', DupeTbl^.GetTime(B80)),
       2, 2, NeedAttr(DupeTbl^.GetTime(B80) <> BadTime));
     FastWriteStack(Win, '40 - '+TimeToTimeString('hhmm', DupeTbl^.GetTime(B40)),
       3, 2, NeedAttr(DupeTbl^.GetTime(B40) <> BadTime));
     FastWriteStack(Win, '20 - '+TimeToTimeString('hhmm', DupeTbl^.GetTime(B20)),
       4, 2, NeedAttr(DupeTbl^.GetTime(B20) <> BadTime));
     FastWriteStack(Win, '15 - '+TimeToTimeString('hhmm', DupeTbl^.GetTime(B15)),
       5, 2, NeedAttr(DupeTbl^.GetTime(B15) <> BadTime));
     FastWriteStack(Win, '10 - '+TimeToTimeString('hhmm', DupeTbl^.GetTime(B10)),
       6, 2, NeedAttr(DupeTbl^.GetTime(B10) <> BadTime));
   end
   else begin {new qso}
     FastWriteStack(Win, '80 - '+CharStr(' ', 4), 2, 2, NeedAttr(false));
     FastWriteStack(Win, '40 - '+CharStr(' ', 4), 3, 2, NeedAttr(false));
     FastWriteStack(Win, '20 - '+CharStr(' ', 4), 4, 2, NeedAttr(false));
     FastWriteStack(Win, '15 - '+CharStr(' ', 4), 5, 2, NeedAttr(false));
     FastWriteStack(Win, '10 - '+CharStr(' ', 4), 6, 2, NeedAttr(false));
   end;
  end;
  ShowMouse;
 end;

end.