{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program CtyList;
uses
  Dos,
  TpDos,
  TpRarray,
  TpString,
  cCountry;

CONST
  BufSize  = 8192;


type
  TextBuffer = array[1..BufSize] of Char;

var
  StdErr : Text;             {For status reporting}
  TextBuf : TextBuffer;      {Speeds input and output}
  StdErrBuf : Char;          {Forces StdErr to write a char at a time}
  Ct_Array, Pf_Array : TParray;

var
  CT    : Ct_Rec_Type;
  PF    : Pf_Rec_Type;

  CONST
    StdInHandle  = 0;           {handle numbers for OpenStdDev}
    StdOutHandle = 1;
    StdErrHandle = 2;
    StdPrnHandle = 4;
  MaxPrefix      : Word = 2000;
  MaxCountry     : Word = 350;

  procedure Error(msg : string);
    {-Report error through StdErr and halt}
  begin
    WriteLn(StdErr, ^M^J, msg);
    Close(StdErr);
    Halt(1);
  end;

  function OpenStdDev(var F : Text; StdHandle : Word) : Boolean;
    {-Assign the text file to the specified standard DOS device}
  begin
    OpenStdDev := False;
    case StdHandle of
      StdInHandle,
      StdOutHandle,
      StdErrHandle,
      StdPrnHandle :
        begin
          {Initialize the file variable}
          Assign(F, '');
          Rewrite(F);
          if IoResult = 0 then begin
            TextRec(F).Handle := StdHandle;
            if StdHandle = StdErrHandle then
              TextRec(F).BufSize := 1;
            OpenStdDev := True;
          end;
        end;
    end;
  end;

  function HandleIsConsole(Handle : Word) : Boolean;
    {-Return true if handle is the console device (input or output)}

  var
    Regs           : Registers;

  begin
    with Regs do begin
      AX := $4400;
      BX := Handle;
      MsDos(Regs);
      if (DX and $80) = 0 then
        HandleIsConsole := False
      else
        HandleIsConsole := (DX and $02 <> 0) or (DX and $01 <> 0);
    end;
  end;

  function OpenRtn(FileName : String) : Boolean;
  var
    Cf : string[79];
    pf : string[79];
  begin
    OpenRtn := False;
    cf := ForceExtension(Filename,'CTY');
    pf := ForceExtension(Filename,'PFX');
    if not ExistFile(pf) then Exit;
    if not ExistFile(cf) then Exit;
    MakeCountryList(CF,PF);
    OpenRtn := True;
  end;
begin

  {Open StdErr for status reporting}
  if not(OpenStdDev(StdErr, 2)) then begin
    WriteLn('Error opening StdErr');
    Halt(1);
  end else
    {Force buffer flush every character}
    SetTextBuf(StdErr,StdErrBuf, 1);

  WriteLn(StdErr, 'Country File Lister Copyright(c) 1993 by Wyvern Technology, Inc.');

  if (Trim(ParamStr(1)) = '') or (Trim(ParamStr(2)) = '') then begin
    WriteLn(StdErr);
    WriteLn(StdErr, 'Usage: CTYLIST InputFile OutputFile');
    WriteLn(StdErr);
    Error('');
  end;

  SetTextBuf(Output, TextBuf, BufSize);

  if OpenRtn(ParamStr(1)) then CountryList^.List(ParamStr(2));

  WriteLn(StdErr,StUpCase(ParamStr(1))+' Country file listed to '+
           StUpCase(ParamStr(2))  );
  Close(StdErr);

end.
