{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit CUserDef;
interface
uses tncobject,
     ApPort;
type
  PUserDef        = ^TUserDef;
  TUserDef        = object(TTnc)
                     Usos : Boolean;
                     constructor Init(const Port : ComNameType);
                     procedure Transmit(const Xmit : Boolean);virtual;
                     procedure ClearXmitBuffer; virtual;
                     procedure StopEverything; virtual;
                     destructor Done; Virtual;
                     procedure  Setup;
                     procedure  ToggleTncTalk; virtual;
                 end;

implementation

uses
  TpEntry,
  TpMouse,
  TpWindow,
  DebugRtns,
  TpCrt,
  Keys,
  RecTypes,
  Routines,
  OneTimers,
  LowLvl,
  cColors,
  IniFile;


  procedure TUserDef.Transmit(const Xmit : Boolean);
  begin
    if Xmit then SendString(CarotToCtl(RttyIni^.GetProfileString('TX-string', 'User-Def', '')))
    else SendString(CarotToCtl(RttyIni^.GetProfileString('RX-string', 'User-Def', '')));
  end;

  procedure TUserDef.ClearXmitBuffer;
  begin
    SendString(CarotToCtl(RttyIni^.GetProfileString('CLEAR-string', 'User-Def', '')));
  end;

  procedure TUserDef.StopEverything;
  begin
    Transmit(False);
    ClearXmitBuffer;
  end;

  constructor TUserDef.Init(const Port : ComNameType);
  begin
    inherited InitCom(Port);
    TncNum := bUserDef;
    SetUsos(GetUsos);
    {$IFDEF DEBUG}
    AppendDebugMessage('UserDef created');
    {$ENDIF}
  end;

  destructor TUserDef.Done;
  begin
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('UserDef destroyed');
    {$ENDIF}
  end;

  procedure TUserDef.Setup;
  var
    Esr : EsRecord;
    ExitCommand : EStype;
    SetWPtr : WindowPtr;
    Instr : array[0..2] of String[9];
    I : Integer;
  begin
    with Colors^ do
      MakeWindow(SetWPtr, 3, 3, 30, 10, True, True, False, WindowAttr,
        FrameAttr, HeaderAttr, 'Set User Tnc');
    HideMouse;
    DisplayWindow(SetWPtr);
    InitEsRecord(Esr);
    Colors^.SetEntryAttributes;
    Instr[0] := RttyIni^.GetProfileString('TX-string', 'User-Def', '');
    Instr[1] := RttyIni^.GetProfileString('RX-string', 'User-Def', '');
    Instr[2] := RttyIni^.GetProfileString('CLEAR-string', 'User-Def', '');
    AddStringField(Esr, 'Transmit String', 5, 4, '', 5, 20, 9, 0, nil, Instr[0]);
    AddStringField(Esr, 'Receive String', 6, 4, '', 6, 20, 9, 0, nil, Instr[1]);
    AddStringField(Esr, 'Clear Buffer St', 7, 4, '', 7, 20, 9, 0, nil, Instr[2]);
    FastWriteWindow('If you need a control-C', 5, 1, Colors^.HiLiteAttr);
    FastWriteWindow('enter it as ^C', 6, 1, Colors^.HiLiteAttr);
    ShowMouse;
    AddCmd(ESEnd, kbEnd);
    AddCmd(ESHome,kbHome);
    AddCmd(EsQuit,kbEsc);
    repeat
      ExitCommand := EditScreen(Esr, 0, False);
    until ExitCommand in [EsQuit, EsDone];
    if ExitCommand = EsDone then begin
      CtlToCarot(Instr[0]);
      CtlToCarot(Instr[1]);
      CtlToCarot(Instr[2]);
      RttyIni^.SetOrAddProfileString('TX-string', 'User-Def', Instr[0]);
      RttyIni^.SetOrAddProfileString('RX-string', 'User-Def', Instr[1]);
      RttyIni^.SetOrAddProfileString('CLEAR-string', 'User-Def', Instr[2]);
    end;
    AddCmd(ESmy25, kbEnd);
    AddCmd(ESmy23, kbHome);
    AddCmd(Esmy49, kbEsc);
    KillWindow(SetWPtr);
    DisposeEditScreen(Esr);
  end;

  procedure TUserDef.ToggleTncTalk;
  begin
    Setup;
  end;

end.
