{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit CUtu;
interface
uses
  TpCrt,
  tncobject,
  ApPort;
type
  PUtu         = ^TUtu;
  TUtu         = object(TTnc)
                     constructor Init(const Port : ComNameType);
                     procedure SendString(const Data : String); virtual;
                     procedure Transmit(const Xmit : Boolean); virtual;
                     procedure SetUsos(const USOS : Boolean); virtual;
                     procedure SetBaudRate(const Rate : Byte); virtual;
                     procedure SetMode(const Mode : String);virtual;
                     procedure Letters; virtual;
                     procedure ClearXmitBuffer; virtual;
                     procedure StopEverything; virtual;
                     destructor Done; Virtual;
                   end;

implementation
uses
  RecTypes,
  Keys,
  DebugRtns,
  IniFile;

  procedure TUtu.SendString(const Data : String);
  var
    B              : Byte;
  begin
    for B := 1 to Length(Data) do begin
      SendChar(Data[B]);
      if KeyPressed then
        if ReadKeyWord = kbEsc then
          B := Length(Data);
    end;
    while KeyPressed do
      ReadKeyWord ;
  end;

  procedure TUtu.Transmit(const Xmit : Boolean);
  begin
    if Xmit then SendString(^C+'T')
    else SendString(^C+'E');
  end;

  procedure TUtu.SetUsos(const USOS : Boolean);
  begin
    inherited SetUsos(Usos);
    case Usos of
      true : SendString('USOS ON'+^M);
      false : SendString('USOS OFF'+^M);
    end;
  end;

  procedure TUtu.Letters;
  begin
    SendString(^C+'L');
  end;

  procedure TUtu.ClearXmitBuffer;
  begin
    SendChar(^X);
  end;

  procedure TUtu.SetMode(const Mode : String);
  begin
    if Mode = 'RTTY' then SendString('RTTY'+^M);
  end;

  procedure TUtu.SetBaudRate(const Rate : Byte);
  begin
    case Rate of
      45 : SendString('RB 45'+^M);
      50 : SendString('RB 50'+^M);
      57 : SendString('RB 57'+^M);
      74 : SendString('RB 75'+^M);
      100 : SendString('RB 100'+^M);
      110 : SendString('RB 110'+^M);
    else
      SendString('RB 45'+^M); ; {default to 45 if not above}
    end;
  end;

  procedure TUtu.StopEverything;
  begin
    Transmit(False);
    ClearXmitBuffer;
  end;

  constructor TUtu.Init(const Port : ComNameType);
  begin
    inherited InitCom(Port);
    Tncnum := bUTU;
    SendString(^C+'X');
    SendString(^C+^M);
    SendString('ECHO ON'+^M);
    SendString('XMITECHO OFF'+^M);
    SetMode(GetMode);
    SetBaudRate(45);
    SetUsos(GetUsos);
    {$IFDEF DEBUG}
    AppendDebugMessage('UTU created');
    {$ENDIF}
  end;

  destructor TUtu.Done;
  begin
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('UTU destroyed');
    {$ENDIF}
  end;

end.
