{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit C_ft890;

interface

uses
  c_ftcmmn,
  apport;

type
  pft890 = ^Tft890;
  Tft890 = object(tFTCommon)
             constructor Init(const ComName : ComNameType);
             destructor Done; virtual;
             function GetDisplayFrequency : LongInt; virtual;
             procedure GetCurrentVfo; virtual;
           end;


implementation

uses
  opstring,
  ApUart,
  ApTimer,
  DebugRtns,
  c_radio;

  constructor Tft890.Init(const ComName : ComNameType);
  begin
    inherited Init(ComName);
    Name := 'FT-890';
    {$IFDEF DEBUG}
    AppendDebugMessage('FT890 created');
    {$ENDIF}
  end;

  destructor Tft890.Done;
  begin
    inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('FT890 destroyed');
    {$ENDIF}
  end;

  procedure Tft890.GetCurrentVfo;

    procedure TryIt;
    var
      ET : EventTimer;
    begin
      NewTimer(ET, 5);
      repeat until TimerExpired(ET) or (UP^.TransReady);
      ClearCommand;
      Command[5] := $FA;
      ClearStatusFlags;
      GetCommandData(StatusFlags, 5);
    end;

  begin
    TryIt;
    if (InfoBlk[1] and $01) = $01 then CurrentVFO := 'B'
                                  else CurrentVFO := 'A';
  end;

  function Tft890.GetDisplayFrequency : LongInt;
    procedure TryIt;
    begin
      NewTimer(ET, 5);
      repeat until TimerExpired(ET) or (UP^.TransReady);
      ClearCommand;
      Command[1] := $02;
      Command[2] := $02;
      Command[3] := $02;
      Command[4] := $02;
      Command[5] := $10;
      SendCommand;
      ClearInfoBlk;
      GetCommandData(InfoBlk, 19);
    end;

  begin
    if not Assigned(UP) then begin
      GetDisplayFrequency := 0;
      Exit;
    end;
    GetCurrentVFO;
    TryIt;
    Case CurrentVFO of
    'A' : GetDisplayFrequency := ((longint(InfoBlk[3]) * 65536) +
                                  (longint(InfoBlk[4]) * 256) +
                                   longint(InfoBlk[5])) * 10;
    'B' : GetDisplayFrequency := ((longint(InfoBlk[12]) * 65536) +
                                  (longint(InfoBlk[13]) * 256) +
                                   longint(InfoBlk[14])) * 10;
    end;
  end;

end.
