{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit DebugRtns;

interface

procedure AppendDebugMessage(const Msg : String);
function  MessageBox(const Header,Line1,Line2,Line3 : String) : byte;
procedure About;
procedure NotEnoughMemory(const Stop : boolean);

const
  HitEnter = 1;
  HitEsc   = 2;

implementation


uses
  TpCrt,
  TpMouse,
  TpString,
  cMyWin,
  RecTypes,
  OneTimers,
  TpDate;

  procedure AppendDebugMessage(const Msg : String);
  const
    FileOK = $0;
    FileNotFound = $2;
  var
    DebugFile : Text;
    IOStatus : Integer;
  begin
    Assign(DebugFile, 'RTTY.DBG');
    {$I-} Append(DebugFile); {$I+}
    IOStatus := IoResult;
    if (IOStatus <> FileOK) and (IOStatus <> FileNotFound) then
      Exit;                       {FATAL ERROR-Get the hell out!}
    if IOStatus = FileNotFound then
      begin
        Rewrite(DebugFile);
        WriteLn(DebugFile, 'RTTY by WF1B Debug & Trace File');
        WriteLn(DebugFile, '');
        WriteLn(DebugFile, 'Date     Time  Comment');
      end;
    WriteLn(DebugFile, TodayString('yy-mm-dd ')+CurrentTimeString('hh:mm ')+Msg);
    Close(DebugFile);
  end;

  function MessageBox(const Header,Line1,Line2,Line3 : String) : byte;
  var
    w : pMyWin;
    k : word;
  begin
    {$IFDEF ASSERT}
    if (Length(Line1) > 50) or
       (Length(Line2) > 50) or
       (Length(Line3) > 50) then begin
       writeln('message length exceeds available area!');
       halt;
    end;
    {$ENDIF}
    w := New(PMyWin, Init(15,6,65,10,True,Header));
    w^.wWriteln(Line1);
    w^.wWriteln(Line2);
    w^.wWrite(Line3);
    w^.Display;
    repeat until KeyPressed;
    k := readkeyword;
    if K = $1C0D then MessageBox := HitEnter else
    if k = $011B then MessageBox := HitEsc else
    MessageBox := 0;
    dispose(w, done);
  end;

  var
    w : pMyWin;
  procedure ShowAboutWin;
  begin
    w := New(PMyWin, Init(22,5,58,20,True,'About RTTY by WF1B'));
    w^.wWriteln('');
    w^.wWriteln('     Product:      '+RttyByWF1b);
    w^.wWriteln('     Version:      '+trim(Version));
    w^.wWriteln('');
    w^.wWriteln('     Date:         June 20, 2000');
    w^.wWriteln('');
    w^.wWriteln('     Copyright 1990-2000. ');
    w^.wWriteln('     All rights reserved.');
    w^.wWriteln('');
    w^.wWriteln('     Wyvern Technology, Inc.');
    w^.wWriteln('     35 Colvintown Road');
    w^.wWriteln('     Coventry, RI 02816 USA');
    w^.wWriteln('     www.wf1b.com');
    w^.Display;
  end;

  procedure KillAboutWin;
  begin
    dispose(w, done);
  end;

  procedure About;
  var
    k : word;
  begin
    ShowAboutWin;
    repeat until KeyPressed or MousePressed;
    if KeyPressed then k := ReadKeyWord
                  else k := MouseKeyWord;
    KillAboutWin;
  end;

  procedure NotEnoughMemory(const Stop : boolean);
  begin
    if Stop then begin
      MessageBox('Severe Error!',
                 'Your system has run out of memory, RTTY is',
                 'unable to continue operating in its present',
                 'condition.  Please free up more low memory.');
      CloseDownScreen;
      Halt;
    end
    else begin
      MessageBox('Severe Error!',
                 'Your system is very low on memory, RTTY is not  ',
                 'able to perform the requested operation.  If ',
                 'possible, please free up more low memory.');
    end;
  end;


end.
