{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program FIX_MINE;

uses
  TpString,
  TpPick,
  TpDir,
  TpCrt,
  TpDate,
  TAccess,
  TaHigh,
  RecTypes,
  Diskio;

var
  RecordNumber   : LongInt;
  DBase          : DataSet;
  DatName, NdxName : String[79];
  TimeOut          : byte;
  Num            : Word;
  C              : Byte;
  Callsign : string[12];
  a        : log_rec;
  index    : string[8];

  function Get_Bin_File : String;
  var
    Result         : Integer;
    BinFile        : String[79];
  const
    DirColors      : PickCOlorArray = ($07, $07, $0F, $70, $0F, $78);
  begin
    ShowSizeDateTime := True;
    SetVerticalPick;
    Result := GetFileName('*.BIN',
                          0,
                          1, 3,
                          15, 1,
                          DirColors,
                          BinFile);
    if ((Result = 0) and (BinFile = '')) or ((Result > 0)) then BinFile := '';
    if BinFile = '' then begin
      Writeln('FIX_MINE: no database selected');
      halt;
    end;
    Get_Bin_File := BinFile;
  end;

  function Get_Callsign : String;
  var
    S        : String[12];
    B        : byte;
  begin
    Write('Enter the callsign you wish to remove ALL contacts for: ');
    Readln(S);
    S := Trim(S);
    if Length(S) > 0 then
      for B := 1 to Length(S) do
        S[B] := Upcase(S[B]);
    if S = '' then begin
      Writeln('FIX_MINE: no callsign entered');
      halt;
    end;
    Get_Callsign := S;
  end;



begin
  Writeln;
  ClrScr;
  Writeln('RTTY by WF1B v3.0 Copyright 1990-1997 Wyvern Technology, Inc.');
  WriteLn('FIX_MINE Utility (remove a callsign from log)');
  Delay(1000);
  DatName := '';
  Num := 0;
  if ParamCount = 1 then
    DatName := ParamStr(1)
  else begin
    DatName := Get_Bin_File;
  end;
  Callsign := Get_Callsign;
  DatName := ForceExtension(DatName,'BIN');
  NdxName := ForceExtension(DatName,'NDX');
  TAOpen(DBase, DatName, SizeOf(Log_Rec), NdxName, SizeOf(Index)-1);
  if not OK then begin
    writeln('FIX_MINE: Unable to open data files, try running REINDEX to repair');
    halt;
  end;
  TAReset(DBase);
  if not OK then begin
    writeln('FIX_MINE: Unable to reset data files, try running REINDEX to repair');
    halt;
  end;
  writeln('Mtr Date     Time Callsign');
  writeln('--- -------- ---- --------');
  TANext(DBase, a, Index);
  while OK do begin
    if a.ToolBoxNumber = 0 then
      if Trim(a.Call) = Callsign then begin
        TADelete(DBase, Index);
        if OK then writeln(BandS[a.Band] + 'M' +
            DateToDateString(' mm/dd/yy ', a.Date) +
            TimeToTimeString('hhmm ', a.Ts) +
            Pad(a.Call, 12)+' DELETED!');
      end;
    TANext(DBase, a, Index);
  end;
  TAClose(DBase);
  writeln;
  WriteLn('All QSO''s with '+Callsign+' have been deleted!');
end.
