{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}

unit Inform;

interface

procedure ShowHelp;

implementation

uses
  cColors,
  RecTypes,
  TpPick;


  function FK(Choice : Word) : String; far;
  begin
    case Choice of
      1 : FK := 'B U F F E R S';
      2 : FK := 'F1      Send CQ Message';
      3 : FK := 'F2      Send Exchange';
      4 : FK := 'F3      Send Confirm Message';
      5 : FK := 'F4      Send My Call';
      6 : FK := 'F5      Send His Call';
      7 : FK := 'F6      Send User Defined';
      8 : FK := 'F7      Send User Defined';
      9 : FK := 'F8      Send User Defined';
      10 : FK := 'F9      Send User Defined';
      11 : FK := 'F10     Send User Defined(CallQue)';
      12 : FK := 'Alt-B   Send Worked Before Message';
      13 : FK := 'Alt-K   Chat mode';
      14 : FK := 'Alt-T   Talk to Tnc (no transmit)';
      15 : FK := ' ';
      16 : FK := 'B U F F E R   V A R I A B L E S';
      17 : FK := '<1>     RX Callsign';
      18 : FK := '<2>     RX State/Province';
      19 : FK := '<3>     RX Exchange Time';
      20 : FK := '<4>     RX Serial Number';
      21 : FK := '<5>     RX CQ Zone';
      22 : FK := '<6>     RX RST';
      23 : FK := '<7A>    RX Date yy/mm/dd';
      24 : FK := '<7B>            mm/dd/yy';
      25 : FK := '<7C>            dd.XII.yy';
      26 : FK := '<7D>            yy.DEC.dd';
      27 : FK := '<7E>            day of week';
      28 : FK := '<8A>    RX Time hh:mmZ';
      29 : FK := '<8B>            hh:mm';
      30 : FK := '<9>     RX Age';
      31 : FK := '<11>    TX Callsign';
      32 : FK := '<12>    TX State/Province';
      33 : FK := '<13>    TX Exchange Time';
      34 : FK := '<14>    TX Serial Number';
      35 : FK := '<15>    TX CQ Zone';
      36 : FK := '<16>    TX RST';
      37 : FK := '<19>    TX Age';
      38 : FK := '<20A>   Date    yy/mm/dd';
      39 : FK := '<20B>           mm/dd/yy';
      40 : FK := '<20C>           dd.XII.yy';
      41 : FK := '<20D>           yy.DEC.dd';
      42 : FK := '<20E>           day of week';
      43 : FK := '<21A>   Time    hh:mmZ';
      44 : FK := '<21B>           hh:mm';
      45 : FK := '<22A>   Band Meters 20';
      46 : FK := '<22B>        MHz    14';
      47 : FK := '<31>    Prev Callsign';
      48 : FK := '<32>    Prev State/Province';
      49 : FK := '<33>    Prev Exchange Time';
      50 : FK := '<34>    Prev Serial Number';
      51 : FK := '<35>    Prev CQ Zone';
      52 : FK := '<36>    Prev RST';
      53 : FK := '<39>    Prev Age';
      54 : FK := '<CR>    Carriage Return';
      55 : FK := '<SP>    Required Space';
      56 : FK := '<HI>    Hello Message';
      57 : FK := '<TU>    Thanks Message';
      58 : FK := ' ';
      59 : FK := 'S E T U P';
      60 : FK := 'Ctl-F1  Enter My Information';
      61 : FK := 'Ctl-F7  Enter Message Buffers';
      62 : FK := 'Alt-I   Work Sheet Edit';
      63 : FK := ' ';
      64 : FK := ' ';
      65 : FK := 'I N F O R M A T I O N';
      66 : FK := 'Alt-D   Display Districts';
      67 : FK := 'Alt-H   Display this list';
      68 : if Contest = WPXC then
             FK := 'Alt-M   Display Prefixes' else
             FK := 'Alt-M   Display Multipliers';
      69 : FK := 'Alt-N   Add Note to .NOT File';
      70 : FK := 'Alt-S   Score Information';
      71 : case Contest of
             ARRL, CQWW, TARA,
             DXPD,NAQP    : FK := 'Alt-U   Display US/VE Multipliers';
             EAWW         : FK := 'Alt-U   Display EA Provinces';
             SPDX         : FK := 'Alt-U   Display SP Provinces';
             RRWW         : FK := 'Alt-U   Display Oblasts';
             ARII         : FK := 'Alt-U   Display I Provinces';
             HSSC,
             SART,JART,
             BART,VOLT,
             ANAR         : FK := 'Alt-U   Display Districts';
             WPXC         : FK := 'Alt-U   Display Prefixes';
           end;
      72 : FK := 'Alt-Z   CQ Zone Map';
      73 : FK := 'Ctl-F4  Super Check Partial';
      74 : FK := 'Ctl-F5  DXCC Status';
      75 : FK := 'Ctl-F6  Display All Countries';
      76 : FK := 'Ctl-F9  Check Callsign';
      77 : FK := 'Ctl-F10 Check Country';
      78 : FK := ' ';
      79 : FK := 'O P E R A T I O N';
      80 : FK := 'Home    Put Call in Log';
      81 : FK := 'Ins "+" Home & F5 & F2';
      82 : FK := 'PgDn    Log Contact & F3';
      83 : FK := 'End     Log Contact';
      84 : FK := 'Alt-F1  Band Down';
      85 : FK := 'Alt-F2  Band Up';
      86 : FK := Chr(24)+'/'+Chr(25)+'     Scroll Call Queue';
      87 : FK := 'Alt-C   Call Queue';
      88 : FK := 'Alt-F   Force Figures';
      89 : FK := 'Alt-L   Force Letters';
      90 : FK := 'Alt-W   Wipe out this QSO';
      91 : FK := 'Alt-=   Toggle Normal/Reverse';
      92 : FK := ' ';
      93 : FK := 'M I S C E L L A N E O U S';
      94 : FK := 'Alt-Q   Quit';
      95 : FK := 'Alt-E   Edit Log';
      96 : FK := 'Esc     Stop xmit buffer';
      97 : FK := ' ';
      98 : FK := 'C O M M A N D S';
      99 : FK := 'AUTOSAVE OFF Disable Autosave Log';
     100 : FK := 'AUTOSAVE ON  Enable Autosave Log';
     101 : FK := 'BEEP ON      Turn on sound';
     102 : FK := 'BEEP OFF     Turn off sound';
     103 : FK := 'CBAUD nnn    Set Baud Rate in BAUD';
     104 : FK := 'CWPM nnn     Set Baud Rate in WPM';
     105 : FK := 'ECHO ON      Set echo (baudot-drv only)';
     106 : FK := 'ECHO OFF     Set echo off';
     107 : FK := 'PRINT ON     Print each contact';
     108 : FK := 'PRINT OFF    Do not print each contact';
     109 : FK := 'SAVELOG x    Save log to drive x:';
     110 : FK := 'SENDFILE     Send text file';
     111 : FK := 'WRITELOG     Write all files';
     112 : FK := '#####        QSY to this frequency'; {v2.5a}
     113 : FK := '*END*';
     else
      FK := '-';
    end;
  end;

  procedure ShowHelp;
  var
    HiNum,Choice : Word;
  begin
    HiNum := 0;
    while FK(HiNum) <> '*END*' do
      Inc(HiNum);
    Dec(HiNum);
    Choice := 1;
    PickMatrix := 1;
    PickWindow(@FK, HiNum, MW_xhi-40, 2, MW_xhi, MW_Yhi-1, True, Colors^.PickColors,
                  'HELP!', Choice);
  end;


end.
