{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit Keys;
interface
const
  kbCtrlA        = $0001; kbCtrlB = $0002; kbCtrlC = $0003;
  kbCtrlD        = $0004; kbCtrlE = $0005; kbCtrlF = $0006;
  kbCtrlG        = $0007; kbCtrlH = $0008; kbCtrlI = $0009;
  kbCtrlJ        = $000a; kbCtrlK = $000b; kbCtrlL = $000c;
  kbCtrlM        = $000d; kbCtrlN = $000e; kbCtrlO = $000f;
  kbCtrlP        = $0010; kbCtrlQ = $0011; kbCtrlR = $0012;
  kbCtrlS        = $0013; kbCtrlT = $0014; kbCtrlU = $0015;
  kbCtrlV        = $0016; kbCtrlW = $0017; kbCtrlX = $0018;
  kbCtrlY        = $0019; kbCtrlZ = $001a;


  kbEsc          = $011b; kbAltSpace = $0200; kbCtrlIns = $0400;
  kbShiftIns     = $0500; kbCtrlDel = $0600; kbShiftDel = $0700;
  kbBack         = $0e08; kbCtrlBack = $0e7f; kbShiftTab = $0f00;
  kbTab          = $0f09; kbAltQ = $1000; kbAltW = $1100;
  kbAltE         = $1200; kbAltR = $1300; kbAltT = $1400;
  kbAltY         = $1500; kbAltU = $1600; kbAltI = $1700;
  kbAltO         = $1800; kbAltP = $1900; kbCtrlEnter = $1c0a;
  kbEnter        = $1c0d; kbAltA = $1e00; kbAltS = $1f00;
  kbAltD         = $2000; kbAltF = $2100; kbAltG = $2200;
  kbAltH         = $2300; kbAltJ = $2400; kbAltK = $2500;
  kbAltL         = $2600; kbAltZ = $2c00; kbAltX = $2d00;
  kbAltC         = $2e00; kbAltV = $2f00; kbAltB = $3000;
  kbAltN         = $3100; kbAltM = $3200; kbF1 = $3b00;
  kbF2           = $3c00; kbF3 = $3d00; kbF4 = $3e00;
  kbF5           = $3f00; kbF6 = $4000; kbF7 = $4100;
  kbF8           = $4200; kbF9 = $4300; kbF10 = $4400;
  kbF11          = $8500; kbF12 = $8600;
  kbHome         = $4700; kbUp = $4800; kbPgUp = $4900;
  kbGrayMinus    = $4a2d; kbLeft = $4b00; kbRight = $4d00;
  kbGrayPlus     = $4e2b; kbEnd = $4f00; kbDown = $5000;
  kbPgDn         = $5100; kbIns = $5200; kbDel = $5300;
  kbShiftF1      = $5400; kbShiftF2 = $5500; kbShiftF3 = $5600;
  kbShiftF4      = $5700; kbShiftF5 = $5800; kbShiftF6 = $5900;
  kbShiftF7      = $5a00; kbShiftF8 = $5b00; kbShiftF9 = $5c00;
  kbShiftF10     = $5d00; kbCtrlF1 = $5e00; kbCtrlF2 = $5f00;
  kbCtrlF3       = $6000; kbCtrlF4 = $6100; kbCtrlF5 = $6200;
  kbCtrlF6       = $6300; kbCtrlF7 = $6400; kbCtrlF8 = $6500;
  kbCtrlF9       = $6600; kbCtrlF10 = $6700; kbAltF1 = $6800;
  kbAltF2        = $6900; kbAltF3 = $6a00; kbAltF4 = $6b00;
  kbAltF5        = $6c00; kbAltF6 = $6d00; kbAltF7 = $6e00;
  kbAltF8        = $6f00; kbAltF9 = $7000; kbAltF10 = $7100;
  kbCtrlPrtSc    = $7200; kbCtrlLeft = $7300; kbCtrlRight = $7400;
  kbCtrlEnd      = $7500; kbCtrlPgDn = $7600; kbCtrlHome = $7700;
  kbAlt1         = $7800; kbAlt2 = $7900; kbAlt3 = $7a00;
  kbAlt4         = $7b00; kbAlt5 = $7c00; kbAlt6 = $7d00;
  kbAlt7         = $7e00; kbAlt8 = $7f00; kbAlt9 = $8000;
  kbAlt0         = $8100; kbAltMinus = $8200; kbAltEqual = $8300;
  kbCtrlPgUp     = $8400; kbNoKey = $0000;
  kbGrayAster    = $372A; kbSpace = $3920;

  kbCtrlUp       = $8D00; kbCtrlDown = $9100;

  msLeftClick    = $ef00; msRightClick = $EE00;


  kbRightShift   = $0001;
  kbLeftShift    = $0002;
  kbCtrlShift    = $0004;
  kbAltShift     = $0008;
  kbScrollState  = $0010;
  kbNumState     = $0020;
  kbCapsState    = $0040;
  kbInsState     = $0080;
implementation
end.


