{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program Labels;
uses
  cColors,
  ColorDef, Dos, Printer, IniFile,
  TAccess, TAHigh, Diskio,
  TpCrt, TpDate, TPdir, TpDos, TpEdit, TpEntry, TpPick, TpString, TpWindow,
  LowLvl, Routines, RecTypes;
var
  RTTYfile       : DataSet;
  CallIndex      : IndexFile;
  ESC            : Boolean;
  FilesOpened    : Boolean;
  FName          : String[79];
  IName          : String[79];
  AIName         : String[79];
  Call           : String[12];
  Junk           : String[10];
  Band           : BandType;
  CT             : Byte;
  Mode           : Char;
  DotPos         : Integer;
  LineIn         : array[0..5] of String[60];
  LineOut        : array[0..5] of String[60];
  MainWinPtr     : WindowPtr;
  SortOnCall     : Boolean;
  Aindex         : String[12];
  PrintAll       : Boolean;
  PrintQuit      : Boolean;
  a              : log_rec;
  Serial_Number   : word;
  Index : String[8];
  Choice : word;

const
  SortStr        : array[Boolean] of String[8] = ('Time    ', 'Callsign');

  procedure Print(Text : String);
  begin
    {$I-}
    WriteLn(Lst,Text);
    {$I+}
    If IOResult > 0 then begin
      Window(1,1,80,25);
      ClrScr;
      Writeln('Printer error!');
      Writeln('Check it out and try again...');
      Halt;
      end;
  end;

  procedure UpdateQSLLines;
  var
    LineNo         : Byte;
  begin
    Serial_Number := a.My_Serno;
    for LineNo := 0 to 5 do begin
      LineOut[LineNo] := Trim(LineOut[LineNo]);
      MakeSubstitutions(LineOut[LineNo], 60,a);
    end;
  end;

  procedure ResetLineOut;
  var
    LineNo              : Byte;
  begin
    for LineNo := 0 to 5 do
      LineOut[LineNo] := LineIn[LineNo];
  end;

  function PrintThisOne : Boolean;
  var
    WinPtr    : WindowPtr;
    KeyStroke : Word;
    LineNo    : Byte;
    Done      : Boolean;
  begin
    if PrintAll then begin
      PrintThisOne := True;
      Exit;
      end;
    if PrintQuit then begin
      PrintThisOne := False;
      Exit;
      end;
    ResetLineOut;
    UpdateQSLLines;
    MakeWindow(WinPtr, 13, 10, 60, 19, True, True, False,Colors^.WindowAttr,
               Colors^.FrameAttr, Colors^.HeaderAttr, 'Print this Label?');
    DisplayWindow(WinPtr);
    for LineNo := 0 to 5 do
      FastWriteWindow(Pad(LineOut[LineNo],43), LineNo+2, 2, WhiteOnBlack);
    FastWriteWindow('''Y'' to print, ''N'' to skip, ''A'' to print all', 9, 2, TextAttr);
    Done := False;
    repeat
      repeat until KeyPressed;
      KeyStroke := ReadKeyWord;
      PrintThisOne := chr(Lo(KeyStroke)) in ['Y','y','A','a'];
      PrintAll     := chr(Lo(KeyStroke)) in ['A','a'];
      PrintQuit    := KeyStroke = 283; {the escape key}
      until (chr(lo(keystroke)) in ['Y','y','N','n','A','a']) or PrintQuit;
    KillWindow(WinPtr);
  end;

  procedure Print_Label;
  var
    LineNo : Byte;
  begin
    if a.Dupe then Exit;
    if not PrintThisOne then Exit;
    if PrintQuit then Exit;
    ResetLineOut;
    UpdateQSLLines;
    for LineNo := 0 to 5 do
      Print(LineOut[LineNo]);
  end;


  procedure ChangeIndex;
  var
    RecordNumber   : LongInt;
    DatF           : DataFile;
    IndexF         : IndexFile;
    Num            : Word;
  begin
    SortOnCall := not SortOnCall;
    FilesOpened := False;
    TAClose(RTTYfile);
    case SortOnCall of
      True : begin
               DeleteFile(AIName);
               OpenFile(DatF, FName, SizeOf(a));
               if not OK then begin
                 Write('LABELS: Open "'+Trim(FName)+'" failed.');
                 Halt;
               end;
               MakeIndex(IndexF, AIName, SizeOf(Aindex)-1, Duplicates);
               if not OK then begin
                 Write('LABELS: Make index "'+Trim(AIName)+'" failed.');
                 Halt;
               end;
               for RecordNumber := 1 to FileLen(DatF)-1 do begin
                 GetRec(DatF, RecordNumber, a);
                 if not OK then begin
                   Write('LABELS: Get data in "'+Trim(FName)+'" failed at record ');
                   WriteLn(RecordNumber);
                   Halt;
                 end;
                 if a.ToolBoxNumber = 0 then begin
                   Aindex := Pad(a.Call, 12);
                   AddKey(IndexF, RecordNumber, Aindex);
                   if not OK then begin
                     Write('LABELS: Add Key Index in "'+Trim(AIName)+'" failed at record ');
                     WriteLn(RecordNumber);
                     Halt;
                   end;
                 end;
               end;
               CloseFile(DatF);
               CloseIndex(IndexF);
               TAOpen(RTTYfile, FName, SizeOf(Log_Rec), AIName, SizeOf(Aindex)-1);
               FilesOpened := True;
             end;

      False : begin
                DeleteFile(IName);
                OpenFile(DatF, FName, SizeOf(a));
                if not OK then begin
                  Write('LABELS: Open "'+Trim(FName)+'" failed.');
                  Halt;
                end;
                MakeIndex(IndexF, IName, SizeOf(Index)-1, NoDuplicates);
                if not OK then begin
                  Write('LABELS: Make index "'+Trim(IName)+'" failed.');
                  Halt;
                end;
                for RecordNumber := 1 to FileLen(DatF)-1 do begin
                  GetRec(DatF, RecordNumber, a);
                  if not OK then begin
                    Write('LABELS: Get data in "'+Trim(FName)+'" failed at record ');
                    WriteLn(RecordNumber);
                    Halt;
                  end;
                  if a.ToolBoxNumber = 0 then begin
                    Index := DateToSortString(a.Date)+TimeToSortString(a.Ts);
                    AddKey(IndexF, RecordNumber, Index);
                    if not OK then begin
                      Inc(a.Ts);
                      Index := DateToSortString(a.Date)+TimeToSortString(a.Ts);
                      AddKey(IndexF, RecordNumber, Index);
                    end;
                  end;
                end;
                CloseFile(DatF);
                CloseIndex(IndexF);
                TAOpen(RTTYfile, FName, SizeOf(Log_Rec), IName, SizeOf(Index)-1);
                FilesOpened := True;
              end;
    end;
  end;

  procedure MyTANext;
  begin
    case SortOnCall of
      True : TANext(RTTYfile, a, Aindex);
      False : TANext(RTTYfile, a, Index);
    end;
  end;

  procedure Print_Labels;
  begin
    TAReset(RTTYfile);
    MyTANext;
    while OK do
    begin
      a.Call := Trim(a.Call);
      if a.Call = Call then Print_Label;
      MyTANext;
    end;
  end;

  procedure Print_Labels_By_Band;
  begin
    TAReset(RTTYfile);
    MyTANext;
    while OK do
    begin
      if a.Band = Band then Print_Label;
      MyTANext;
    end;
  end;

  procedure PrintCountries;
  begin
    TAReset(RTTYfile);
    MyTANext;
    while OK do
    begin
      if a.New_Country then Print_Label;
      MyTANext;
    end;
  end;

  procedure PrintZones;
  begin
    TAReset(RTTYfile);
    MyTANext;
    while (OK) and (a.New_Zone) do begin
      Print_Label;
      MyTANext;
    end;
  end;

  procedure PrintStates;
  begin
    TAReset(RTTYfile);
    MyTANext;
    while (OK) and (a.New_Qth) do begin
      Print_Label;
      MyTANext;
    end;
  end;

  procedure Print_All_Labels;
  begin
    TAReset(RTTYfile);
    MyTANext;
    while OK do begin
      Print_Label;
      MyTANext;
    end;
  end;

  procedure Individual;
  var
    WinPtr         : WindowPtr;
    Escaped        : Boolean;
  begin
    Escaped := False;
    MakeWindow(WinPtr, 3, 3, 18, 5, True, True, False, Colors^.WindowAttr,
                  Colors^.FrameAttr, Colors^.HeaderAttr, 'Individual') ;
    DisplayWindow(WinPtr) ;
    repeat
      Call := '';
      ReadString('', 1, 1, 12, Colors^.PromptAttr, Colors^.StringAttr, Colors^.CtrlAttr, Escaped, Call);
      Call := Trim(Call);
      if not Escaped then Print_Labels;
      PrintQuit := False;
    until Escaped;
    KillWindow(WinPtr);
  end;

  procedure By_Band;
  var
    WinPtr         : WindowPtr;
    Escaped        : Boolean;
    Str            : String[2];
  begin
    Escaped := False;
    MakeWindow(WinPtr, 3, 3, 18, 5, True, True, False, Colors^.WindowAttr,
                  Colors^.FrameAttr, Colors^.HeaderAttr, 'Band') ;
    DisplayWindow(WinPtr) ;
    repeat
      Band := TOT;
      Str := '';
      ReadString('', 1, 1, 2, Colors^.PromptAttr, Colors^.StringAttr, Colors^.CtrlAttr, Escaped, Str);
      if Str = '80' then Band := B80;
      if Str = '40' then Band := B40;
      if Str = '20' then Band := B20;
      if Str = '15' then Band := B15;
      if Str = '10' then Band := B10;
      if (Band <> TOT) and (not Escaped) then Print_Labels_By_Band;
      PrintQuit := False;
    until Escaped;
    KillWindow(WinPtr);
  end;

  function sPickMenu(Choice : Word) : String; far;
  begin
    case Choice of
      1 : sPickMenu := '1) Open .BIN file';
      2 : sPickMenu := '2) All for specific callsign';
      3 : sPickMenu := '3) All for specific band';
      4 : sPickMenu := '4) All labels';
      5 : sPickMenu := '5) Only country multipliers';
      6 : sPickMenu := '6) Only zone multipliers';
      7 : sPickMenu := '7) Only US/VE multipliers';
      8 : sPickMenu := '8) QSL.INF help';
      9 : sPickMenu := '9) Sort by '+SortStr[SortOnCall];
      10 : sPickMenu := 'X) Exit';
    end;
  end;

  procedure PickMenu;
  var
    Result         : Boolean;
  begin
    TpPick.PickSrch := CharPickNow;
    Result := PickWindow(@sPickMenu, 10, 3, 3, 32, 14, True, Colors^.PickColors,
                         'QSL Label Menu', Choice);
  end;

  procedure IOError(const FName : string);
  var
    WinPtr         : WindowPtr;
    KeyStroke      : Word;
  begin
    MakeWindow(WinPtr, 10, 10, 60, 14, True, True, False,
                  Colors^.WindowAttr, Colors^.FrameAttr, Colors^.HeaderAttr, 'ERROR') ;
    DisplayWindow(WinPtr) ;
    FastWriteWindow('An IO error occurred looking for:', 1, 2, TextAttr);
    FastWriteWindow(FName, 2, 2, TextAttr);
    FastWriteWindow('Check your disk(ette) for possible errors.', 3, 2, TextAttr);
    AnyKey(14, 11);
    repeat until KeyPressed;
    KeyStroke := ReadKeyWord;
    KillWindow(WinPtr);
  end;


  procedure ReadQSLFile;
  var
    QSLFile        : Text;
    B              : Byte;
  begin
    {$I-}
    Assign(QSLFile, 'QSL.INF');
    Reset(QSLFile);
    if IoResult = 0 then begin
      for B := 0 to 5 do
        ReadLn(QSLFile, LineIn[B]);
      Close(QSLFile);
    end
    else
    begin
      LineIn[0] := '<11> Confirms 2xQSO with <1>';
      LineIn[1] := '<7A> <8A> <22A>Mtrs';
      LineIn[2] := 'Mode:RTTY RST:<16> QSL PSE TNX';
      LineIn[3] := '';
      LineIn[4] := '';
      LineIn[5] := '';
    end;
  end;

  function Get_File_Name : Boolean;
  var
    Result         : Integer;
    ans            : Boolean;
  begin
    ans := True;
    if FilesOpened then
    begin
      TAClose(RTTYfile);
      FilesOpened := False;
    end;
    OK := True;
    TPdir.ShowSizeDateTime := True;
    Result := GetFileName('*.BIN', Anyfile, 3, 3, 23, 1, Colors^.PickColors, FName);
    if (Result = 0) and (FName = '') then ans := False;
    if (Result > 0) then ans := False;
    GotoXY(1, 15);
    if ans then
    begin
      IName := Copy(FName, 1, Pos('.', FName))+'NDX';
      AIName := Copy(FName, 1, Pos('.', FName))+'AIX';
      if Not ExistFile(IName) then begin
        IoError(IName);
        Exit;
      end;
      TAOpen(RTTYfile, FName, SizeOf(Log_Rec), IName, SizeOf(Index)-1);
      if not OK then IOError(FName);
      if not OK then ans := False;
    end;
    if ans then
    begin
      ReadQSLFile;
      FilesOpened := True;
    end;
    Get_File_Name := ans;
  end;

  procedure HelpWindow;
  var
    WinPtr         : WindowPtr;
    KeyStroke      : Word;
  begin
    MakeWindow(WinPtr, 3, 3, 67, 23, True, True, False,
                  Colors^.WindowAttr, Colors^.FrameAttr, Colors^.HeaderAttr, 'Help');
    DisplayWindow(WinPtr);
    FastWriteWindow('Use the standard DOS editor to change the QSL.INF file.', 2, 2, TextAttr);
    FastWriteWindow('It is loaded and used as a template for the QSL labels.', 3, 2, TextAttr);
    FastWriteWindow('As each label is printed, variables are substituted', 4, 2, TextAttr);
    FastWriteWindow('in the text file, then it is sent to the printer', 5, 2, TextAttr);
    FastWriteWindow('Variable  Value                            Sample', 6, 2, TextAttr);
    FastWriteWindow('--------  -------------------------------  -----------', 7, 2, TextAttr);
    FastWriteWindow('<1>       His Callsign                     KA1JGB', 8, 2, TextAttr);
    FastWriteWindow('<2>       His Qth                          RI', 9, 2, TextAttr);
    FastWriteWindow('<3>       His Exchange Time                0102', 10, 2, TextAttr);
    FastWriteWindow('<4>       His Serial Number                003', 11, 2, TextAttr);
    FastWriteWindow('<5>       His CQ Zone                      5', 12, 2, TextAttr);
    FastWriteWindow('<6>       His RST                          599', 13, 2, TextAttr);
    FastWriteWindow('<7A>      Date of QSO                      92/12/31', 14, 2, TextAttr);
    FastWriteWindow('<8A>      Time of QSO                      13:30Z', 15, 2, TextAttr);
    FastWriteWindow('NOTE: Tag <11> will ask for a callsign.', 18, 2, TextAttr);
    FastWriteWindow('Refer to the manual for a complete list', 19, 2, TextAttr);
    AnyKey(23, 5);
    repeat until KeyPressed;
    KeyStroke := ReadKeyWord;
    KillWindow(WinPtr);
  end;

begin
  RttyFunction := 'LABELS';
  InitIni;
  Colors := New(PColors, Init);
  CheckBreak := False;
  WindowRelative := True;
  FilesOpened := False;
  ForceUpper := True;
  SortOnCall := False;
  FName := '';
  PickSrch := CharPickNow;
  SetVerticalPick;
  Colors^.SetEntryAttributes;
  MakeWindow(MainWinPtr, 1, 1, 80, 25, True, True, False,
                Colors^.WindowAttr, Colors^.FrameAttr, Colors^.HeaderAttr, rttybywf1b+version+copyright);
  DisplayWindow(MainWinPtr);
  repeat
    PickMenu;
    PrintAll := False;
    PrintQuit := False;
    if PickCmdNum = PKSSelect then
      case Choice of
        1 : if Get_File_Name then {ignore result} ;
        2 : if FilesOpened then Individual;
        3 : if FilesOpened then By_Band;
        4 : if FilesOpened then Print_All_Labels;
        5 : if FilesOpened then PrintCountries;
        6 : if FilesOpened then PrintZones;
        7 : if FilesOpened then PrintStates;
        8 : HelpWindow;
        9 : if FilesOpened then ChangeIndex;
        10 : {exit} ;
      end;
  until ((PKSSelect <> PKSSelect) or (Choice = 10));
  if FilesOpened then TAClose(RTTYfile);
  DeleteFile(AIName);
  KillWindow(MainWinPtr);
  Dispose(RttyIni, Done);
  ClrScr;
  WriteLn(rttybywf1b+version+copyright);
  WriteLn('Written by Ray Ortgiesen, WF1B');
end.
