{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit NAQPName;

interface

uses OpRoot;

type
  PNameData = ^TNameData;
  TNameData = object(SingleListNode)
                Callsign : string[12];
                Name : string[10];
                constructor Init(const aCall : string; const aName : string);
                Destructor Done; virtual;
                function GetName : string;
                procedure SetName(const aName : string);
                function GetCall : string;
                procedure SetCall(const aCall : string);
              end;

  PNameList = ^TNameList;
  TNameList = object(SingleList)
                CurrNode : PNameData;
                constructor Init;
                destructor Done; virtual;
                function Locate(const aCall : string) : boolean;
                function GetName(const aCall : string) : string;
                procedure SetName(const aCall : string; const aName : string);
              end;

var
  NameList : PNameList;

implementation

uses
  DebugRtns,
  OpString;

constructor TNameData.Init(const aCall : string; const aName : string);
begin
  if not inherited Init then Fail;
  Name := Trim(aName);
  Callsign := Trim(aCall);
end;

Destructor TNameData.Done;
begin
  inherited Done;
end;

function TNameData.GetName : string;
begin
  GetName := Name;
end;

procedure TNameData.SetName(const aName : string);
begin
  Name := Trim(aName);
end;

function TNameData.GetCall : string;
begin
  GetCall := Callsign;
end;

procedure TNameData.SetCall(const aCall : string);
begin
  Callsign := Trim(aCall);
end;


constructor TNameList.Init;
begin
  inherited Init;
    {$IFDEF DEBUG}
    AppendDebugMessage('NameList created');
    {$ENDIF}
end;

destructor TNameList.Done;
begin
  inherited Done;
    {$IFDEF DEBUG}
    AppendDebugMessage('NameList destroyed');
    {$ENDIF}
end;

function TNameList.Locate(const aCall : string) : boolean;
var
  Found : Boolean;
begin
  Found := False;
  CurrNode := PNameData(Head);
  while (CurrNode <> nil) and (not Found) do
    if CurrNode^.GetCall = Trim(aCall) then Found := True
                                       else CurrNode := PNameData(Next(CurrNode));
  Locate := Found;
end;

function TNameList.GetName(const aCall : string) : string;
begin
  if Locate(aCall) then
    Getname := CurrNode^.GetName
  else
    GetName := '';
end;

procedure TNameList.SetName(const aCall : string; const aName : string);
var
  bName : string[10];
begin
  if Locate(aCall) then
    {nothing to do, already in the list}
  else begin
    if Length(aName) > sizeof(bName) then bName := Copy(aName,1,sizeof(bName))
                                     else bName := aName;
    CurrNode := New(PNameData, Init(aCall, aName));
    Append(CurrNode);
  end;
end;

end.