{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program NetMon;

uses
  ApPort,
  ApUart,
  OoCom,
  Network,
  cMsgWin,
  ApMisc,
  OpString,
  IniTools,
  LowLvl,
  RecTypes,
  ApTimer,
  TpCrt,
  TpString,
  cRttyWin,
  DebugRtns,
  IniFile;

var
  UP : UartPortPtr;
  LastAsyncStatus : word;
  c : char;
  Com : ComNameType;


  procedure AsyncInit;
  var
    S : String[4];
    Irq : Byte;
    Vector : Byte;
    BaseAddr : Word;
    w : word;
  begin
    BaseAddr := 0;
    ps2detectmode := ps2ignore;
    ActivateApUart; {REQUIRED!!! .., in order to use upper interupts}
    write('Which comport?<1>   ');readln(s);
    case s[1] of
      '1' : com := com1;
      '2' : com := com2;
      '3' : com := com3;
      '4' : com := com4;
      '5' : com := com5;
      '6' : com := com6;
      '7' : com := com7;
      '8' : com := com8;
    else
      Com := com1;
    end;
    com := ComNameType(ord(s[1])-ord('1'));
    write('Which irq?<default> ');readln(s);
    if not Str2word(s,w) then Irq := 0 else Irq := w;
    case Irq of
     $05 : Vector := $0D;
     $06 : Vector := $0E;
     $07 : Vector := $0F;
     $08 : Vector := $70;
     $09 : Vector := $71;
     $0A : Vector := $72;
     $0B : Vector := $73;
     $0C : Vector := $74;
     $0D : Vector := $75;
     $0E : Vector := $76;
     $0F : Vector := $77;
    else
      Vector := $00;
    end;
    SetUart(Com, BaseAddr, Irq, Vector);
  end;


function GetCheckDigit(Data : string) : byte;
var
  b : byte;
  i : integer;
begin
  Data[4] := cNUL;
  i := 0;
  for b := 0 to Ord(Data[0])-1 do
    inc(i, ord(Data[b]));
  GetCheckDigit := i mod 255;
end;

procedure ShowBlock(Block, SMsg : String);
var
  s,s1 : string;
  i : integer;
  j : integer;
  st : string[10];
begin
  Case Block[1] of
   #$00 : Exit;
   #$01 : st := 'Ping';
   #$02 : st := 'Pong';
   #$03 : st := 'Note';
   #$04 : st := 'Date';
   #$05 : st := 'Log Rec';
   #$06 : st := 'Qrg Data';
   #$07 : st := 'Qrg Req';
   #$08 : st := 'Del Rec';
   #$09 : st := 'Ser# Req';
   #$0A : st := 'Ser# Data';
   #$0B : st := 'Clst TX';
   #$0C : st := 'Clst RX';
   #$0D : st := 'CWS Data';
   #$0E : st := 'TEST Data';
  else
    begin
      st := 'INVALID';
      sound(1000);delay(250);sound(2000);delay(250);
      sound(1000);delay(250);sound(2000);delay(250); nosound;
    end;
  end;
  writeln(Copy(Pad(st,10),1,10)+
                       'Id=$'+hexb(ord(block[1]))+
                     ', Sz=$'+hexb(ord(block[0]))+
                     ', Orig=$'+hexb(ord(block[2]))+
                     ', Dest=$'+hexb(ord(block[3]))+
                     ', CheckDig=$'+hexb(ord(block[4])));
  s := '';
  s1 := '';
  j := 0;
  for i := 5 to length(Block)-1 do begin
    s  := s  + hexb(ord(block[i]))+' ';
    if block[i] = #$0A then
      s1 := s1 + 'LF '
    else if block[i] = #$07 then
      s1 := s1 + 'BL '
    else
      s1 := s1 + block[i]+'  ';
    inc(j);
    if j = 16 then begin
      if (Paramstr(1) = '1') or (Paramstr(2) = '1') then
        writeln(Copy(Pad('1',10),1,10)+s);
      s := '';
      j := 0;
    end;
  end;
  if j > 0 then
    if (Paramstr(1) = '1') or (Paramstr(2) = '1') then
      writeln(Copy(Pad('2',10),1,10)+s);
 if (Paramstr(1) = '2') or (Paramstr(2) = '2') then
  writeln(Copy(Pad(SMsg,10),1,10)+s1);
end;

function TransmitBlock(var Block : String) : boolean;
var
  BytesWritten : word;
  BlockLen : word;
  cd : byte;
  l : byte;
  et : eventtimer;
begin
  cd := GetCheckDigit(Block);
  Block[4] := chr(cd);
  L := byte(Block[0]);
  BlockLen := word(l);
  UP^.PutBlock(Block[0], BlockLen, BytesWritten);
  LastAsyncStatus := AsyncStatus;
  while not UP^.CheckTE do; { wait for 'T'ransmitter to 'E'mpty }
end;

function ReceiveBlock(var Block : String) : boolean;
var
  c       : char;
  RestOfBlock : word;
  ActualGetSize : word;
  et : EventTimer;
  Br : boolean;
begin
  ReceiveBlock := False;
  if not UP^.CharReady then Exit;
{  FillChar(Block, SizeOf(Block), cNUL); }
  UP^.GetChar(C);
  LastAsyncStatus := AsyncStatus;
  if (C = #$FF) or
     (C = cNUL) or
     (LastAsyncStatus <> ecOK) then Exit;
  Block[0] := c;
  RestOfBlock := word(ord(c)-1);
  NewTimer(Et, 27); {wait up to 1.5 seconds}
  repeat
    br := UP^.BlockReady(RestOfBlock,[]);
  until TimerExpired(Et) or Br;
  if not Br then begin
    writeln('Incomplete block received'+
                       'Id=$'+hexb(ord(block[1]))+
                     ', Sz=$'+hexb(ord(block[0]))+
                     ', Orig=$'+hexb(ord(block[2]))+
                     ', Dest=$'+hexb(ord(block[3]))+
                     ', CheckDig=$'+hexb(ord(block[4])));
    FillChar(Block, SizeOf(Block), cNUL);
    Exit;
  end;
  UP^.GetBlockTimeOut(Block[1],RestOfBlock,ActualGetSize,[],27);
  LastAsyncStatus := AsyncStatus;
  if Ord(Block[4]) = GetCheckDigit(Block) then
    ReceiveBlock := True
  else begin
    writeln('Check digit invalid'+
                       'Id=$'+hexb(ord(block[1]))+
                     ', Sz=$'+hexb(ord(block[0]))+
                     ', Orig=$'+hexb(ord(block[2]))+
                     ', Dest=$'+hexb(ord(block[3]))+
                     ', CheckDig=$'+hexb(ord(block[4]))+
                     ', CalcDig=$'+hexb(ord(GetCheckDigit(Block))));
    ShowBLock(Block,'Inv chk#');
    FillChar(Block, SizeOf(Block), cNUL);
  end;
end;



begin
  clrscr;
  AsyncInit;
  if (Paramstr(1) = '?') or (Paramstr(2) = '?') then begin
    writeln;
    writeln('Usage:');
    writeln('      NETMON 1 2');
    writeln;
    writeln('1= hex notation');
    writeln('2= raw data');
    writeln;
    halt;
  end;
  writeln('Network monitor '+ComNameString(com)+', 2400 baud');
   UP := New(UartPortPtr, InitFast(COM, 2400));
  UP^.HWFlowDisable;
  UP^.SWFlowDisable;
  while not KeyPressed do begin
    if ReceiveBlock(Block) then begin
      ShowBlock(Block,'Block:');
      TransmitBlock(Block);
    end;
  end;
  if Assigned(UP) then Dispose(UP, Done);
end.

