{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program NetTest;
{$DEFINE NETTEST}
{$DEFINE TRACING}
{$DEFINE EVENTLOGGING}
{$DEFINE STANDARDLOGGING}
uses
  NetWork,
  ApMisc,
  ApPort,
  ApUart,
  TpCrt,
  RecTypes,
  TpDate,
  IniFile,
  Diskio,
  OpString;

var
  S     : string;
  sid   : byte;
  c     : char;
  done  : boolean;
  cp    : comnametype;
  ar    : log_rec;
  i     : word;

begin
  {$IFNDEF NETTEST}
  bzzzt! need that define so this will work as a standalone utility
  {$ENDIF}

  i := 1;
  InitIni;
  InitNetwork;
  InitEventLogging(2000);
  InitTracing(2000);
  ClrScr;
  TextColor(Green);
  TextBackground(Black);
  WriteLn('NetTest.Exe : A networking test utility');
  writeln;
  writeln('Commands:');
  writeln('');
  writeln('alt-x    Quit');
  writeln('1..8     Ping Station #');
  writeln('         (see if connection is valid to station)');

  repeat
    Net^.Idle;
    normvideo;
    S := Net^.LastMessage;
    TextColor(Green);
    TextBackground(Black);
    if S  <> '' then begin
      Writeln('*'+s+'*');
      sound(2000);delay(200);nosound;
    end;
    case ord(Block[1]) of
      NoteDataId : Writeln(N.Note);
    end;
    {Process chars to send}
    if KeyPressed then begin
      C := ReadKey;
      if C = #0 then
        Done := ReadKey = #$2D
      else begin
        if c in ['1'..'8'] then begin
          Net^.SendPing(ord(C)-ord('0')) ;
          sound(1000);delay(400);nosound;
        end;
      end;
    end;

  until Done;
  DumpTrace('NETTEST.TRC');
  DumpEvents('NETTEST.LOG');
end.