{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit OneTimers;
interface

procedure AddCmd(const Cmd : Word; const Key : word);
procedure AddMyCommands;
procedure FinalProgramClose;
procedure InitialProgramSetup;
procedure ProcessParameters;
function RecoverError : Boolean;
procedure RTTYCheck;
procedure SetScreenSizeAndAttrs;
procedure Terminate(Code : Byte);
procedure CloseDownScreen;


implementation
uses
  ApUart,
  ApPort,
  TAccess,
  TAHigh,
  TpCrt,
  TpDate,
  TpDos,
  TpEnhKbd,
  TpEntry,
  TpErrhan,
  TpInt24,
  TpMouse,
  TpPick,
  TpRarray,
  OpString,
  TpWindow,
  TpDir,
  cColors,
  ClusterTerm,
  Keys,
  LowLvl,
  RecTypes,
  Diskio,
  CCountry,
  cDupeTbl,
  WrkSheet,
  Inform,
  Notes,
  SendFile,
  Routines,
  cCallQue,
  TncControl,
  CmdLnObj,
  cRttyWin,
  cTopWin,
  cBotWin,
  Dos,
  IniTools,
  QtcSObj,
  QtcRObj,
  c_radio,
  csernum,
  clustermon,
  cEditWin,
  cRateWin,
  cScoreWin,
  Network,
  C_Contest,
  cZone,
  cEaTbl,
  cSpTbl,
  cITbl,
  cRTbl,
  cMsgWin,
  cDist_W,
  cDist_VE,
  cDist_VK,
  cDist_JA,
  cDist_ZL,
  cContinent,
  cState,
  cProvince,
  cClock,
  TpEdit,
  DebugRtns,
  OvrTrick,
  IniFile;


  function RecoverError : Boolean;
  var
    I : Word;
    msg : string[79];
  begin
    I := IoResult;
    if I > 0 then Msg := 'RTTY I/O ERROR: '+long2str(I)
             else Msg := 'RTTY Runtime ERROR: '+Long2str(ExitCode);
{    Msg := Msg + ' '+HexW(Seg(ErrorAddr^))+':'+HexW(Ofs(ErrorAddr^))+' '; }
    if I > 0 then begin
      if MessageBox('Runtime I/O Error',
                 'An error occurred while handling file I/O',
                 'Press <enter> to attempt to continue',
                 'Press <esc> to terminate RTTY') = HitEnter then begin
        RecoverError := True;
        AppendDebugMessage(Msg); { put message everytime }
        Exit;
      end;
    end;
    RecoverError := False;
    AppendDebugMessage(Msg); { put message everytime }
    Assign(Output,'');
    Rewrite(Output);
    WriteLn;
    WriteLn(Msg);
    WriteLn;
  end;

  procedure Terminate(Code : Byte);
  var
    T : String[79];
    M : Char;
  begin
    case DupeTbl^.GetMax of
      500 : M := '1';
      1000 : M := '2';
      2000 : M := '3';
      3000 : M := '4';
    end;
    if Assigned(RttyTerm1) then
      Dispose(RttyTerm1,Done);
    if (not Code in [103, 106]) then
      begin
        Dispose(RttyWin, Done);
        KillWindow(EditWin);
      end;
    case Code of
      001 : T := 'Country file error.';
      002 : T := 'Prefix file error.';
      003 : T := 'Unable to load Work Sheet.';
      004 : T := 'Fatal disk error. Check disk drive.';
      005 : T := 'Unable to create/load data files.';
      006 : T := 'Insufficient memory to continue. Maximize low memory!';
      007 : T := 'Unable to initialize communications port';
      008 : T := 'Fatal IO Error during NOTES operation';
      010 : T := 'Invalid address for PCI-3000';
      { over 100 for no close on data base }
      100 : T := 'Non-compatible work sheet file';
      101 : T := 'No file name entered.';
      102 : T := 'Invalid file, unable to open.';
      103 : T := 'Insufficient memory to continue.';
      104 : T := 'Unable to find Country (.CTY) file';
      105 : T := 'Unable to find Prefix (.PFX) file';
      106 : T := 'Restart using -'+M+'K parameter.  Exceeded Max QSO Count Parameter';
      107 : T := 'Unable to open CTY.DAT file';
      111 : T := 'Invalid file name entered, no spaces or punctiation';
      200 : if TAStatus < 1000 then T := TurboError(TAStatus)
            else T := TAError(TAStatus);
    end;
    AppendDebugMessage('Err#'+Long2Str(Code)+': '+T);
    NormVideo;
    NormalCursor;
    ClrScr;
    Writeln(RTTYbyWF1B+Version+Copyright);
    WriteLn('RTTY: Err#'+Long2Str(Code)+': '+T);
    Halt;
  end;

  procedure RTTYCheck;
  var
    W1, w2 : Word;
    B : Byte;
  begin
    W1 := 0;
    W2 := 0;
    for B := 1 to Length(RTTYbyWF1B) do
      W1 := W1+Ord(rttybywf1b[B]);
    for B := 1 to Length(copyright) do
      W2 := W2+Ord(copyright[B]);
    if (W1 <> 894) or (W2 <> 3606) then
      begin
        ClrScr;
{        writeln('w1='+long2str(w1));
        writeln('w2='+long2str(w2));
        halt;}
        WriteLn('RTTY: has been modified and will not run.');
        WriteLn('RTTY: Reinstall from original diskette.');
        Halt;
      end;
  end;

  procedure SetScreenSizeAndAttrs;
  begin
    BiosScroll := False;
    GetCrtMode;
    MW_Xlo := 1;
    MW_xhi := Lo(ScreenWidth)-12;
    MW_Ylo := 1;
    MW_Yhi := Lo(ScreenHeight)-7;
    EW_Xlo := 1;
    EW_Xhi := 53;
    EW_Ylo := Lo(ScreenHeight)-2;
    EW_Yhi := Lo(ScreenHeight);
    ActionBarLine := Lo(ScreenHeight)-7;
    QSOinLine := Lo(ScreenHeight)-1;
    SetVerticalPick;
  end;

  procedure AddCmd(const Cmd : Word; const Key : word);
  begin
    AddEntryCommand(Cmd, 1, RttyIni^.GetProfileWord('$'+Hexw(Key),'KEYMAP',Key), 0); { pop up menu }
  end;


  procedure AddMyCommands;
  var
    Key : word;
  begin
    AddCmd(ESmy0,kbAltQ);
    AddCmd(ESmy1,kbAltI);
    AddCmd(ESmy2,kbAltT);
    AddCmd(ESmy3,kbAltU);
    AddCmd(ESmy4,kbAltP);
    AddCmd(ESmy5,kbAltS);
    AddCmd(ESmy6,kbAltH);
    AddCmd(ESmy7,kbAltK);
    AddCmd(ESmy8,kbAltZ);
    AddCmd(ESmy9,kbAltX);
    AddCmd(ESmy10,kbAltL);
    AddCmd(ESmy11,kbAltN);
    AddCmd(ESmy12,kbAltM);
    AddCmd(Esmy13,kbF1);
    AddCmd(Esmy14,kbF2);
    AddCmd(Esmy15,kbF3);
    AddCmd(Esmy16,kbF4);
    AddCmd(ESmy17,kbF5);
    AddCmd(ESmy18,kbF6);
    AddCmd(Esmy19,kbF7);
    AddCmd(ESmy20,msLeftClick);
    AddCmd(ESmy21,msRightClick);
    AddCmd(ESmy22,kbAltD);
    AddCmd(ESmy23,kbHome);
    AddCmd(ESmy24,kbCtrlUp);
    AddCmd(ESmy25,kbEnd);
    AddCmd(ESmy26,kbCtrlDown);
    AddCmd(ESmy27,kbPgDn);
    AddCmd(ESmy28,kbIns);
    AddCmd(ESmy28,kbGrayPlus); { 2 keys, same command }
    AddCmd(ESmy29,kbAltW);
    AddCmd(ESmy30,kbCtrlF1);
    AddCmd(ESmy31,kbAltF);
    AddCmd(ESmy32,kbCtrlF9);
    AddCmd(ESmy33,kbCtrlF3);
    AddCmd(ESmy34,kbCtrlF5);
    AddCmd(ESmy35,kbCtrlF6);
    AddCmd(ESmy36,kbCtrlF7);
    AddCmd(ESmy37,kbF12);
    AddCmd(ESmy38,kbCtrlF10);
    AddCmd(ESmy39,kbAltF1);
    AddCmd(ESmy40,kbAltF2);
    AddCmd(ESmy41,kbCtrlF4);
    AddCmd(ESmy42,kbAltC);
    AddCmd(ESmy43,kbAltA);
    AddCmd(ESmy44,kbAltB);
    AddCmd(ESmy45,kbAltE);
    AddCmd(ESmy46,kbAltG);
    AddCmd(EsMy47,kbAltO);
    AddCmd(ESmy48,kbAltP);
    AddCmd(Esmy49,kbEsc);
    AddCmd(Esmy50,kbF8);
    AddCmd(ESmy51,kbF9);
    AddCmd(Esmy52,kbF10);
    AddCmd(Esmy53,kbAltEqual);
    AddCmd(Esmy54,kbGrayAster);
    AddCmd(ESmy55,kbAltF3); { send packet spot }
    AddCmd(ESmy56,kbAltV);
    AddCmd(EsMy60,kbShiftF1);
    AddCmd(EsMy61,kbShiftF2);
    AddCmd(EsMy62,kbShiftF3);
    AddCmd(EsMy63,kbShiftF4);
    AddCmd(EsMy64,kbShiftF5);
    AddCmd(EsMy65,kbShiftF6);
    AddCmd(EsMy66,kbShiftF7);
    AddCmd(EsMy67,kbShiftF8);
    AddCmd(EsMy68,kbShiftF9);
    AddCmd(EsMy69,kbShiftF10);
    if Contest = WAED then begin
      AddCmd(EsMy70,kbCtrlS);
      AddCmd(EsMy71,kbCtrlR);
      AddCmd(EsMy72,kbCtrlA);
    end;
    AddCmd(EsMy73,kbCtrlPgUp);
    AddCmd(EsMy74,kbCtrlPgDn);
    AddCmd(EsMy99,$2960);
    { highest command: EsMy99 }
  end;

  procedure Async_Init;
    { initialize variables }
  var
    S : String[4];
    T : String[7];
    Irq : Byte;
    Vector : Byte;
    BaseAddr : Word;
    Com : ComNameType;
  begin
    ps2detectmode := ps2ignore;
    ActivateApUart; {REQUIRED!!! .., in order to use upper interupts}
    for Com := Com1 to Com8 do begin
      S := ComNameString(Com);
      Irq := RttyIni^.GetProfileByte('IrqNumber', S, 0);
      case Irq of
       $05 : Vector := $0D;
       $06 : Vector := $0E;
       $07 : Vector := $0F;
       $08 : Vector := $70;
       $09 : Vector := $71;
       $0A : Vector := $72;
       $0B : Vector := $73;
       $0C : Vector := $74;
       $0D : Vector := $75;
       $0E : Vector := $76;
       $0F : Vector := $77;
      else
             Vector := $00;
      end;
      BaseAddr := RttyIni^.GetProfileWord('BaseAddr', S, 0);
      if BaseAddr = 0 then {Try for both spellings}
        BaseAddr := RttyIni^.GetProfileWord('BaseAddress', S, 0); {v2.5a}
      SetUart(Com, BaseAddr, Irq, Vector);
    end;
  end;                            { Async_Init }




  procedure PopupBinList;
  var
    Result : Integer;
    FileName : String[79];
  begin
    ShowSizeDateTime := True;
    PickSrch := StringPickSrch;
    SetVerticalPick;
    Result := GetFileName('*.BIN', AnyFile, 1, 3, ScreenHeight, 1, Colors^.PickColors, FileName);
    if ((Result = 0) and (FileName = '')) or ((Result > 0)) then FileName := '';
    InputFileName := CleanPathName(FileName);
  end;


  procedure ProcessParameters;
  var
    AskedForHelp : Boolean;
  begin
    CmdLn := New(PCmdLnObj, Init);
    with CmdLn^ do begin
      if ExistSwitch('NOEMS') then { remove switch from line, handled in ovrtrick};
      ByPassWorkSheet := ExistSwitch('NOW');
      FastStart := ByPassWorksheet;
      if ExistSwitch('MIN') then RttyIni^.SetOrAddProfileString('MaxQsos','PROFILE','500');
      if ExistSwitch('1K') then RttyIni^.SetOrAddProfileString('MaxQsos','PROFILE','1000');
      if ExistSwitch('2K') then RttyIni^.SetOrAddProfileString('MaxQsos','PROFILE','2000');
      if ExistSwitch('3K') then RttyIni^.SetOrAddProfileString('MaxQsos','PROFILE','3000');
      if ExistSwitch('4K') then RttyIni^.SetOrAddProfileString('MaxQsos','PROFILE','4000');
      if ExistSwitch('5K') then RttyIni^.SetOrAddProfileString('MaxQsos','PROFILE','5000');
      if ExistSwitch('NOADVICE') then RttyIni^.SetOrAddProfileString('Advice','PROFILE','False');
      AskedForHelp := ExistSwitch('?');
      if (AskedForHelp) or (ParameterCount > 1) or (SwitchCount > 0) then begin
        WriteLn('Usage:');
        WriteLn(' RTTY [-MONO] [-nK] [-NOADVICE] filename');
        WriteLn('  -nK       Number of QSOs to handle(in thousands)');
        WriteLn('  -NOADVICE Bypass the QSO logging Advisor');
        WriteLn('  -MIN      Use minimum number of QSO''s (500)');
        WriteLn('  -NOW      Bypass the worksheet');
        WriteLn('  filename  is .BIN file');
        Halt;
      end;
      if ParameterCount = 0 then begin
        ClrScr;
        WriteLn(rttybywf1b+version+copyright);
        WriteLn('Enter the worksheet name or <Enter> for a list');
        Write('File Name: ');
        InputFileName := '';
        ReadLn(InputFileName);
        if Trim(InputFileName) = '' then begin
          InputFileName := '';
          PopupBinList;
        end;
        InputFileName := Trim(InputFileName);
        if InputFileName = '' then Terminate(101); {normal terminate}
      end
      else
        InputFileName := Parameter(1);
      InputFileName := CleanPathName(StUpCase(ForceExtension(InputFileName, '')));
      if not GoodFileName(InputFileName) then Terminate(111); {file name error}
    end;
    Dispose(CmdLn, Done);
  end;

  procedure InitialProgramSetup;
  var
    a : log_rec;
    I : Integer;
    Band : BandType;

    procedure InitMouse;
    begin
      MouseCall := '';
    end;

  begin
    ClrScr;
    AppendDebugMessage('First RTTY Instruction Executed at: '+OvrTrick.StartTime);
    if not HasEnhancedKbd then
      AppendDebugMessage('Enhanced Keyboard NOT detected');
    if FiltersEnhanced then
      AppendDebugMessage('BIOS filters enhanced keystrokes');
    InitIni;
    RTTYCheck;
    Async_Init;
    Clock := New(PClock, Init);
    SerNum := New(PSerNum, Init);
    Colors := New(PCOlors, Init);
    DataLine := '';
    RttyFunction := 'RTTY';
    InitLowLvl;
    InitMouse;
    QSOTimeSet := False;
    GetOut := False;
    HandlingNetQso := False;
    Ccall := '';
    CatchCall := False;
    gInMainLoop := False;
    ErrorRecovery(True, @RecoverError);
    SetScreenSizeAndAttrs;
    ProcessParameters;
    RttyWin := New(PRttyWin, Init);
    with Colors^ do begin
      if not MakeWindow(EditWin, 1, MW_Yhi+1, ScreenWidth-24, ScreenHeight-1, False, True, True,
        WindowAttr, FrameAttr, HeaderAttr, '') then NotEnoughMemory(True);
      if not MakeWindow(TuneWin, 61, EW_Ylo, ScreenWidth, EW_Yhi, False, True, True,
        WindowAttr, FrameAttr, HeaderAttr, '') then NotEnoughMemory(True);
      WindowRelative := True;
      DisplayWindow(EditWin);
      DisplayWindow(TuneWin);
      FastWrite(Charstr('', 12), 7, MW_xhi+1, FrameAttr); { div b/w call & country }
      FastWrite('', 7, MW_xhi, FrameAttr);
      FastWrite(Charstr('', 12), 14, MW_xhi+1, FrameAttr); { div b/w country & time since last qso }
      FastWrite(Charstr('', 12), 16, MW_xhi+1, FrameAttr); { div b/w time since last qso & rate }
      FastWrite(Charstr('', 12), 18, MW_xhi+1, FrameAttr); { div b/w rate & packet }
      RttyWin^.MakeTop;
    end;
    Contest := PeekAtBinContest; { if file existed, which one was it? }
    InitWrkSheet;
    EditWorkSheet;
    { CANNOT put to screen until after this point!!!! }
    RttyWin^.HilightOff;
    MakeContest;
    if (RttyIni^.GetProfileString('F1','FKeys','*#*#') = '*#*#') or
       (NOT ExistFile(FileName('BIN'))) then ThisContest^.ReadDefaultFKeys;
    DataCount := RttyIni^.GetProfileByte('DataCount', 'Profile', 40);
    EditW := New(PEditWin, Init);
    if (DataCount = 0) or (DataCount > 79) then DataCount := 80;
    if Trim(RttyIni^.GetProfileString('Call','Profile','')) = '' then begin
      MyContinent := 'NA';
      MyCountry := 'W';
      MyDistrict := 1;
    end
    else with CountryList^ do begin
      LogFile^.BlankLogRec(a);
      a.Call := Trim(RttyIni^.GetProfileString('Call','Profile',''));
      if Identify(a) <> NoCountry then begin
        MyContinent := Ct.Continent;
        MyCountry := Trim(Ct.Code);
      end;
      MyDistrict := WDistList^.GetDistNo(RttyIni^.GetProfileString('Call','Profile',''));
    end;
    RttyWin^.PutString(cCr+'Memory allocated for '+Long2Str(DupeTbl^.GetMax)+' QSOs.');
    RttyWin^.PutString(cCr+'Loading '+FileName('BIN'));
    EditW^.EditRecs[1].Band := B20;
    EditW^.EditRecs[1].Mode := RTTYMODE;
    EditW^.EditRecs[1].Contest := Contest;
    RttyWin^.PutString(cCr+Long2Str(LogFile^.LoadData)+' QSOs loaded.');
    MakeRadio;
    InitNetwork;
    InitCluster;
    CountryList^.BlankCTRec;
    RttyWin^.MakeTop;
    SetMyInfo;
  end;

  procedure FinalProgramClose;
  begin
    HideMouse;
    DisposeEditScreen(EntryEsr);
    if MouseInstalled            then DisableEventHandling;
    if Assigned(RttyTerm1)       then Dispose(RttyTerm1,Done);
    if Assigned(ClusterTerminal) then Dispose(ClusterTerminal, Done);
    if Assigned(Net)             then Dispose(Net, Done);
    if Assigned(Radio)           then KillRadio;
    if Assigned(SerNum)          then Dispose(SerNum, Done);
    if Assigned(Clock)           then Dispose(Clock, Done);
    if Assigned(ThisContest)     then KillContest;
    if Assigned(Colors)          then Dispose(Colors, Done(True));
    if Assigned(RttyIni)         then Dispose(RttyIni, Done);
    CloseDownScreen;
    AppendDebugMessage('---------- Session Ends ----------');
  end;

  procedure CloseDownScreen;
  begin
    Dispose(RttyWin, Done);
    if Assigned(EditW) then Dispose(EditW, Done);
    if Assigned(MsgWin) then Dispose(MsgWin, Done);
    if Assigned(TopWin) then Dispose(TopWin, Done);
    if Assigned(BotWin) then Dispose(BotWin, Done);
    if Assigned(RateWin) then Dispose(RateWin, Done);
    if Assigned(ScoreWin) then Dispose(ScoreWin, Done);
    KillWindow(EditWin);
    KillWindow(TuneWin);
    NormVideo;
    Window(1,1,ScreenWidth, ScreenHeight);
    ClrScr;
    WriteLn(rttybywf1b+version+copyright);
    WriteLn('Written by Ray Ortgiesen, WF1B');
  end;


end.
