{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{
  This unit is required to initialize the Overlay unit.  It needs to be
  here so that it runs OvrInit BEFORE any other units that have
  initialization code run.  Any questions? Read RunTime Error 208!
}

{$I APDEFINE.INC}

unit OvrTrick;

interface

const
  ExtraSize = 32*1024;            {32K}
var
  Message : string[59];
  StartTime : string[8];

implementation

uses
  {$IFNDEF DPMI}
  Overlay,
  OverXMS,
  {$ENDIF}
  TpDate;

begin
  StartTime := CurrentTimeString('hh:mm:ss');
  {$IFNDEF DPMI}
  WriteLn('Initializing RTTY overlay system...');
{  OvrInit('RTTY.EXE'); }

  if OvrResult <> ovrOk then begin
    WriteLn('Warning! Using RTTY.OVR for system overlay.');
    ReadLn;
    OvrInit('RTTY.OVR');
  end;
  if OvrResult <> ovrOk then begin
    WriteLn('Overlay file ''RTTY.EXE'' could not be found.');
    WriteLn('or the original RTTY.EXE program was renamed.');
    WriteLn('Please check for this file in the RTTY directory.');
    WriteLn('If not found, then reinstall from diskette.');
    Halt(1);
  end;
  OvrInitXMS;
  Message := '';
  If OvrResult = 0 then Message := 'XMS is begin utilized';
  If OvrResult <> OvrOk Then begin
    OvrInitEMS;
    If OvrResult = 0 then Message := 'EMS is begin utilized';
  end;
  If message = '' then Message := 'Neither XMS or EMS ar begin used';
  {$ENDIF}
end.
