{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program Rewrite;

uses
  TpString, Diskio, TpCrt, TpDate, TAccess, LowLvl, RecTypes;

var
  scrap : log_rec;
  index : string[8];
  RecordNumber : LongInt;
  DatF : DataFile;
  IndexF : IndexFile;
  DatName, Indname : String[20];
  Ts : Time;
  TimeOut : Byte;
  Num : Word;
  HoldSerno : Word;
  HoldTime : Time;
  HoldDate : Date;
  C : Byte;
  Hr, Mn, Sc : Byte;
  Da, Mo, Yr : Integer;
begin
  ClrScr;
  WriteLn('Rewrite Utility');
  DatName := '';
  Num := 0;
  if ParamCount = 1 then
    DatName := ParamStr(1)
  else begin
    Write('Bin File Name: ');
    ReadLn(DatName);
  end;
  DatName := ForceExtension(DatName, 'BIN');
  OpenFile(DatF, DatName, SizeOf(Scrap));
  if not OK then begin
    Write('REBUILD: Open bin file failed.');
    Halt;
  end;
  Indname := ForceExtension(DatName, 'NDX');
  MakeIndex(IndexF, Indname, SizeOf(Index)-1, NoDuplicates);
  if not OK then begin
    Write('REBUILD: Make new index failed.');
    Halt;
  end;
  C := 0;
  HoldSerno := 0;
  HoldDate := 0;
  HoldTime := 0;
  for RecordNumber := 1 to FileLen(DatF)-1 do begin
    GetRec(DatF, RecordNumber, Scrap);
    if not OK then begin
      Write('REBUILD: Get data failed at rec:');
      WriteLn(RecordNumber);
      Halt;
    end;
    if (Scrap.Call = 'DELETE') and (Scrap.ToolBoxNumber = 0) then DeleteRec(DatF, RecordNumber);
    if Scrap.ToolBoxNumber = 0 then begin
      TimeOut := 0;

      { special logic here! }
{    DateToDMY(Scrap.Date, Da, Mo, Yr);
    if Yr = 1900 then begin
      writeln('DELETED!'+scrap.call);
      DeleteRec(DatF, RecordNumber);
    end;}

{      DateToDMY(Scrap.Date, Da, Mo, Yr);
      TimeToHMS(Scrap.Ts, Hr, Mn, Sc);
      if (Mo=6) and (Da =13) then begin
        Mo := 9;
        Da := 26;
        Scrap.Date := DMYtoDate(Da, Mo, Yr);
        Scrap.Ts := HMStoTime(Hr, Mn, Sc);
      end;
      if (Mo=6) and (Da=14) then begin
        Mo := 9;
        Da := 27;
        Scrap.Date := DMYtoDate(Da, Mo, Yr);
        Scrap.Ts := HMStoTime(Hr, Mn, Sc);
      end;

{      if Mn > 8 then Dec(Mn, 8)
      else begin
        Mn := Mn+60-8;
        if Hr > 0 then Dec(Hr, 1)
        else begin
          Hr := 23;
          Dec(Da, 1);
        end;
      end;
      if Hr > 3 then Dec(Hr, 4)
      else begin
        Hr := Hr+24-4;
        Dec(Da, 1);
      end; }

{      if yr = 97 then yr := 98;
      if yr = 1997 then yr := 1998;

      Scrap.Date := DMYtoDate(Da, Mo, Yr);
      Scrap.Ts := HMStoTime(Hr, Mn, Sc); }
      Scrap.My_Qth := Trim('CA');
      PutRec(DatF, RecordNumber, Scrap);

      { end special logic ... }
{      if Scrap.Call = 'IV3AS' then begin
        Scrap.Call := 'IV3KAS';
        PutRec(DatF, RecordNumber, Scrap);
      end;
      { end special logic ... }

      Ts := Scrap.Ts;
      Index := DateToSortString(Scrap.Date)+TimeToSortString(Ts);
      AddKey(IndexF, RecordNumber, Index);
      while not OK do begin
        Inc(Ts);
        Index := DateToSortString(Scrap.Date)+TimeToSortString(Ts);
        AddKey(IndexF, RecordNumber, Index);
        Inc(TimeOut);
        if TimeOut = 50 then begin
          Write('REBUILD: Create index failed at rec:');
          WriteLn(RecordNumber);
          Halt;
        end;
      end;
    end;
    Inc(C);
    if C = 100 then begin
      Write(Long2Str(RecordNumber)+'...');
      C := 0;
    end;
  end;
  WriteLn;
  CloseFile(DatF);
  CloseIndex(IndexF);
  WriteLn('New index created: '+Indname);
end.
