{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program ReIndex;

uses
  TpString,
  TpCrt,
  TpDate,
  TAccess,
  LowLvl,
  Diskio;

var
  RecordNumber   : LongInt;
  DatF           : DataFile;
  IndexF         : IndexFile;
  DatName, Indname : String[20];
  TimeOut          : byte;
  Num            : Word;
  C              : Byte;
  a              : log_rec;
  index          : string[8];
  RemDupes       : Boolean;
  FixSCC         : Boolean;

CONST
  HeaderData : Array[0..87] of byte = (
  $FF,$FF,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$57,$00,$00,$00,
  $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
  $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
  $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
  $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
  $00,$00,$00,$00,$00,$00,$00,$73);

  procedure RewriteHeader;
  var
    FromF, ToF : file;
    NumRead, NumWritten : Word;
    Buf : array[1..4096] of Char;
  begin
    { make backup copy of data file }
    Assign(FromF, DatName);             { Open input file }
    Reset(FromF, 1);              { Record size = 1 }
    Assign(ToF, ForceExtension(DatName,'BAK'));               { Open output file }
    Rewrite(ToF, 1);              { Record size = 1 }
    repeat
      BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
      BlockWrite(ToF, Buf, NumRead, NumWritten);
    until (NumRead = 0) or (NumWritten <> NumRead);
    Close(FromF);
    Close(ToF);

    { overwrite the header info}
    Assign(FromF, ForceExtension(DatName,'BAK'));             { Open input file }
    Reset(FromF, 1);              { Record size = 1 }
    Assign(ToF, DatName);               { Open output file }
    Rewrite(ToF, 1);              { Record size = 1 }
{    BlockRead(FromF, Buf, 88, NumRead); }
{    BlockWrite(ToF, HeaderData, 88, NumWritten);}
    repeat
      BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
      BlockWrite(ToF, Buf, NumRead, NumWritten);
    until (NumRead = 0) or (NumWritten <> NumRead);
    Close(FromF);
    Close(ToF);

  end;


begin
  ClrScr;
  WriteLn('RTTY by WF1B');
  WriteLn('ReIndex Index Utility');
  DatName := '';
  Num := 0;
  RemDupes := False;
  FixSCC := False;
  Case ParamCount of
    0 : begin
          Write('Bin File Name: ');
          ReadLn(DatName);
          Write('Remove duplicate QSOS? (Y/N)');
          ReadLn(index);
          if index[1] in ['y','Y'] then RemDupes := True;
        end;
    1 : if ParamStr(1) = '/RD' then begin
          Write('Bin File Name: ');
          ReadLn(DatName);
        end
        else
          DatName := ParamStr(1);
    2 : begin
          if (ParamStr(2) = '/RD') then RemDupes := True;
          if (ParamStr(2) = '/SCC') then FixSCC := True;
        end;
  end;
  DatName := ForceExtension(DatName,'BIN');
  RewriteHeader;
  OpenFile(DatF, DatName, SizeOf(a));
  if not OK then begin
    Write('ReIndex: Open bin file failed. Error='+long2str(TaStatus));
    Halt;
  end;
  Indname := ForceExtension(DatName, 'NDX');
  MakeIndex(IndexF, Indname, SizeOf(Index)-1, NoDuplicates);
  if not OK then begin
    Write('ReIndex: Make new index failed. Error='+long2str(TaStatus));
    Halt;
  end;
  C := 0;
  for RecordNumber := 1 to FileLen(DatF)-1 do begin
    GetRec(DatF, RecordNumber, a);
    if not OK then begin
      Write('ReIndex: Get data failed at rec:'+long2str(RecordNumber));
      WriteLn('Error='+long2str(TaStatus));
      Halt;
    end;
    a.call := Trim(a.call);
    if (a.Call = 'DELETE') and (a.ToolBoxNumber = 0) then DeleteRec(DatF, RecordNUmber);
    if FixSCC then a.New_Continent := False;
    if (a.Dupe) and RemDupes then DeleteRec(DatF, RecordNUmber)
    else begin
      if a.Call = '' then begin
        a.Call := 'Q/NOCALL/Q';
        PutRec(DatF,RecordNumber,A);
      end;
      if a.ToolBoxNumber = 0 then begin
        TimeOut := 0;
        Index := DateToSortString(a.Date)+TimeToSortString(a.Ts);
        AddKey(IndexF, RecordNumber, Index);
        While not OK do begin
          Inc(a.Ts,3);
          Index := DateToSortString(a.Date)+TimeToSortString(a.Ts);
          AddKey(IndexF, RecordNumber, Index);
          inc(TimeOut);
          if TimeOut = 99 then begin
            Write('ReIndex: Create index failed at rec:');
            WriteLn(RecordNumber);
            Write('ReIndex: Could not create unique index entry');
            Halt;
          end;
        end;
      end;
    end;
    inc(c);
    if C = 100 then begin
      Write(Long2Str(RecordNumber)+'...');
      C := 0;
    end;
  end;
  WriteLn;
  CloseFile(DatF);
  CloseIndex(IndexF);
  WriteLn('New index created: '+Indname);
end.
