{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit Routines;

interface

uses
  DiskIo;

procedure HandleContact(NewQso : Boolean; LR : log_rec; Ind : String);
procedure MakeSubstitutions(var Msg : String; MaxLen : Byte; var R : log_rec);
procedure TestCall(Call : String; var R : log_rec);


implementation
uses
  TpEntry,
  TpWindow,
  TpMouse,

  TpString,
  TpDate,
  cDist_W,
  cDist_VE,
  cDist_VK,
  cDist_JA,
  cDist_ZL,
  TAHigh,
  TAccess,
  C_Contest,
  LowLvl,
  cEditWin,
  IniTools,
  OneTimers,
  IniFile,
  c_radio,
  cRttyWin,
  Bearings,
  cSerNum,
  cCountry,
  cZone,
  cEaTbl,
  cSpTbl,
  cITbl,
  cRTbl,
  cContinent,
  cState,
  cProvince,
  ApPort,
  cClock,
  cDupeTbl,
  cAutoCq,
  DebugRtns,
  RecTypes;



 procedure HandleContact(NewQSo : Boolean; LR : log_rec; Ind : String);
    { 1st, attempts to locate a matching record in the database }
    { if found, then update that record with parameter          }
    { if not found, then add the record using the LogContact routine }
  var
    TR : log_rec;
    Found : Boolean;
    Count : Byte;

  procedure HandleUpdate;
  begin
    Count := 5;
    Found := False;
    repeat
      Dec(Count);
      TARead(LogFile^.TpDataSet, TR, Ind, True);
      if OK then
        if (LR.ts = TR.ts) and (LR.Date = TR.Date) then Found := True;
    until (Found) or (Count = 0);
    if Found then begin
      ThisContest^.RemoveOldMults(TR);
      TAUpdate(LogFile^.TpDataSet, LR, Ind);
      ThisContest^.AddNewMults(LR);
      Editw^.RefreshFromDisk;
    end;
  end;

  procedure HandleNew;
  begin
    ThisContest^.LogContact(LR);
  end;

  begin
    HandlingNetQso := TRUE;
    Case NewQSo of
      true  : HandleNew;
      False : HandleUpdate;
    end;
    if gInMainLoop then DrawEditScreen(EntryEsr);
    HandlingNetQso := FALSE;
  end;

  procedure TestCall(Call : String; var R : log_rec);
  begin
    if Trim(Call) <> '' then begin
      R.Call := Call;
      CountryList^.Identify(R);
      if RttyIni^.GetProfileBool('PutMsgs','Profile',True) then
        case Contest of
          SPRI : if not ThisContest^.QsoIsGood(R) then RttyWin^.PutString(^G^Y'Not yet'^Z);
        else
          if DupeTbl^.IsDupe(R.Call, R.Band) then RttyWin^.PutString(^G^Y'-DUPE '^Z)
                                             else ThisContest^.FillRec(R.Call, R);
        end;
    end;
  end;


  procedure MakeSubstitutions(var Msg : String; MaxLen : Byte; var R : log_rec);
  var
    MO, Yr, Da : Integer;
    SMO, SYR, SDA : Integer;
    DateT : Date;
    TimeT : Time;
    Slot : Word;

    procedure SubThis(Code : String; Value : String);
    begin
      while (Pos(Code, Msg) > 0) and (Length(Msg) < MaxLen) do begin
        Insert(Value, Msg, Pos(Code, Msg));
        Delete(Msg, Pos(Code, Msg), Length(Code));
      end;
    end;

  begin
    if Assigned(Clock) then
      Clock^.DateAndTimeUtc(DateT, TimeT)
    else begin
      Clock := New(pClock, Init);
      Clock^.DateAndTimeUtc(DateT, TimeT);
    end;
    DateToDMY(DateT, Da, MO, Yr);
    DateToDMY(R.Date, SDA, SMO, SYR);
    if RttyFunction <> 'LABELS' then
      DupeTbl^.GetDupeByCall(R.Call, Slot);

    {HIS INFORMATION 1-10  -------------------------------------------}
    SubThis('<1>', R.Call);
    SubThis('<2>', R.His_Qth);
    SubThis('<3>', TimeToTimeString('hhmm', R.His_Time));
    SubThis('<4>', LeftPadCh(long2str(R.His_Serno), '0', 3));
    SubThis('<5>', LeftPadCh(long2str(R.His_Zone), '0', 2));
    SubThis('<6>', long2str(R.His_RST)+'9');
    SubThis('<7>', long2str(SDA)+Copy(MonthString[SMO], 1, 3)+'.'+long2str(SYR));
    SubThis('<7A>', DateToDateString('yy/mm/dd', R.Date));
    SubThis('<7B>', DateToDateString('mm/dd/yy', R.Date));
    SubThis('<7C>', long2str(SYR)+'.'+RomanMonth(SMO)+'.'+long2str(SDA));
    SubThis('<7D>', long2str(SYR)+'.'+Copy(MonthString[SMO], 1, 3)+'.'+long2str(SDA));
    SubThis('<7E>', DayString[DayOfWeek(R.Date)]);
    SubThis('<7F>', Clock^.Date2DateString(R.Date));
    SubThis('<8A>', TimeToTimeString('hh:mmZ', R.ts));
    SubThis('<8B>', TimeToTimeString('hh:mm', R.ts));
    SubThis('<9>', R.His_Qth);    {age}

    {MY INFORMATION 11-20  -------------------------------------------}
    SubThis('<11>', Trim(RttyIni^.GetProfileString('Call','Profile','')));
    SubThis('<12>', Trim(RttyIni^.GetProfileString('Qth','Profile','')));
    SubThis('<13>', TimeToTimeString('hhmm', R.My_Time));
    if Assigned(SerNum) then SubThis('<14>', LeftPadCh(long2str(SerNum^.CurrentSerialNumberInAll), '0', 3));
    if Assigned(SerNum) then SubThis('<14A>', LeftPadCh(long2str(SerNum^.CurrentSerialNumberByBand(R.Band)), '0', 3));
    SubThis('<15>', RttyIni^.GetProfileString('CQZone','Profile',''));
    SubThis('<16>', RttyIni^.GetProfileString('UsualRST','Profile','599'));
    SubThis('<19>', RttyIni^.GetProfileString('Age','Profile',''));

    {MISC INFORMATION 21++  ------------------------------------------- }

    SubThis('<20A>', DateToDateString('yy/mm/dd', DateT));
    SubThis('<20B>', DateToDateString('mm/dd/yy', DateT));
    SubThis('<20C>', long2str(Yr)+'.'+RomanMonth(MO)+'.'+long2str(Da));
    SubThis('<20D>', long2str(Yr)+'.'+Copy(MonthString[MO], 1, 3)+'.'+long2str(Da));
    SubThis('<20E>', DayString[DayOfWeek(DateT)]);
    SubThis('<20F>', Clock^.Date2DateString(DateT));
    SubThis('<21A>', TimeToTimeString('hh:mmZ', TimeT));
    SubThis('<21B>', TimeToTimeString('hh:mm', TimeT));
    SubThis('<22A>', BandS[R.Band]);
    SubThis('<22B>', MHZs[R.Band]);
    if Assigned(DupeTbl) then SubThis('<23A>', TimeToTimeString('hh:mmZ', DupeTbl^.GetTime(R.Band)));
    if Assigned(DupeTbl) then SubThis('<23B>', TimeToTimeString('hh:mm', DupeTbl^.GetTime(R.Band)));

    {Prev INFORMATION 31-20  -----------------------------------------}
    SubThis('<31>', Prev.Call);
    SubThis('<32>', Prev.My_Qth);
    SubThis('<33>', TimeToTimeString('hhmm', Prev.My_Time));
    SubThis('<34>', LeftPadCh(long2str(Prev.My_Serno), '0', 3));
    SubThis('<35>', LeftPadCh(long2str(Prev.My_Zone), '0', 2));
    SubThis('<36>', long2str(Prev.My_Rst)+'9');
    SubThis('<39>', Prev.His_Qth); {age}

    SubThis('<CR>', ^M);          {v2.5a}
    SubThis('<SP>', ' ');
    if Assigned(FriendList) then SubThis('<HI>', FriendList^.GetProfileString(R.Call, 'HI', ''));
    if Assigned(FriendList) then SubThis('<TU>', FriendList^.GetProfileString(R.Call, 'TU', ''));

    {END MISC INFORMATION 21++  --------------------------------------- }
  end;



end.
