{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
UNIT Rttymenu;

interface

uses TPMenu;

var
  M : Menu;
  Ch : Char;
  Key : MenuKey;

const
  mnuSystem = 1;
  mnuAdjustTime = 2;
  mnuClearScreen = 3;
  mnuSetFunctionKeys = 4;
  mnuSetSerialPorts = 5;
  mnuSetSerialNums = 6;
  mnuShellToDos = 7;
  mnuResetFKeys = 8;

  mnuWIndows       = 25;
  mnuDispCountries = 26;
  mnuDispZones     = 27;
  mnuDispStates    = 28;
  mnuDispDistricts = 29;
  mnuDispOblasts   = 30;
  mnuDispSPProvs   = 31;
  mnuDispEAProvs   = 32;
  mnuDispPrefixes  = 33;
  mnuDispIProvs    = 34;
  mnuCheck         = 35;
  mnuDispSections  = 37;

  mnuReports = 50;
  mnuSummary =51;
  mnuMultipliers = 52;
  mnuDupeSheet = 53;
  mnuWriteLog = 54;

  mnuHelp = 75;
  mnuAbout = 76;
  mnuHelpTopics = 77;
  mnuUserHelp = 78;
  mnuIniHelp = 79;
  mnuColorHelp = 80;

  mnuNet = 100;
  mnuSyncTime = 101;
  mnuPing = 102;
  mnuPing1 = 103;
  mnuPing2 = 104;
  mnuPing3 = 105;
  mnuPing4 = 106;
  mnuPing5 = 107;
  mnuPing6 = 108;
  mnuPing7 = 109;
  mnuPing8 = 110;
  mnuNetGab   = 111;
  mnuNetAnnounce = 112;
  mnuPacket = 113;
  mnuAltAWin = 114;
  mnuViewMsgs = 115;
  mnuSpotCurrBand = 116;
  mnuSpotAllBands = 117;

  mnuOptions = 130;
  mnuOptionReindex = 131;
  mnuOptionPrintQso = 132;
  mnuOptionSpaceBar = 133;

procedure RunMenu;


implementation

uses
  TPString,
  TPCrt,
  TPCmd,
  RecTypes,
  IniFile,
  IniTools,
  cEAtbl,
  cState,
  cZone,
  cItbl,
  cRtbl,
  cSection,
  cSPtbl,
  Network,
  cDist_ve,
  cColors,
  ClusterMon,
  TPWindow;

const
  Color1 : MenuColorArray = ($0E, $2E, $03, $1E, $0B, $0E, $19, $78);

procedure InitMenu(var M : Menu);
const
  Frame1 : FrameArray = 'Ըͳ';
  OnOff  : Array[Boolean] of Char = (' ','');
  OffOnString : Array[Boolean] of string[3] = ('Yes','No');
var
  Checked : Char;
begin
  {Customize this call for special exit characters and custom item displays}
  M := NewMenu([], nil);

  SubMenu(1,2,1,Horizontal,Frame1,Color1,'');
    MenuWidth(80);
    MenuItem('System',2,1,mnuSystem,'RTTY System-wide settings');
    SubMenu(3,4,1,Vertical,Frame1,Color1,'');
      MenuItem('Adjust Time',1,1,mnuAdjustTime,'Set the system time');
      MenuItem('Clear Screen',2,1,mnuClearScreen,'Clear contents of receive screen');
      MenuItem('Set Function Keys  CTL-F7',3,5,mnuSetFunctionKeys,'Program the function keys');
      MenuItem('Set Serial Ports',4,12,mnuSetSerialPorts,'Change the serial port settings');
      MenuItem('Set Serial Numbers',5,12,mnuSetSerialNums,'Change the serial numbers');
      MenuItem('Shell to DOS',6,12,mnuShellToDos,'Shell to DOS (type EXIT to return)');
      MenuItem('Reset FKeys to default',7,1,mnuResetFKeys,'Read function key definitions from default.ini');
      PopSublevel;
    MenuItem('Windows',9,1,mnuWindows,'Display Various Informational Windows');
    SubMenu(9,4,1,Vertical,Frame1,Color1,'');
      MenuWidth(23);
      MenuItem('Countries           ALT-M',1,1,mnuDispCountries,'Display Countries worked');
      MenuItem('Zones               ALT-Z',2,1,mnuDispZones,'Display CQ zones worked');
      if not Assigned(ZoneList) then DisableMenuItem(M,mnuDispZones);
      MenuItem('US States           ALT-U',3,1,mnuDispStates,'Display US States worked');
      if not Assigned(StateList) then DisableMenuItem(M,mnuDispStates);
      MenuItem('Districts           ALT-D',4,1,mnuDispDistricts,'Display Districts worked');
      if not Assigned(VEDistList) then DisableMenuItem(M,mnuDispDistricts);
      MenuItem('Oblasts             ALT-U',5,1,mnuDispOblasts,'Display Russian Oblasts worked');
      if not Assigned(RList) then DisableMenuItem(M,mnuDispOblasts);
      MenuItem('SP Provinces        ALT-U',6,1,mnuDispSPProvs,'Display Polish Provinces worked');
      if not Assigned(SPList) then DisableMenuItem(M,mnuDispSpProvs);
      MenuItem('EA Provinces        ALT-U',7,1,mnuDispEAProvs,'Display Spanish Provinces worked');
      if not Assigned(EAList) then DisableMenuItem(M,mnuDispEAProvs);
      MenuItem('Prefixes            ALT-U',8,1,mnuDispPrefixes,'Display Prefixes worked');
      if not Assigned(PrefixList) then DisableMenuItem(M,mnuDispPrefixes);
      MenuItem('I Provinces         ALT-U',9,1,mnuDispIProvs,'Display Italian Provinces worked');
      if not Assigned(IList) then DisableMenuItem(M,mnuDispIPRovs);
      MenuItem('ARRL Sections       ALT-U',10,1,mnuDispSections,'Display ARRL sections worked');
      if not Assigned(SectionList) then DisableMenuItem(M,mnuDispSections);
      MenuItem('Check Partial       CTL-F4',11,4,mnuCheck,'Check for partial call matches');
      PopSublevel;
    MenuItem('Reports',17,1,mnuReports,'Generate report files of various information');
    SubMenu(17,4,1,Vertical,Frame1,Color1,'');
      MenuItem('All Reports',1,1,mnuWriteLog,'Create all reports (WRITELOG)');
      MenuItem('Summary',2,1,mnuSummary,'Create Summary report (.sum)');
      MenuItem('Multipliers',3,1,mnuMultipliers,'Create various multplier reports ');
      MenuItem('Duplicates',4,1,mnuDupeSheet,'Create "dupe" report (.dup)');
      PopSublevel;
    MenuItem('Network',25,1,mnuNet,'Network related menu options');
    SubMenu(25,4,1,Vertical,Frame1,Color1,'');
      MenuWidth(26);
      MenuItem('Synchronize Time',1,14,mnuSyncTime,'Display version and copyright information');
      MenuItem('Send Message',2,5,mnuNetGab,'Send a message to other station');
      MenuItem('Send Announcement   ALT-G',3,5,mnuNetAnnounce,'Send a gab message');
      MenuItem('Ping...',4,1,mnuPing,'Test network connection to another station');
      SubMenu(26,8,1,Vertical,Frame1,Color1,'');
        MenuItem('Ping 1',1,1,mnuPing1,'Test network connection to station 1');
        MenuItem('Ping 2',2,1,mnuPing2,'Test network connection to station 2');
        MenuItem('Ping 3',3,1,mnuPing3,'Test network connection to station 3');
        MenuItem('Ping 4',4,1,mnuPing4,'Test network connection to station 4');
        MenuItem('Ping 5',5,1,mnuPing5,'Test network connection to station 5');
        MenuItem('Ping 6',6,1,mnuPing6,'Test network connection to station 6');
        MenuItem('Ping 7',7,1,mnuPing7,'Test network connection to station 7');
        MenuItem('Ping 8',8,1,mnuPing8,'Test network connection to station 8');
        PopSublevel;
      MenuItem('Packet              ALT-O',5,2,mnuPacket,'Communicate via packet controller');
      MenuItem('Needed Spots        ALT-A',6,1,mnuAltaWin,'Display needed multipliers from packet');
      MenuItem('View Messages       ALT-V',7,1,mnuViewMsgs,'Display network messages received');
      Checked := OnOff[RttyIni^.GetProfileBool('CurrentBand','CLUSTER',True)];
      MenuItem('Spots for this band '+Checked,8,11,mnuSpotCUrrBand,'Display packet spots for the current band');
      Checked := OnOff[RttyIni^.GetProfileBool('OtherBands','CLUSTER',True)];
      MenuItem('Spots for other bands '+Checked,9,11,mnuSpotAllBands,'Display packet spots for all other bands');
      if not Assigned(net) then begin
        DisableMenuItem(m,mnuSyncTime);
        DisableMenuItem(m,mnuNetGab);
        DisableMenuItem(m,mnuNetAnnounce);
        DisableMenuItem(m,mnuPing);
        DisableMenuItem(m,mnuViewMsgs);
      end;
      if not Assigned(ClusterMonitor) then begin
        DisableMenuItem(m,mnuPacket);
        DisableMenuItem(m,mnuAltaWin);
        DisableMenuItem(m,mnuSpotCurrBand);
        DisableMenuItem(m,mnuSpotAllBands);
      end;
      PopSublevel;
    MenuItem('Options',33,1,mnuOptions,'Set RTTY options');
    SubMenu(33,4,1,Vertical,Frame1,Color1,'');
      MenuWidth(26);
      Checked := OnOff[RttyIni^.GetProfileBool('AutoReindex','PROFILE',True)];
      MenuItem('Auto Reindex            '+Checked,1,1,mnuOptionReindex,'Automatically repair/reindex the .BIN file');
      Checked := OnOff[RttyIni^.GetProfileBool('PrintEachContact','PROFILE',False)];
      MenuItem('Print Each Contact      '+Checked,2,1,mnuOptionPrintQso,'Print each QSO as it is initially logged');
      Checked := OnOff[RttyIni^.GetProfileBool('SpaceTab','PROFILE',False)];
      MenuItem('Spacebar Advances Field '+Checked,3,1,mnuOptionSpaceBar,'The spacebar will act as a tab for current QSO');
      PopSublevel;
    MenuItem('HELP',72,1,mnuHelp,'Display online help');
    SubMenu(55,4,1,Vertical,Frame1,Color1,'');
      MenuWidth(26);
      MenuItem('About...',1,1,mnuAbout,'Display version and copyright information');
      MenuItem('Help Topics        ALT-H',2,1,mnuHelpTopics,'Predefined Help topics');
      MenuItem('Ini Specs',3,1,mnuIniHelp,'Show documentation of INI file settings(INI.TXT)');
      MenuItem('Color List',4,1,mnuColorHelp,'Show list of available colors(COLORS.TXT)');
      MenuItem('User Help',5,1,mnuUserHelp,'User defined text file (USERHELP.TXT)');
      PopSublevel;
    PopSublevel;

  ResetMenu(M);
end;

procedure RunMenu;
begin
  with Colors^ do begin
  Color1[FrameColor]    := FrameAttr;  {Color used for menu frames}
  Color1[HeaderColor]   := HeaderAttr; {Color used for header string within frame}
  Color1[BodyColor]     := WindowAttr; {Color used for body of menu}
  Color1[SelectColor]   := StringAttr; {Color used for the selected item}
  Color1[HiliteColor]   := HiLiteAttr; {Color used for the pick character of each item}
  Color1[HelpColor]     := WindowAttr; {Color used for help row, if any}
  Color1[DisabledColor] := HiLiteAttr; {Color used for temporarily disabled items}
  Color1[ShadowColor]   := WindowAttr; {Color used for menu shadows}
  end;
  InitMenu(M);
  EnableMenuMouse;
  Key := MenuChoice(M, Ch);
  EraseMenu(M, False);
  RttyIni^.FlushFile;
{  Writeln('Key=', Key, ' Ch=#', Ord(Ch));
  halt; }
end;

end.
