{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program Stats;
uses
  TpCrt, TpDate, TpDos, TpEdit, TpRarray, TpEntry, TpWindow,
  TAccess, TpString, Diskio,
  Printer, RecTypes;

var
  RecordNumber   : LongInt;
  DatF           : DataFile;
  IndexF         : IndexFile;
  DatName, Indname : String[20];
  Num            : Word;
  QSOS           : array[0..47] of Word;
  USQSOS         : array[0..47] of Word;
  VEQSOS         : array[0..47] of Word;
  DXQSOS         : array[0..47] of Word;
  MSTATES        : array[0..47] of Word;
  MPROVINCES     : array[0..47] of Word;
  MCOUNTRIES     : array[0..47] of Word;
  MZONES         : array[0..47] of Word;
  TQSOS          : Word;
  TUSQSOS        : Word;
  TVEQSOS        : Word;
  TDXQSOS        : Word;
  TSTATES        : Word;
  TPROVINCES     : Word;
  TCOUNTRIES     : Word;
  TZONES         : Word;
  ho, MI, se     : Byte;
  Da, MO, Yr     : Integer;
  hd, adj        : Integer;
  otsw           : Boolean;
  Title          : String[80];
  yn             : String[5];
  acthrs         : Byte;
  f              : text;
  filname        : string[20];
  a              : log_rec;
  i              : integer;

  procedure accumulatestats(R : Log_Rec);
  begin
    if R.ToolBoxNumber <> 0 then Exit;
    TimeToHMS(R.Ts, ho, MI, se);
    DateToDMY(R.Date, Da, MO, Yr);
    if otsw then hd := Da;
    otsw := False;
    if hd <> Da then adj := 24
    else adj := 0;
    Inc(QSOS[ho+adj]);
    if Trim(R.His_Country) = 'VE' then Inc(VEQSOS[ho+adj]) else
      if Trim(R.His_Country) = 'W' then Inc(USQSOS[ho+adj]) else
        Inc(DXQSOS[ho+adj]);
    if R.New_Qth then
      if Trim(R.His_Country) = 'VE' then Inc(MPROVINCES[ho+adj])
      else Inc(MSTATES[ho+adj]);
    if R.New_Zone then Inc(MZONES[ho+adj]);
    if R.New_Country then Inc(MCOUNTRIES[ho+adj]);
  end;


begin
  ClrScr;
  WriteLn(rttybywf1b+version+copyright);
  WriteLn('Some rate statistics ...');
  otsw := True;
  Da := 0;
  adj := 0;
  for ho := 0 to 47 do begin
    QSOS[ho] := 0;
    USQSOS[ho] := 0;
    VEQSOS[ho] := 0;
    DXQSOS[ho] := 0;
    MCOUNTRIES[ho] := 0;
    MSTATES[ho] := 0;
    MPROVINCES[ho] := 0;
    MZONES[ho] := 0;
  end;
  TQSOS := 0;
  TUSQSOS := 0;
  TVEQSOS := 0;
  TDXQSOS := 0;
  TSTATES := 0;
  TPROVINCES := 0;
  TCOUNTRIES := 0;
  TZONES := 0;
  Write('BIN file name?    ');
  ReadLn(DatName);
  Write('Title for output? ');
  Read(Title);
  Write('Is the printer ready, (Y)es, (S)creen, (F)ile, (Q)uit ?');
  yn := '';
  repeat
    ReadLn(yn);
    if yn[1] in ['Q', 'q'] then Halt;
  until yn[1] in ['Y', 'y', 'S', 's','f','F'];
  WriteLn;
  WriteLn('Preparing...');
  Num := 0;
  for I := 1 to Length(DatName) do DatName[I] := Upcase(DatName[I]);
  if Pos('.', DatName) = 0 then DatName := DatName+'.BIN';
  OpenFile(DatF, DatName, SizeOf(a));
  if not OK then begin
    Write('STATS: Open data failed.');
    Halt;
  end;
  for RecordNumber := 1 to FileLen(DatF)-1 do begin
    GetRec(DatF, RecordNumber, a);
    if not OK then begin
      Write('STATS: Get data failed.');
      Halt;
    end;
    accumulatestats(a);
  end;
  acthrs := 0;
  for ho := 0 to 47 do
    if QSOS[ho] > 0 then Inc(acthrs);
  if yn[1] in ['Y', 'y'] then begin
    WriteLn('Printing...');
    WriteLn(Lst, '');
    WriteLn(Lst, Title);
    WriteLn(Lst, '');
    WriteLn(Lst, '');
    WriteLn(Lst, 'Hour QSO Rate  US Rate  VE Rate  DX Rate US Mults VE Mults DX Mults Zn Mults');
    WriteLn(Lst, '---- -------- -------- -------- -------- -------- -------- -------- --------');
    for ho := 0 to 47 do begin
      WriteLn(Lst,
              LeftPad(Long2Str(ho), 4)+' '+
              LeftPad(Long2Str(QSOS[ho]), 8)+' '+
              LeftPad(Long2Str(USQSOS[ho]), 8)+' '+
              LeftPad(Long2Str(VEQSOS[ho]), 8)+' '+
              LeftPad(Long2Str(DXQSOS[ho]), 8)+' '+
              LeftPad(Long2Str(MSTATES[ho]), 8)+' '+
              LeftPad(Long2Str(MPROVINCES[ho]), 8)+' '+
              LeftPad(Long2Str(MCOUNTRIES[ho]), 8)+' '+
              LeftPad(Long2Str(MZONES[ho]), 8)
              );
      TQSOS := TQSOS+QSOS[ho];
      TUSQSOS := TUSQSOS+USQSOS[ho];
      TVEQSOS := TVEQSOS+VEQSOS[ho];
      TDXQSOS := TDXQSOS+DXQSOS[ho];
      TSTATES := TSTATES+MSTATES[ho];
      TPROVINCES := TPROVINCES+MPROVINCES[ho];
      TCOUNTRIES := TCOUNTRIES+MCOUNTRIES[ho];
      TZONES := TZONES+MZONES[ho];
    end;

    WriteLn(Lst, '---- -------- -------- -------- -------- -------- -------- -------- --------');
    WriteLn(Lst,
            'Total'+
            LeftPad(Long2Str(TQSOS), 8)+' '+
            LeftPad(Long2Str(TUSQSOS), 8)+' '+
            LeftPad(Long2Str(TVEQSOS), 8)+' '+
            LeftPad(Long2Str(TDXQSOS), 8)+' '+
            LeftPad(Long2Str(TSTATES), 8)+' '+
            LeftPad(Long2Str(TPROVINCES), 8)+' '+
            LeftPad(Long2Str(TCOUNTRIES), 8)+' '+
            LeftPad(Long2Str(TZONES), 8)
            );
    WriteLn(Lst,
            'Avgs.'+
            LeftPad(Long2Str(TQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TUSQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TVEQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TDXQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TSTATES div acthrs), 8)+' '+
            LeftPad(Long2Str(TPROVINCES div acthrs), 8)+' '+
            LeftPad(Long2Str(TCOUNTRIES div acthrs), 8)+' '+
            LeftPad(Long2Str(TZONES div acthrs), 8)
            );
    Write(Lst, ^L);
  end;
  if yn[1] in ['F', 'f'] then begin
    Write('Report file name? ');
    ReadLn(FilName);
    filname := Trim(Filname);
    if filname = '' then halt;
    assign(f,filname);
    rewrite(f);
    WriteLn(F, '');
    WriteLn(F, Title);
    WriteLn(F, '');
    WriteLn(F, '');
    WriteLn(F, 'Hour QSO Rate  US Rate  VE Rate  DX Rate US Mults VE Mults DX Mults Zn Mults');
    WriteLn(F, '---- -------- -------- -------- -------- -------- -------- -------- --------');
    for ho := 0 to 47 do begin
      WriteLn(F,
              LeftPad(Long2Str(ho), 4)+' '+
              LeftPad(Long2Str(QSOS[ho]), 8)+' '+
              LeftPad(Long2Str(USQSOS[ho]), 8)+' '+
              LeftPad(Long2Str(VEQSOS[ho]), 8)+' '+
              LeftPad(Long2Str(DXQSOS[ho]), 8)+' '+
              LeftPad(Long2Str(MSTATES[ho]), 8)+' '+
              LeftPad(Long2Str(MPROVINCES[ho]), 8)+' '+
              LeftPad(Long2Str(MCOUNTRIES[ho]), 8)+' '+
              LeftPad(Long2Str(MZONES[ho]), 8)
              );
      TQSOS := TQSOS+QSOS[ho];
      TUSQSOS := TUSQSOS+USQSOS[ho];
      TVEQSOS := TVEQSOS+VEQSOS[ho];
      TDXQSOS := TDXQSOS+DXQSOS[ho];
      TSTATES := TSTATES+MSTATES[ho];
      TPROVINCES := TPROVINCES+MPROVINCES[ho];
      TCOUNTRIES := TCOUNTRIES+MCOUNTRIES[ho];
      TZONES := TZONES+MZONES[ho];
    end;

    WriteLn(F, '---- -------- -------- -------- -------- -------- -------- -------- --------');
    WriteLn(F,
            'Total'+
            LeftPad(Long2Str(TQSOS), 8)+' '+
            LeftPad(Long2Str(TUSQSOS), 8)+' '+
            LeftPad(Long2Str(TVEQSOS), 8)+' '+
            LeftPad(Long2Str(TDXQSOS), 8)+' '+
            LeftPad(Long2Str(TSTATES), 8)+' '+
            LeftPad(Long2Str(TPROVINCES), 8)+' '+
            LeftPad(Long2Str(TCOUNTRIES), 8)+' '+
            LeftPad(Long2Str(TZONES), 8)
            );
    WriteLn(F,
            'Avgs.'+
            LeftPad(Long2Str(TQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TUSQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TVEQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TDXQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TSTATES div acthrs), 8)+' '+
            LeftPad(Long2Str(TPROVINCES div acthrs), 8)+' '+
            LeftPad(Long2Str(TCOUNTRIES div acthrs), 8)+' '+
            LeftPad(Long2Str(TZONES div acthrs), 8)
            );
  end;
  if yn[1] in ['S', 's'] then
  begin
    Clrscr;
    WriteLn('Hour QSO Rate  US Rate  VE Rate  DX Rate US Mults VE Mults DX Mults Zn Mults');
    WriteLn('---- -------- -------- -------- -------- -------- -------- -------- --------');
    for ho := 0 to 47 do
    begin
      WriteLn(LeftPad(Long2Str(ho), 4)+' '+
              LeftPad(Long2Str(QSOS[ho]), 8)+' '+
              LeftPad(Long2Str(USQSOS[ho]), 8)+' '+
              LeftPad(Long2Str(VEQSOS[ho]), 8)+' '+
              LeftPad(Long2Str(DXQSOS[ho]), 8)+' '+
              LeftPad(Long2Str(MSTATES[ho]), 8)+' '+
              LeftPad(Long2Str(MPROVINCES[ho]), 8)+' '+
              LeftPad(Long2Str(MCOUNTRIES[ho]), 8)+' '+
              LeftPad(Long2Str(MZONES[ho]), 8)
              );
      TQSOS := TQSOS+QSOS[ho];
      TUSQSOS := TUSQSOS+USQSOS[ho];
      TVEQSOS := TVEQSOS+VEQSOS[ho];
      TDXQSOS := TDXQSOS+DXQSOS[ho];
      TSTATES := TSTATES+MSTATES[ho];
      TPROVINCES := TPROVINCES+MPROVINCES[ho];
      TCOUNTRIES := TCOUNTRIES+MCOUNTRIES[ho];
      TZONES := TZONES+MZONES[ho];
      if ho in [21,43] then begin
        Write('Press <enter>');
        Readln;
        Clrscr;
        WriteLn('Hour QSO Rate  US Rate  VE Rate  DX Rate US Mults VE Mults DX Mults Zn Mults');
        WriteLn('---- -------- -------- -------- -------- -------- -------- -------- --------');
      end;
    end;

    WriteLn('---- -------- -------- -------- -------- -------- -------- -------- --------');
    WriteLn('Total'+
            LeftPad(Long2Str(TQSOS), 8)+' '+
            LeftPad(Long2Str(TUSQSOS), 8)+' '+
            LeftPad(Long2Str(TVEQSOS), 8)+' '+
            LeftPad(Long2Str(TDXQSOS), 8)+' '+
            LeftPad(Long2Str(TSTATES), 8)+' '+
            LeftPad(Long2Str(TPROVINCES), 8)+' '+
            LeftPad(Long2Str(TCOUNTRIES), 8)+' '+
            LeftPad(Long2Str(TZONES), 8)
            );
    WriteLn('Avgs.'+
            LeftPad(Long2Str(TQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TUSQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TVEQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TDXQSOS div acthrs), 8)+' '+
            LeftPad(Long2Str(TSTATES div acthrs), 8)+' '+
            LeftPad(Long2Str(TPROVINCES div acthrs), 8)+' '+
            LeftPad(Long2Str(TCOUNTRIES div acthrs), 8)+' '+
            LeftPad(Long2Str(TZONES div acthrs), 8)
            );
    WriteLn('Press <enter>');
    ReadLn;
  end;

  CloseFile(DatF);
  ClrScr;
  WriteLn(rttybywf1b+version+copyright);
  WriteLn('Written by Ray Ortgiesen, WF1B');
end.
