{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit TncControl;

interface

Uses
  TncObject;

procedure CreateTnc;
function  TncName2Num(Const TncName : String) : Byte;

const
  RttyTerm1 : PTnc = NIL;

implementation

uses
  LowLvl,
  TpString,
  ApPort,
  IniFile,
  RecTypes,
  cRttyWin,
  CAmt,
  CPci3000,
  CAeaCommand,
  CMfj1278,
  CKam,
  CUserDef,
  CUtu,
  CNoTnc,
  CBaudotDrv,
  CPk900,
  CPci4000,
  Cp38,
  CPk232,
  cDsp232,
  CK6STI,
  CPtc1,
  cPtc2,
  DebugRtns,
  CDsp4100,
  cDxp38;

  procedure CreateTnc;
  var
    P : Byte;
    cp : ComNameType;
    TncTypeStr : string[19];
    ShowError : Boolean;
  begin
    ShowError := False;
    TncTypeStr := StUpCase(RttyIni^.GetProfileString('Type','TNC1','NONE'));
    P := RttyIni^.GetProfileByte('ComPort', 'TNC1', 0);
    if (P = 0) and
    NOT (
    (TncTypeStr = 'PCI-3000') or
    (TncTypeStr = 'PCI-4000') or
    (TncTypeStr = 'P38') or
    (TncTypeStr = 'K6STI') or
    (TncTypeStr = 'NONE')
    ) then begin
      ShowError := True;
      TncTypeStr := 'NONE';
    end;
    {$IFDEF DEBUG}
    AppendDebugMessage('At tnc creation "'+TncTypeStr+'" Port='+long2str(p));
    {$ENDIF}

    if P > 0 then cp := ComNameType(P-1);
    if TncTypeStr = 'AEA CMD' then RttyTerm1 := New(PAeaCommand, Init(cp));
    if TncTypeStr = 'PK-232' then RttyTerm1 := New(PPk232, Init(cp));
    if TncTypeStr = 'PK-900' then RttyTerm1 := New(PPk900, Init(cp));
    if TncTypeStr = 'DSP-232' then RttyTerm1 := New(PDsp232, Init(cp));
    if TncTypeStr = 'MFJ-1278' then RttyTerm1 := New(PMfj1278, Init(cp));
    if TncTypeStr = 'KAM' then RttyTerm1 := New(PKam, Init(cp));
    if TncTypeStr = 'BAUDOT-DRV' then RttyTerm1 := New(PBaudotDrv, Init(cp));
    if TncTypeStr = 'USER-DEF' then RttyTerm1 := New(PUserDef, Init(cp));
    if TncTypeStr = 'UTU' then RttyTerm1 := New(PUtu, Init(cp));
    if TncTypeStr = 'AMT' then RttyTerm1 := New(PAmt, Init(cp));
    if TncTypeStr = 'PTC-I' then RttyTerm1 := New(PPtc1, Init(cp));
    if TncTypeStr = 'PTC-II' then RttyTerm1 := New(PPtc2, Init(cp));
    if TncTypeStr = 'DSP-4100' then RttyTerm1 := New(PDsp4100, Init(cp));
    if TncTypeStr = 'DXP38' then RttyTerm1 := New(PDxp38, Init(cp));
    if TncTypeStr = 'PCI-3000' then RttyTerm1 := New(PPci3000, Init);
    if TncTypeStr = 'PCI-4000' then RttyTerm1 := New(PPci4000, Init);
    if TncTypeStr = 'P38' then RttyTerm1 := New(PP38, Init);
    if TncTypeStr = 'K6STI' then RttyTerm1 := New(PK6STI, Init);
    if TncTypeStr = 'NONE' then RttyTerm1 := New(PNoTnc, Init);
    RttyTerm1^.Name := TncTypeStr;
{    RttyTerm1^.Initialize; }
    if ShowError then begin
      RttyWin^.PutString(^M+'Tnc: The '+TncTypeStr+' requires a comport to be identified.');
      RttyWin^.PutString(^M+'Tnc: yet no comport identified in the RTTY.INI file.  The TNC');
      RttyWin^.PutString(^M+'Tnc: selection has been changed to "None".');
    end;
    {$IFDEF DEBUG}
    AppendDebugMessage('TncControl.CreateTnc end');
    {$ENDIF}
  end;


function  TncName2Num(Const TncName : String) : Byte;
var
  b : byte;
begin
  for b := Tnc_First to Tnc_Last do
    if StUpCase(Tncs[b]) = StUpCase(TncName) then begin
      TncName2Num := b;
      Exit;
    end;
  TncName2Num := Tnc_Last;
end;


end.
