{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$o+}
unit WpxNode;
interface

uses OpRoot;

type

  {An object for manipulating Prefix, derived from SingleListNode}
  PWpxNode = ^TWpxNode;
  TWpxNode =
    object(SingleListNode)
      private
      Prefix : String[5];
      Count  : Byte;
      public
      constructor Init(NewPrefix : String);
      function GetPrefix : string;
      function GetCount : byte;
      procedure IncCount;
      procedure DecCount;
      procedure Show;
      destructor Done; virtual;
    end;

implementation

uses TpString;

  {---------- TWpxNode Methods --------------------------------------}
  constructor TWpxNode.Init(NewPrefix : String);
    { initialize a singly linked list node. }
  begin
    inherited Init;
    Prefix := NewPrefix;
    Count := 1;
  end;

  function TWpxNode.GetPrefix : string;
  begin
    GetPrefix := Prefix;
  end;

  function TWpxNode.GetCount : byte;
  begin
    GetCount := Count;
  end;

  procedure TWpxNode.IncCount;
  begin
    If Count < 254 then Inc(Count);
  end;

  procedure TWpxNode.DecCount;
  begin
    If Count > 0 then Dec(Count);
  end;

  procedure TWpxNode.Show;
  begin
    WriteLn('TWpxNode');
    WriteLn(Prefix, ' ', Count);
  end;

  destructor TWpxNode.Done;
  begin
    inherited Done;
  end;

  {---------- End TWpxNode Methods ----------------------------------}

end.
