{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit WrkSheet;

interface

procedure InitWrkSheet;
procedure EditWorkSheet;
procedure SetMyInfo;
procedure SetSerialPorts;

implementation
uses
  TpCrt,
  TpDos,
  TpEdit,
  TpEntry,
  TpMouse,
  TpRarray,
  TpWindow,
  TpString,
  RecTypes,
  DebugRtns,
  c_Contest,
  cColors,
  LowLvl,
  Routines,
  OneTimers,
  TncControl,
  ApPort,
  IniTools,
  Inifile,
  cRttyWin,
  cMsgWin,
  Keys;

var
  Esr : EsRecord;
  PressedAltI : Boolean;          { t=got here by pressing alt-i }



  {* This routine handles the choice type variables. If a + or ' ' is entered *}
  {* then the item is incremented. If a - is entered, then the choice is      *}
  {* decremented.                                                             *}
  procedure IncChoice(var Value; FieldID : Byte;
    Factor : Integer;
    var St : String); far;
  var
    Contest : ContestType absolute Value;
    Class : ClassType absolute Value;
    Tnc : byte absolute Value;
  begin
    case FieldID of
      000 : begin
              case Factor of
                1 : if Contest = Contest_Last then Contest := Contest_First {v3.0}
                    else Inc(Contest);
                -1 : if Contest = Contest_First then Contest := Contest_Last {v3.0}
                     else Dec(Contest);
              end;
              St := ContestName[Contest];
            end;
      009 : begin
              case Factor of
                1 : if Class = Class_Last then Class := Class_First
                    else Inc(Class);
                -1 : if Class = Class_First then Class := Class_Last
                     else Dec(Class);
              end;
              St := Classes[Class];
            end;
      012 : begin
              case Factor of
                1 : if Tnc >= Tnc_Last then Tnc := Tnc_First
                    else inc(Tnc);
                -1 : if Tnc = Tnc_First then Tnc := Tnc_Last
                     else dec(Tnc);
              end;
              St := TncS[Tnc];
            end;

    end;
  end;
  {* This is the main routine for the WRKSHEET unit. It creates a pop up  *}
  {* window and invokes an edit for work sheet variables.                 *}

  procedure EditWorkSheet;
  var
    OK : Boolean;
    ExitCommand : EStype;
    EditPtr : WindowPtr;
    OldTnc, NewTnc : Byte;
    call : string[12];
    name : string[30];
    street : string[30];
    town : string[20];
    state : string[3];
    ZipCode : string[6];
    Club : string[50];
    Power : integer;
    basefname : string[12];
    Class : ClassType;
    CqZone : String[2];
    BinFileName : string[79];
  label
    bypass;
  begin
    if ByPassWorkSheet then goto bypass;
    Call := RttyIni^.GetProfileString('Call', 'Profile', '');
    Name := RttyIni^.GetProfileString('Name', 'Profile', '');
    Street:= RttyIni^.GetProfileString('Street', 'Profile', '');
    Town := RttyIni^.GetProfileString('City', 'Profile', '');
    State := RttyIni^.GetProfileString('State', 'Profile', '');
    ZipCode := RttyIni^.GetProfileString('ZipCode', 'Profile', '');
    OldTnc := TncName2num(StUpCase(RttyIni^.GetProfileString('Type','TNC1','NONE')));
    Club := RttyIni^.GetProfileString('Club', 'Profile', '');
    Power:= RttyIni^.GetProfileInt('Power', 'Profile', 0);
    Class := ClassStr2Class(RttyIni^.GetProfileString('Class', 'Profile', 'Single Op, All Band'));
    CqZone := RttyIni^.GetProfileString('CqZone', 'Profile', '');
    BinFileName := FileName('BIN');
    NewTnc := OldTnc;
    with Colors^ do
      if not MakeWindow(EditPtr, 3, 3, 77, 21, True, True, False, WindowAttr,
        FrameAttr, HeaderAttr, 'Work Sheet') then NotEnoughMemory(True);
    HideMouse;
    DisplayWindow(EditPtr);
    InitEsRecord(Esr);
    Colors^.SetEntryAttributes;
    SetWrapMode(Esr, WrapAtEdges);
    if PressedAltI then SetProtection(True); {v2.5a}
    AddChoiceField(Esr, 'Contest:', 6, 4, 'XXXXXXXXXXXXXXXXXX',
      6, 18, 0, 1, @IncChoice, Contest);
    SetProtection(False);
    AddStringField(Esr, 'Call:', 6, 42, '!!!!!!!!!!!!',
      6, 47, 12, 0, nil, Call);
    AddStringField(Esr, 'Zone:', 6, 63, '99',
      6, 68, 2, 0, nil,  CQzone);
    AddStringField(Esr, 'Name:', 8, 4, '',
      8, 18, 30, 0, nil, Name);
    AddStringField(Esr, 'Address:', 9, 4, '',
      9, 18, 30, 0, nil, Street);
    AddStringField(Esr, 'City:', 10, 4, '',
      10, 18, 20, 0, nil, Town);
    AddStringField(Esr, 'St:', 10, 42, '!!!',
      10, 45, 3, 0, nil, State);
    AddStringField(Esr, 'Zip:', 10, 63, '!!!!!!',
      10, 67, 6, 0, nil, ZipCode);
    AddStringField(Esr, 'Affiliation:', 12, 4, '',
      12, 18, 50, 0, nil, Club);
    AddChoiceField(Esr, 'Class:', 14, 4, CharStr('X', 22),
      14, 18, 0, 1, @IncChoice, Class);
    AddIntField(Esr, 'Power:', 14, 63, '9999',
      14, 69, 0, 0, 9999, Power);
    SetProtection(True);
    AddStringField(Esr, 'File Name: ', 16, 4, CharStr('X', 40),
      16, 18, 40, 0, nil, BinFileName);
    SetProtection(False);
    AddChoiceField(Esr, 'Tnc:', 19, 52, 'XXXXXXXXXX',
      19, 61, 0, 1, @IncChoice, NewTnc);
    CtrlEnter(21, 4);
    ShowMouse;
    AddCmd(ESincChoice, kbGrayPlus);
    AddCmd(ESEnd,  kbEnd);
    AddCmd(ESHome, kbHome);
    AddCmd(EsQuit, kbEsc);
    repeat
      ExitCommand := EditScreen(Esr, 0, False);
    until ExitCommand in [EsQuit, EsDone];
    if (ExitCommand = EsQuit) and (NOT PressedAltI) then begin { first time cancel }
      CloseDownScreen;
      Writeln('<esc> pressed');
      halt;
    end;
    AddCmd(ESmy28, kbGrayPlus);
    AddCmd(ESmy25, kbEnd);
    AddCmd(ESmy23, kbHome);
    AddCmd(Esmy49, kbEsc);
    HideMouse;
    KillWindow(EditPtr);
    DisposeEditScreen(Esr);
    Case ExitCommand of
      EsQuit : begin { normal cancel }
                 MsgWin^.Display('<esc> Pressed, changes cancelled');
                 RttyWin^.makeTop;
                 Exit;
               end;
      EsDone : begin
                 if Assigned(MsgWin) then MsgWin^.Clear;
                 with RttyIni^ do begin
                   SetOrAddProfileString('Contest', 'Current', Trim(ContestName[Contest]));
                   SetOrAddProfileString('Call', 'Profile', Trim(Call));
                   SetOrAddProfileString('Name', 'Profile', Trim(Name));
                   SetOrAddProfileString('Street', 'Profile', Trim(Street));
                   SetOrAddProfileString('City', 'Profile', Trim(Town));
                   SetOrAddProfileString('State', 'Profile', Trim(State));
                   SetOrAddProfileString('ZipCode', 'Profile', Trim(ZipCode));
                   SetOrAddProfileString('Club', 'Profile', Trim(CLub));
                   SetOrAddProfileString('Power', 'Profile', Trim(long2str(Power)));
                   SetOrAddProfileString('Class', 'Profile', Trim(Classes[Class]));
                   SetOrAddProfileString('CqZone', 'Profile', Trim(CQZone));
                   SetOrAddProfileString('Type','TNC1',Trim(Tncs[NewTnc]));
                 end;
               end;
    end;
bypass:
    ByPassWorkSheet := False; {so they can get to it with alt-i}
    RttyWin^.makeTop;
    if Assigned(RttyTerm1) and (NewTnc <> OldTnc) then begin
      Dispose(RttyTerm1,Done);
      RttyTerm1 := NIL;
    end;
    if not Assigned(RttyTerm1) then CreateTnc;
    PressedAltI := True;        {from now on, only way to get here is pressing alt-i}
    KillWindow(TuneWin);
    case RttyTerm1^.TncNum of
      bk6sti : with Colors^ do begin
                  if not MakeWindow(TuneWin, 57, EW_Ylo, ScreenWidth, EW_Yhi, True, True, True,
                    WindowAttr, FrameAttr, HeaderAttr, '') then NotEnoughMemory(True);
                  DisplayWindow(TuneWin);
                  FastWrite(' Tuning ', ScreenHeight-2, ScreenWidth-17, FrameAttr);
                  FastWrite('', ScreenHeight, ScreenWidth-17, FrameAttr);
               end;
      bP38 : if RttyIni^.GetProfileBool('NoDisplay', 'P38', False) then
            {}
            else with Colors^ do begin
              if not MakeWindow(TuneWin, 57, EW_Ylo, ScreenWidth, EW_Yhi, True, True, True,
                WindowAttr, FrameAttr, HeaderAttr, '') then NotEnoughMemory(True);
              DisplayWindow(TuneWin);
              FastWrite('Tuning Indicator', ScreenHeight-2, ScreenWidth-21, FrameAttr);
            end;
      bpci4000 : if RttyIni^.GetProfileBool('NoDisplay', 'PCI-4000', False) then
                {}
                else with Colors^ do begin
                  if not MakeWindow(TuneWin, 57, EW_Ylo, ScreenWidth, EW_Yhi, True, True, True,
                    WindowAttr, FrameAttr, HeaderAttr, '') then NotEnoughMemory(True);
                  DisplayWindow(TuneWin);
                  FastWrite('Tuning Indicator', ScreenHeight-2, ScreenWidth-21, FrameAttr);
                end;
      bdsp4100 : if RttyIni^.GetProfileBool('NoDisplay', 'DSP-4100', False) then
                {}
                else with Colors^ do begin
                  if not MakeWindow(TuneWin, 57, EW_Ylo, ScreenWidth, EW_Yhi, True, True, True,
                    WindowAttr, FrameAttr, HeaderAttr, '') then NotEnoughMemory(True);
                  DisplayWindow(TuneWin);
                  FastWrite('Tuning Indicator', ScreenHeight-2, ScreenWidth-21, FrameAttr);
                end;
      bdxp38 : if RttyIni^.GetProfileBool('NoDisplay', 'DXP38', False) then
                {}
                else with Colors^ do begin
                  if not MakeWindow(TuneWin, 57, EW_Ylo, ScreenWidth, EW_Yhi, True, True, True,
                    WindowAttr, FrameAttr, HeaderAttr, '') then NotEnoughMemory(True);
                  DisplayWindow(TuneWin);
                  FastWrite('Tuning Indicator', ScreenHeight-2, ScreenWidth-21, FrameAttr);
                end;
    else with Colors^ do begin
        if not MakeWindow(TuneWin, 57, EW_Ylo, ScreenWidth, EW_Yhi, False, True, True,
          WindowAttr, FrameAttr, HeaderAttr, '') then NotEnoughMemory(True);
        DisplayWindow(TuneWin);
      end;
    end;
    ShowMouse;
  end;

  procedure SetMyInfo;
  var
    Esr : EsRecord;
    ExitCommand : EStype;
    SetPtr : WindowPtr;
    My_Rst : integer;
    My_Qth : String[3];
    My_Age : String[2];
  begin
    My_Rst := RttyIni^.GetProfileInt('UsualRST','Profile',599);
    My_Qth := RttyIni^.GetProfileString('Qth','Profile','');
    My_Age := RttyIni^.GetProfileString('Age','Profile','');
    if (My_Qth <> '') and (My_Age <> '') then Exit;
    with Colors^ do
      if not MakeWindow(SetPtr, 3, 3, 40, 8, True, True, False, WindowAttr,
        FrameAttr, HeaderAttr, 'Set My Information') then begin
          NotEnoughMemory(False);
          Exit;
        end;
    HideMouse;
    DisplayWindow(SetPtr);
    InitEsRecord(Esr);
    Colors^.SetEntryAttributes;
    SetWrapMode(Esr, WrapAtEdges);
    AddIntField(Esr, 'Usual RST   9', 5, 6,
      '99', 5, 17, 0, 11, 59, My_Rst);
    AddStringField(Esr, 'My Age', 6, 6,
      '99', 6, 17, 3, 0, nil, My_Age);
    AddStringField(Esr, 'My QTH', 7, 6,
      '!!!', 7, 17, 3, 0, nil, My_Qth);
    CtrlEnter(8, 4);
    ShowMouse;
    repeat
      ExitCommand := EditScreen(Esr, 0, False);
    until ExitCommand in [EsQuit, EsDone];
    if ExitCommand = EsDone then begin
      RttyIni^.SetOrAddProfileString('UsualRST','Profile',long2str(My_Rst));
      RttyIni^.SetOrAddProfileString('Qth','Profile',My_Qth);
      RttyIni^.SetOrAddProfileString('Age','Profile',My_Age);
    end;
    KillWindow(SetPtr);
    DisposeEditScreen(Esr);
  end;

  procedure SerialPortChoice(var Value; FieldID : Byte;
    Factor : Integer;
    var St : String); far;
  var
    Parity : ParityType absolute Value;
    HandShake : HandShakeType absolute Value;
  begin
    case FieldID of
      4, 10, 16, 22, 28, 34, 40, 46 : begin
                                        case Factor of
                                          1 : if Parity = EvenParity then Parity := NoParity
                                              else Inc(Parity);
                                          -1 : if Parity = NoParity then Parity := EvenParity
                                               else Dec(Parity);
                                        end;
                                        St := ParityString[Parity];
                                      end;
      5, 11, 17, 23, 29, 35, 41, 47 : begin
                                        case Factor of
                                          1 : if HandShake = DtrDsr then HandShake := NoHandShake
                                              else Inc(HandShake);
                                          -1 : if HandShake = NoHandShake then HandShake := DtrDsr
                                               else Dec(HandShake);
                                        end;
                                        St := HandShakeString[HandShake];
                                      end;

    end;
  end;

  procedure SetSerialPorts;
  var
    Esr : EsRecord;
    ExitCommand : EStype;
    WinPtr : WindowPtr;
    b : Byte;
    iAvailable : array[COM1..Com8] of Boolean;
    iBaudRate : array[COM1..Com8] of LongInt;
    iDataBits : array[COM1..Com8] of LongInt;
    iStopBits : array[COM1..Com8] of LongInt;
    iParity : array[COM1..Com8] of ParityType;
    iHandShake : array[COM1..Com8] of HandShakeType;
    Com : ComNameType;
  begin
    with Colors^ do begin
    if not MakeWindow(WinPtr, 1, 1, 80, 25, True, True, False, WindowAttr,
      FrameAttr, HeaderAttr, 'Serial Port Settings') then begin
      NotEnoughMemory(False);
      Exit;
    end;
    HideMouse;
    DisplayWindow(WinPtr);
    InitEsRecord(Esr);
    SetEntryAttributes;
    SetTrimBlanks(Off);
    SetWrapMode(Esr, WrapAtEdges);
    for Com := COM1 to Com8 do begin
      iBaudRate[Com] := RttyIni^.GetProfileLong('BaudRate', ComNameString(Com), 0);
      iParity[Com] := ParityStringToParity(RttyIni^.GetProfileString('Parity', ComNameString(Com), ' '));
      iDataBits[Com] := RttyIni^.GetProfileLong('DataBits', ComNameString(Com), 0);
      iStopBits[Com] := RttyIni^.GetProfileLong('StopBits', ComNameString(Com), 0);
      iHandShake[Com] := HandShakeStringToHandShake(RttyIni^.GetProfileString('HandShake', ComNameString(Com), ' '));
      if (iBaudRate[Com] = 0) and
      (iDataBits[Com] = 0) and
      (iStopBits[Com] = 0) then
        iAvailable[Com] := False
      else
        iAvailable[Com] := True;
      if (iBaudRate[Com] = 0) then iBaudRate[Com] := 9600;
      if (iDataBits[Com] = 0) then iDataBits[Com] := 8;
      if (iStopBits[Com] = 0) then iStopBits[Com] := 1;
    end;

    FastWriteWindow('Port Available BaudRate DataBits StopBits Parity HandShake Buffer', 2, 4, HiLiteAttr);
    {                    ..+....0.........2.........3.........4.........5.........6.........7 }
    for Com := COM1 to Com8 do begin
      AddBooleanField(Esr, ComNameString(Com), Ord(Com)+4, 4, '',
        Ord(Com)+4, 12, 0, iAvailable[Com]);
      AddLongField(Esr, '', Ord(Com)+4, 2, '999999',
        Ord(Com)+4, 22, 0, 110, 115200, iBaudRate[Com]);
      AddLongField(Esr, '', Ord(Com)+4, 2, '9',
        Ord(Com)+4, 31, 0, 5, 8, iDataBits[Com]);
      AddLongField(Esr, '', Ord(Com)+4, 2, '9',
        Ord(Com)+4, 40, 0, 1, 2, iStopBits[Com]);
      AddChoiceField(Esr, '', Ord(Com)+4, 2, 'XXXXXXX',
        Ord(Com)+4, 49, 0, 1, @SerialPortChoice, iParity[Com]);
      AddChoiceField(Esr, '', Ord(Com)+4, 2, 'XXXXXXXXXX',
        Ord(Com)+4, 56, 0, 1, @SerialPortChoice, iHandShake[Com]);
    end;
    FastWriteWindow('Available [T,F]     indicate if the port exists in your system', 14, 4, HiLiteAttr);
    FastWriteWindow('BaudRate  [######]  specify the baud rate', 15, 4, HiLiteAttr);
    FastWriteWindow('DataBits  [5,6,7,8] specify the number of data bits per word', 16, 4, HiLiteAttr);
    FastWriteWindow('StopBits  [1,2]     specify the number of stop bits per word', 17, 4, HiLiteAttr);
    FastWriteWindow('Parity    [XXXXXX]  use the space bar to specify the parity', 18, 4, HiLiteAttr);
    FastWriteWindow('Handshake [XXXXXX]  use the space bar to specify the handshaking technique', 19, 4, HiLiteAttr);
    FastWriteWindow('* * Please mark your mouse port as NOT AVAILABLE! * *', 22, 4, HiLiteAttr);
    CtrlEnter(25, 4);
    ShowMouse;
    AddCmd(ESEnd, kbEnd);
    AddCmd(ESHome, kbHome);
    AddCmd(EsQuit, kbEsc);
    repeat
      ExitCommand := EditScreen(Esr, 0, False);
    until ExitCommand in [EsQuit, EsDone];
    if ExitCommand = EsDone then begin
      for Com := COM1 to Com8 do begin
        if iAvailable[Com] then begin
          RttyIni^.SetOrAddProfileString('BaudRate', ComNameString(Com), long2str(iBaudRate[Com]));
          RttyIni^.SetOrAddProfileString('Parity', ComNameString(Com), ParityString[iParity[Com]]);
          RttyIni^.SetOrAddProfileString('DataBits', ComNameString(Com), long2str(iDataBits[Com]));
          RttyIni^.SetOrAddProfileString('StopBits', ComNameString(Com), long2str(iStopBits[Com]));
          RttyIni^.SetOrAddProfileString('HandShake', ComNameString(Com), HandShakeString[iHandShake[Com]]);
        end;
      end;
    end;
    AddCmd(ESmy25, kbEnd);
    AddCmd(ESmy23, kbHome);
    AddCmd(Esmy49, kbEsc);
    end;
    KillWindow(WinPtr);
    DisposeEditScreen(Esr);
  end;


procedure InitWrkSheet;
begin
  NewContestStartup := False;
  PressedAltI := False;
end;

end.
