{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
program Country;
uses
  TPcrt,
  TpDos,
  TPedit,
  TPentry,
  TPpick,
  TPrarray,
  TpString,
  TPwindow,
  OpSort,
  ccountry,
  cColors,
  IniFile,
  RecTypes;


type

  Edit_Rec_Type = record
                    Num : Word;   { points to member }
                    Name : String[20];
                    Code : String[5];
                    CqZone : Byte;
                    Continent : String[2];
                    Info : String[10];
                    Prefix : array[0..159] of String[8];
                    Pf_Num : array[0..159] of Word; { points to each member }
                  end;

var
  CountryFileName,
  PrefixFileName,
  CTFileName : String[30];
  Ct_File : Text;
  I, Ct_Recno : Integer;
  CT, Ct_Zero : Ct_Rec_Type;
  PF, Pf_Zero : Pf_Rec_Type;
  ed : Edit_Rec_Type;
  Ct_Num, Pf_Num,
  W, Choice : Word;
  MainWinPtr : WindowPtr;
  CT_flag,
  PF_flag : Boolean;
  FilesGotten,
  Escaped : Boolean;
  Ch : Char;
  OrigCode : String[5];
  ErrorString : array[1..3] of String[45];
  New_Ct_Array : TParray;
  B : Byte;
  PrefixDatDone : Boolean;
  FileNames : String[60];
  Ct_Array : TParray;
  Pf_Array : TParray;
  PrefixesUsed, CountriesUsed : word;
const
  MaxCountry = 340;
  MaxPrefix = 1700;

  procedure BlankErrors;
  begin
    ErrorString[1] := '';
    ErrorString[2] := '';
    ErrorString[3] := '';
  end;

  function FileChoice(Num : Word) : String; far;
  begin
    case Num of
      1 : FileChoice := 'All other contests';
      2 : FileChoice := 'Only CQWW & WAE';
    end;
  end;

  procedure GetArrayNames;
  var
    Num : Word;
  begin
    Num := 1;
    PickWindow(@FileChoice, 2, 3, 3, 28, 9, True, Colors^.PickColors, 'Select Contest Files', Num);
    case Num of
      1 : begin
            CountryFileName := 'ARRL.CTY';
            PrefixFileName := 'ARRL.PFX';
          end;
      2 : begin
            CountryFileName := 'CQWW.CTY';
            PrefixFileName := 'CQWW.PFX';
          end;
    end;
    FileNames := CountryFileName+'/'+PrefixFileName;
  end;

  function TestFiles : Boolean;
  begin
    TestFiles := (ExistFile(CountryFileName)) and (ExistFile(PrefixFileName));
  end;


  procedure DisplayError;
  var
    Win : WindowPtr;
  begin
    with Colors^ do begin
      MakeWindow(Win, 10, 10, 60, 15, True, True, False, WindowAttr, FrameAttr, HeaderAttr, 'ERROR');
      DisplayWindow(Win);
      FastWriteWindow(ErrorString[1], 2, 2, TextAttr);
      FastWriteWindow(ErrorString[2], 3, 2, TextAttr);
      FastWriteWindow(ErrorString[3], 4, 2, TextAttr);
      FastWrite('Press Any Key to continue', 15, 11, WindowAttr);
    end;
    HiddenCursor;
    repeat until Keypressed;
    BlockCursor;
    KillWindow(Win);
  end;

  function OpenRtn : Boolean;
  begin
    BlankErrors;
    GetArrayNames;
    if TestFiles then begin
      LoadA(Ct_Array, CountryFileName);
      CT_flag := True;
      LoadA(Pf_Array, PrefixFileName);
      PF_flag := True;
      MakeA(New_Ct_Array, MaxCountry, 1, SizeOf(Ct_Rec_Type));
      ClearA(New_Ct_Array, Ct_Zero, ExactInit);
      FilesGotten := True;
      OpenRtn := True;
    end
    else begin
      ErrorString[1] := 'Unable to open files';
      ErrorString[2] := 'Please try again.';
      DisplayError;
      OpenRtn := False;
    end;
  end;

  procedure SortCountryIn; far;
  begin
    for W := 0 to MaxCountry-1 do begin
      Reta(Ct_Array, W, 0, CT);
      if CT.Code = '' then CT.Code := SpecialEnd;
      if not PutElement(CT) then begin
        ErrorString[1] := 'Ran out of memory!';
        ErrorString[2] := 'Cannot continue.';
        DisplayError;
        Halt;
      end;
    end;
  end;

  function SortCountry(var R1, R2) : Boolean; far;
  var
    X1 : Ct_Rec_Type absolute R1;
    X2 : Ct_Rec_Type absolute R2;
  begin
    SortCountry := X1.Code < X2.Code;
  end;

  procedure SortCountryOut; far;
  begin
    W := 0;
    while GetElement(CT) do begin
      if CT.Code = SpecialEnd then CT.Code := '';
      Seta(New_Ct_Array, W, 0, CT);
      Inc(W);
    end;
  end;

  procedure MoveSortedToOutputArray;
  var
    New_Cty_No, Old_Cty_No : Word;
    New_Ct, Old_Ct : Ct_Rec_Type;
    PF_No : Word;
    Found : Boolean;
  begin
    HiddenCursor;
    for PF_No := 0 to MaxPrefix-1 do begin
      gotoxy(1, 16); WriteLn('Prefix #'+long2str(PF_No)+'  ');
      Reta(Pf_Array, PF_No, 0, PF);
      if PF.Cty_No < 9999 then begin
        Reta(Ct_Array, PF.Cty_No, 0, Old_Ct);
        Found := False;
        New_Cty_No := 0;
        while (New_Cty_No < MaxCountry) and (not Found) do begin
          gotoxy(1, 17); WriteLn('Country#'+long2str(New_Cty_No)+'  ');
          Reta(New_Ct_Array, New_Cty_No, 0, New_Ct);
          if Old_Ct.Code = New_Ct.Code then Found := True;
          Inc(New_Cty_No);
        end;
        Dec(New_Cty_No);
        PF.Cty_No := New_Cty_No;
        Seta(Pf_Array, PF_No, 0, PF);
      end;
    end;
    for Old_Cty_No := 0 to MaxCountry-1 do begin
      Reta(New_Ct_Array, Old_Cty_No, 0, New_Ct);
      Seta(Ct_Array, Old_Cty_No, 0, New_Ct);
    end;
    gotoxy(1, 15); WriteLn(charstr(' ', 25));
    gotoxy(1, 16); WriteLn(charstr(' ', 25));
    gotoxy(1, 17); WriteLn(charstr(' ', 25));
    gotoxy(1, 15);
    normalcursor;
  end;

  function Continent(Zone : Byte) : String;
  begin
    case Zone of
      1..8 : Continent := 'NA';
      9..13 : Continent := 'SA';
      14..16, 20, 40 : Continent := 'EU';
      33..39 : Continent := 'AF';
      17..19, 21..26, 28 : Continent := 'AS';
      27, 29..32 : Continent := 'OC';
    end;
  end;

  procedure SetZeroRecords;
  begin
    Ct_Zero.Name := '';
    Ct_Zero.Code := '';
    Ct_Zero.CqZone := 0;
    Ct_Zero.Info := '';
    Ct_Zero.Continent := '';
    Pf_Zero.Prefix := '';
    Pf_Zero.Cty_No := 9999;
  end;


  function CountryCodeExists(Code : String) : Boolean;
  var
    W : Word;
    Result : Boolean;
  begin
    W := 0;
    Result := False;
    while W < MaxCountry do begin
      Reta(Ct_Array, W, 0, CT);
      if CT.Code = Code then Result := True;
      Inc(W);
    end;
    CountryCodeExists := Result;
  end;


  procedure GetCountryCode;
  var
    WinPtr : WindowPtr;
  begin
    with Colors^ do begin
      MakeWindow(WinPtr, 3, 3, 18, 5, True, True, False, WindowAttr, FrameAttr, HeaderAttr, 'Code');
      DisplayWindow(WinPtr);
      OrigCode := '';
      ReadString('', 1, 1, 5, PromptAttr, StringAttr, CtrlAttr, Escaped, OrigCode);
      OrigCode := Trim(OrigCode);
    end;
    KillWindow(WinPtr);
  end;

  function sPickMenu(Choice : Word) : String; far;
  begin
    case Choice of
      1 : sPickMenu := 'Add Country';
      2 : sPickMenu := 'Cancel Changes';
      3 : sPickMenu := 'Change Country';
      4 : sPickMenu := 'Delete Country';
      5 : sPickMenu := 'List Countries';
      6 : sPickMenu := 'Open Files';
      7 : sPickMenu := 'Save Changes';
      8 : sPickMenu := 'Read ????.CTY';
      9 : sPickMenu := 'Read CTY.DAT';
      10 : sPickMenu := 'Exit';
    end;
  end;

  procedure PickMenu;
  begin
    PickWindow(@sPickMenu, 10, 3, 3, 22, 14, True, Colors^.PickColors, 'Pfx/Cty Menu', Choice);
  end;

  procedure InitEditRecord(var ed : Edit_Rec_Type);
  var
    B : Byte;
  begin
    ed.Num := 9999;
    ed.Name := '';
    ed.Code := '';
    ed.CqZone := 0;
    ed.Info := '';
    ed.Continent := '';
    for B := 0 to 159 do ed.Prefix[B] := '';
    for B := 0 to 159 do ed.Pf_Num[B] := 9999;
  end;

  procedure FillEditRecord(var ed : Edit_Rec_Type);
  var
    Error : Word;
    GotIt : Boolean;
    W : Word;
    B : Byte;
  begin
    if OrigCode = '' then Exit;
    Ct_Num := 0;
    GotIt := False;
    while (Ct_Num < MaxCountry) and (not GotIt) do begin
      Reta(Ct_Array, Ct_Num, 0, CT);
      if Trim(OrigCode) = Trim(CT.Code) then begin
        GotIt := True;
        ed.Name := CT.Name;
        ed.Code := CT.Code;
        ed.CqZone := CT.CqZone;
        ed.Continent := CT.Continent;
        ed.Info := CT.Info;
        ed.Num := Ct_Num;
        W := 0;
        B := 0;
        while (W < MaxPrefix) do begin
          Reta(Pf_Array, W, 0, PF);
          Error := ErrorA;
          if (PF.Cty_No = ed.Num) and (PF.Prefix <> '') and (B < 160) then begin
            ed.Prefix[B] := PF.Prefix;
            ed.Pf_Num[B] := W;
            Inc(B);
          end;
          Inc(W);
        end;
      end;
      Inc(Ct_Num);
    end;
  end;

  procedure HowMany(var Countries, Prefixes : Word);
  var
    Error : Word;
    i , J : word;
  begin
    I := 0;
    Countries := 0;
    Prefixes := 0;
    while (I < MaxCountry) do begin
      Reta(Ct_Array, I, 0, CT);
      if Trim(CT.Code) <> '' then Inc(Countries);
      inc(I);
    end;
    J := 0;
    while (J < MaxPrefix) do begin
      Reta(Pf_Array, J, 0, PF);
      if Trim(PF.Prefix) <> '' then Inc(Prefixes);
      inc(J);
    end;
  end;

  procedure UpdateArrays;
  var
    B : Byte;
  begin
    CT.Name := ed.Name;
    CT.Code := ed.Code;
    CT.Continent := ed.Continent;
    CT.CqZone := ed.CqZone;
    CT.Info := ed.Info;
    Seta(Ct_Array, ed.Num, 0, CT);
    for B := 0 to 159 do begin
      ed.Prefix[B] := Trim(ed.Prefix[B]);
      if ed.Pf_Num[B] < 9999 then { was originally there }
        if ed.Prefix[B] = '' then begin { now blank }
          PF.Cty_No := 0;
          PF.Prefix := '';
          Seta(Pf_Array, ed.Pf_Num[B], 0, PF);
        end
        else begin                { update in place }
          PF.Cty_No := ed.Num;
          PF.Prefix := Trim(ed.Prefix[B]);
          Seta(Pf_Array, ed.Pf_Num[B], 0, PF);
        end;
      if (ed.Pf_Num[B] = 9999) and (ed.Prefix[B] <> '') then begin { add this prefx for this country }
        W := 0;
        Reta(Pf_Array, W, 0, PF);
        while PF.Prefix <> '' do begin
          Inc(W);
          Reta(Pf_Array, W, 0, PF);
        end;
        PF.Prefix := ed.Prefix[B];
        PF.Cty_No := ed.Num;
        Seta(Pf_Array, W, 0, PF);
      end;
    end;
  end;

  procedure AddEdits;
  var
    W : Word;
    B : Byte;
    OK : Boolean;
  begin
    BlankErrors;
    ed.Code := Trim(ed.Code);
    ed.Name := Trim(ed.Name);
    ed.Info := Trim(ed.Info);

    { edit for blank fields }
    if ed.Name = '' then begin
      ErrorString[1] := 'Error: Country name is missing.';
      ErrorString[2] := 'Enter a country name in the name field.';
    end;
    if ErrorString[1] <> '' then Exit;
    if ed.Code = '' then begin
      ErrorString[1] := 'Error: Country code is missing.';
      ErrorString[2] := 'Enter a country code in the code field.';
    end;
    if ErrorString[1] <> '' then Exit;
    if ed.Continent = '' then begin
      ErrorString[1] := 'Error: Continent is missing.';
      ErrorString[2] := 'Enter a valid continent in the cont field.';
    end;
    if ErrorString[1] <> '' then Exit;

    { edit continent }
    OK := True;
    if not((ed.Continent <> 'NA') or (ed.Continent <> 'SA') or
      (ed.Continent <> 'EU') or (ed.Continent <> 'AS') or
      (ed.Continent <> 'OC') or (ed.Continent <> 'AN') or
      (ed.Continent <> 'AF'))
    then begin
      OK := False;
      ErrorString[1] := 'Enter a valid continent: NA,SA,EU,AS,AF,OC,AN';
      ErrorString[2] := '"'+ed.Continent+'" is not in this list.';
    end;
    if ErrorString[1] <> '' then Exit;
    { See if this code is already used }
    W := 0;
    while W < MaxCountry do begin
      Reta(Ct_Array, W, 0, CT);
      if ((CT.Code = ed.Code) and (CT.Code <> '')) then begin
        if ed.Num <> W then begin
          ErrorString[1] := 'Error: This country code is already in use.';
          ErrorString[2] := 'Check: "'+CT.Name+'" - "'+CT.Code+'"';
        end;
      end;
      Inc(W);
    end;
    if ErrorString[1] <> '' then Exit;
    { see if any prefixes are already in use }
    W := 0;
    while W < MaxPrefix do begin
      Reta(Pf_Array, W, 0, PF);
      if PF.Prefix <> '' then
        for B := 0 to 159 do
          if (ed.Prefix[B] = PF.Prefix) and (PF.Cty_No <> ed.Num) then begin
            Reta(Ct_Array, PF.Cty_No, 0, CT);
            ErrorString[1] := 'Error: This prefix is already in use.';
            ErrorString[2] := 'Check: "'+PF.Prefix+'" - "'+CT.Name+'" - "'+CT.Code+'"';
          end;
      Inc(W);
    end;
    if ErrorString[1] <> '' then Exit;
  end;

  procedure AddToCountryArrays;
  var
    B : Byte;
    W : Word;
  begin
    W := 0;
    Reta(Ct_Array, W, 0, CT);
    while CT.Code <> '' do begin
      Inc(W);
      Reta(Ct_Array, W, 0, CT);
    end;
    ed.Num := W;
    CT.Name := ed.Name;
    CT.Code := ed.Code;
    CT.Continent := ed.Continent;
    CT.CqZone := ed.CqZone;
    CT.Info := ed.Info;
    Seta(Ct_Array, W, 0, CT);
    W := 0;
    for B := 0 to 159 do
      if Trim(ed.Prefix[B]) <> '' then begin
        Reta(Pf_Array, W, 0, PF);
        while PF.Prefix <> '' do begin
          Inc(W);
          Reta(Pf_Array, W, 0, PF);
        end;
        PF.Prefix := Trim(ed.Prefix[B]);
        PF.Cty_No := ed.Num;
        Seta(Pf_Array, W, 0, PF);
      end;
  end;

  procedure EditCountry;
  var
    SWES : EsRecord;
    Win : WindowPtr;
    ExitCommand : EsType;
    row, col, B : Byte;
  begin
    with Colors^ do begin
      MakeWindow(Win, 1, 1, 80, 25, True, True, False, WindowAttr, FrameAttr, HeaderAttr, 'Edit Country');
      InitEsRecord(SWES);
      SetCtrlAttr(CtrlAttr);
      SetFieldAttr(PromptAttr);
      SetPromptAttr(PromptAttr);
      SetStringAttr(StringAttr);
      SetAutoAdvance(True);
      SetRequired(False);
      SetEntryWindow(SWES, 2, 2, 79, 24, False, PromptAttr, StringAttr);
      AddStringField(SWES, 'Name', 2, 2, '', 2, 7,
        20, 1, nil, ed.Name);
      AddStringField(SWES, 'Code', 2, 28, '', 2, 33,
        5, 1, nil, ed.Code);
      AddStringField(SWES, 'Cont', 2, 39, '!!', 2, 44,
        2, 1, nil, ed.Continent);
      AddByteField(SWES, 'Zone', 2, 47, '99', 2, 52,
        0, 0, 40, ed.CqZone);
      AddStringField(SWES, 'Info', 2, 55, '', 2, 60,
        10, 1, nil, ed.Info);
      B := 0;
      for row := 0 to 19 do
        for col := 0 to 7 do begin
          AddStringField(SWES, '', row+4, col*9+2, '!!!!!!!!', row+4, col*9+2, 8, 1, nil, ed.Prefix[B]);
          Inc(B);
        end;
      DisplayWindow(Win);
      FastWrite('Ctrl-Enter to continue', 25, 4, WindowAttr);
    end;
    Escaped := False;
    repeat
      ExitCommand := EditScreen(SWES, 0, False);
      if ExitCommand = EsQuit then begin
        Escaped := True;
        BlankErrors;
      end
      else
        AddEdits;
      if ErrorString[1] <> '' then DisplayError;
    until (ErrorString[1] = '') or (Escaped);

    KillWindow(Win);
    DisposeEditScreen(SWES);
  end;


  procedure AddCountry;
  begin
    if not FilesGotten then
      if not OpenRtn then Exit;
    InitEditRecord(ed);
    EditCountry;
    if not Escaped then AddToCountryArrays;
    Escaped := False;
  end;

  procedure CancelChanges;
  var
    Win : WindowPtr;
    KeyStroke : Word;
  begin
    if not FilesGotten then
      if not OpenRtn then Exit;
    with Colors^ do begin
      MakeWindow(Win, 10, 10, 60, 15, True, True, False, WindowAttr, FrameAttr, HeaderAttr, 'Confirm');
      DisplayWindow(Win);
      FastWriteWindow('Press ENTER to Cancel ALL changes.', 2, 2, TextAttr);
      FastWriteWindow('Press any other key to cancel.', 3, 2, TextAttr);
    end;
    HiddenCursor;
    repeat until Keypressed;
    BlockCursor;
    KeyStroke := ReadKeyWord;
    if Lo(KeyStroke) = 13 then begin
      if CT_flag then DisposeA(Ct_Array);
      CT_flag := False;
      if PF_flag then DisposeA(Pf_Array);
      PF_flag := False;
      FilesGotten := False;
    end;
    KillWindow(Win);
  end;

  procedure ChangeCountry;
  begin
    if not FilesGotten then
      if not OpenRtn then Exit;
    BlankErrors;
    GetCountryCode;
    if OrigCode = '' then Exit;
    if not CountryCodeExists(OrigCode) then begin
      ErrorString[1] := 'Country code not found.';
      DisplayError;
      Exit;
    end;
    InitEditRecord(ed);
    FillEditRecord(ed);
    EditCountry;
    if not Escaped then UpdateArrays;
  end;

  procedure DeleteCountry;
  var
    Win : WindowPtr;
    KeyStroke : Word;
    W1 : Word;
  begin
    if not FilesGotten then
      if not OpenRtn then Exit;
    GetCountryCode;
    if OrigCode = '' then Exit;
    W := 0;
    while W < MaxCountry do begin
      Reta(Ct_Array, W, 0, CT);
      if CT.Code = OrigCode then begin
        with Colors^ do begin
          MakeWindow(Win, 10, 10, 60, 15, True, True, False, WindowAttr, FrameAttr, HeaderAttr, 'Confirm');
          DisplayWindow(Win);
          FastWriteWindow(CT.Name+' '+CT.Code, 2, 2, TextAttr);
          FastWriteWindow('Press ENTER to delete this country.', 3, 2, TextAttr);
          FastWriteWindow('Press any other key to cancel.', 4, 2, TextAttr);
        end;
        HiddenCursor;
        repeat until Keypressed;
        BlockCursor;
        KeyStroke := ReadKeyWord;
        if Lo(KeyStroke) = 13 then begin
          CT.Code := '';
          CT.Name := '';
          CT.Continent := '';
          CT.CqZone := 0;
          CT.Info := '';
          Seta(Ct_Array, W, 0, CT);
          W1 := 0;
          while W1 < MaxPrefix do begin
            Reta(Pf_Array, W1, 0, PF);
            if PF.Cty_No = W then begin
              PF.Prefix := '';
              PF.Cty_No := 0;
              Seta(Pf_Array, W1, 0, PF);
            end;
            Inc(W1);
          end;
        end;
        KillWindow(Win);
      end;
      Inc(W);
    end;
  end;

  procedure SortPrefixIn; far;
  begin
    for W := 0 to MaxPrefix-1 do begin
      Reta(Pf_Array, W, 0, PF);
      if PF.Prefix = '' then PF.Prefix := SpecialEnd;
      PutElement(PF);
    end;
  end;

  function SortPrefix(var R1, R2) : Boolean; far;
  var
    X1 : Pf_Rec_Type absolute R1;
    X2 : Pf_Rec_Type absolute R2;
  begin
    SortPrefix := X1.Prefix < X2.Prefix;
  end;

  procedure SortPrefixOut; far;
  begin
    W := 0;
    while GetElement(PF) do begin
      if PF.Prefix = SpecialEnd then PF.Prefix := '';
      Seta(Pf_Array, W, 0, PF);
      Inc(W);
    end;
  end;

  procedure SaveChanges;
  var
    H : Pf_Rec_Type;
    OneTime : Boolean;
    SortStat : SortStatus;
  begin
    if not FilesGotten then Exit;
    OneTime := False;
    gotoxy(1, 15);
    WriteLn('Sorting Prefixes ...');
    SortStat := Sort(MaxPrefix, SizeOf(PF), SortPrefixIn, SortPrefix, SortPrefixOut);
    case SortStat of
      SortSuccess : WriteLn('Sort complete.');
      SortOutOfMemory : WriteLn('Insufficient Memory.');
      SortTooManyElements : WriteLn('Too many elements to sort.');
    end;
    gotoxy(1, 15);
    WriteLn('Sorting Countries ...');
    SortStat := Sort(MaxCountry, SizeOf(CT), SortCountryIn, SortCountry, SortCountryOut);
    case SortStat of
      SortSuccess : WriteLn('Sort complete.');
      SortOutOfMemory : WriteLn('Insufficient Memory.');
      SortTooManyElements : WriteLn('Too many elements to sort.');
    end;
    gotoxy(1, 15);
    WriteLn('Indexing/Verifying ...');
    MoveSortedToOutputArray;
    StoreA(Ct_Array, CountryFileName);
    StoreA(Pf_Array, PrefixFileName);
    for Pf_Num := 0 to MaxPrefix-2 do begin
      Reta(Pf_Array, Pf_Num, 0, PF);
      Reta(Pf_Array, Pf_Num+1, 0, H);
      if (H.Prefix = PF.Prefix) and (H.Prefix <> '') then begin
        if not OneTime then begin
          OneTime := True;
          Write('Duplicate Prefix(s) found - '+H.Prefix);
        end
        else
          Write(' & '+H.Prefix);
      end;
    end;
  end;

  function Open_CT_Country_File : Boolean;
  begin
    Assign(Ct_File, CTFileName);
    {$I-}
    Reset(Ct_File);
    {$I+}
    I := IoResult;
    if I <> 0 then begin
      WriteLn('Unable to open :'+CTFileName);
      Open_CT_Country_File := False;
    end
    else
      Open_CT_Country_File := True;
  end;


  procedure Get_CT_char(var Ch : Char);
  begin
    Read(Ct_File, Ch);
    if Ch = ';' then Inc(Ct_Recno);
    if Ch in [#0..#31] then Ch := #0; {ignore these characters} ;
  end;

  procedure Process_CTY_File;
  var
    Ch : Char;
    Str : String[20];
    S30 : String[30];
    I : Integer;
    Win : WindowPtr;
    OK, PrefixDone : Boolean;
  begin
    gotoxy(1, 13);
    CT := Ct_Zero;
    PF := Pf_Zero;
    PF.Cty_No := 0;
    Str := '';
    with Colors^ do begin
      MakeWindow(Win, 3, 3, 32, 5, True, True, False, WindowAttr, FrameAttr, HeaderAttr, '');
      DisplayWindow(Win);
      while not Eof(Ct_File) do begin ;
        { first get country name, read up to first colon as delimiter }
        FastWriteWindow('Now reading Country # '+long2str(PF.Cty_No+1),
          1, 1, WindowAttr);
        I := 0;
        S30 := '';
        repeat
          Get_CT_char(Ch);
          S30 := S30+Ch;
          Inc(I);
          if I > 26 then begin
            WriteLn(CT.Name+': Country not found in 1-20 followed by colon');
            Halt;
          end;
        until Ch = ':';
        S30 := Trim(S30);
        if S30[Length(S30)] = ':' then Dec(S30[0]);
        if Length(S30) > 20 then CT.Name := Copy(S30, 1, 20)
        else CT.Name := S30;
        { next, get cq zone, that is up to next colon }
        I := 0;
        Str := '';
        repeat
          Get_CT_char(Ch);
          if I > 3 then begin
            WriteLn(CT.Name+': Zone too long(01-40 only)');
            Halt;
          end;
          if not(Ch in [' ', ':', '.', ';']) then begin
            Str := Str+Ch;
            Inc(I);
          end;
        until Ch = ':';
        if not Str2Int(Str, I) then begin
          WriteLn(CT.Name+': Zone not number');
          Halt;
        end;
        if (I < 1) or (I > 40) then begin
          WriteLn(CT.Name+': Zone out of range(01-40)');
          Halt;
        end;
        CT.CqZone := I;

        { next, read in country code }
        I := 0;
        repeat
          Get_CT_char(Ch);
          if I > 50 then Ch := ':'; {safety net}
          if not(Ch in [' ', ':']) then begin
            if Length(CT.Code) < 5 then CT.Code := CT.Code+Ch;
            Inc(I);
          end;
        until Ch = ':';
        CT.Code := Trim(CT.Code);
        if CT.Code = 'K' then CT.Code := 'W';

        { now read in all prefixes for that country }
        PrefixDone := False;
        Str := '';
        I := 0;
        repeat
          Get_CT_char(Ch);
          {some prefixes have a zone attached to them. i ignore them}
          if Ch = '(' then PrefixDone := True;
          {maybe read until Ch := ')' then read one more? }
          if PrefixDone and (Ch in [',', ';', '.']) then PrefixDone := False;
          if not PrefixDone then begin
            if I > 20 then begin
              WriteLn(CT.Name+': Prefix too long(max=20 chars)');
              Halt;
            end;
            if Ch = '&' then Ch := ',';
            if not(Ch in [',', ';', ' ', #0, '.']) then begin
              Str := Str+Ch;
              Inc(I);
            end;
            if Ch in [',', ';', '.'] then begin
              PF.Prefix := Trim(Str);
              Seta(Pf_Array, Pf_Num, 0, PF); { set array entry }
              Inc(Pf_Num);
              if Pf_Num >= MaxPrefix then begin
                KillWindow(Win);
                WriteLn('Too many prefixes!  This file is too large to convert.');
                WriteLn('Please contact WF1B or download new WF1B files from the internet.');
                Halt;
              end;
              PF.Prefix := '';
              Str := '';
              I := 0;
            end;
          end;
        until (Ch = ';');
        ReadLn(Ct_File, Str);
        Str := Trim(Str);
        if Str <> '' then begin
          while Pos('  ', Str) > 0 do
            Delete(Str, Pos('  ', Str), 1);
          if Pos(' ', Str) > 0 then begin
            CT.Continent := Copy(Str, 1, Pos(' ', Str)-1);
            if (CT.Continent = 'NA') or (CT.Continent = 'SA') or
            (CT.Continent = 'EU') or (CT.Continent = 'AS') or
            (CT.Continent = 'OC') or (CT.Continent = 'AF') then { its OK }
            else CT.Continent := Continent(CT.CqZone); { generate a default }
            CT.Info := Copy(Str, Pos(' ', Str)+1, Length(Str)-Pos(' ', Str));
          end
          else begin
            if (Trim(Str) = 'NA') or (Trim(Str) = 'SA') or
            (Trim(Str) = 'EU') or (Trim(Str) = 'AS') or
            (Trim(Str) = 'OC') or (Trim(Str) = 'AF') { its OK }
            then CT.Continent := Trim(Str);
            if CT.Continent = '' then CT.Info := Trim(Copy(Pad(Str, 10), 1, 10));
          end;
        end;
        if CT.Continent = '' then CT.Continent := Continent(CT.CqZone);
        Seta(Ct_Array, PF.Cty_No, 0, CT);
        Inc(PF.Cty_No);
        CT.Name := '';
        CT.Code := '';
        CT.CqZone := 0;
        CT.Continent := '';
        CT.Info := '';
      end;
    end;
    KillWindow(Win);
  end;

  function GetNextDatWord : String;
  var
    s : String[50];
    I : Integer;
  begin
    s := '';
    I := 0;
    repeat
      Get_CT_char(Ch);
      Inc(I);
      if not(Ch in [':']) then s := s+Ch;
    until (Ch = ':') or (I = 50);
    s := Trim(s);
    GetNextDatWord := Pad(s, 50);
  end;

  function GetNextDatPrefix : String;
  var
    s : String[50];
    I : Integer;
  begin
    PrefixDatDone := False;
    s := '';
    I := 0;
    repeat
      Get_CT_char(Ch);
      Inc(I);
      PrefixDatDone := Ch = ';';
      if not(Ch in [',', ';', ' ', #00]) then s := s+Ch;
    until (Ch in [',', ';']) or (I = 50);
    GetNextDatPrefix := Pad(s, 50);
  end;

  procedure Process_DAT_File;
  var
    Ch : Char;
    Str, junk : String[20];
    S25 : String[30];
    I : Integer;
    Win : WindowPtr;
    OK, PrefixDone : Boolean;
    IgnoreThisCountry : Boolean;
    lat, long : String[7];
  begin
    gotoxy(1, 13);
    CT := Ct_Zero;
    PF := Pf_Zero;
    PF.Cty_No := 0;
    Str := '';
    with Colors^ do begin
      MakeWindow(Win, 3, 3, 32, 5, True, True, False, WindowAttr, FrameAttr, HeaderAttr, '');
      DisplayWindow(Win);
      while not Eof(Ct_File) do begin ;
        IgnoreThisCountry := False;
        { first get country name, read up to first colon as delimiter }
        FastWriteWindow('Now reading Country # '+long2str(PF.Cty_No+1),
          1, 1, WindowAttr);

        CT.Name := Trim(Copy(GetNextDatWord, 1, 25));
        if CT.Name = '' then Break;

        { next, get cq zone, that is up to next colon }

        Str := Trim(Copy(GetNextDatWord, 1, 2));
        if not Str2Int(Str, I) then begin
          WriteLn(CT.Name+': Zone not number');
          Halt;
        end;
        if (I < 1) or (I > 40) then begin
          WriteLn(CT.Name+': Zone out of range(01-40)');
          Halt;
        end;
        CT.CqZone := I;

        { next, read in the itu zone and discard }
        GetNextDatWord;

        { next, read in continent code }
        CT.Continent := Copy(GetNextDatWord, 1, 2);

        { get latitude & longitude }
        lat := GetNextDatWord;
        long := GetNextDatWord;
        { next, discard next three items? whatever they are...}

        junk := GetNextDatWord;

        { next, read in country code }
        CT.Code := Trim(Copy(GetNextDatWord, 1, 5));
        if CT.Code = 'K' then CT.Code := 'W';

        if CT.Code[1] = '*' then begin {a * means its a wae country}
          CT.Code[1] := ' ';
          CT.Code := Trim(CT.Code);
          IgnoreThisCountry := CountryFileName[1] = 'A'; {arrl doesnt use there countries}
        end;

        { now read in all prefixes for that country }
        repeat
          Str := GetNextDatPrefix;
          I := Pos('(', Str);
          if I = 0 then I := Pos('[', Str);
          if I = 0 then I := Pos(' ', Str);

          PF.Prefix := Trim(Copy(Str, 1, I-1));
          Delete(Str, 1, I);

          if Str[4] = ')' then begin
            junk := Copy(Str, 2, 2); {junk has the cq zone}
            Delete(Str, 1, 4);
          end;

          if Str[4] = ']' then begin
            junk := Copy(Str, 2, 2); {junk has the itu zone}
            Delete(Str, 1, 4);
          end;

          if not IgnoreThisCountry then begin
            Seta(Pf_Array, Pf_Num, 0, PF); { set array entry }
            Inc(Pf_Num);
          end;
          PF.Prefix := '';
        until PrefixDatDone;

        if not IgnoreThisCountry then begin
          Seta(Ct_Array, PF.Cty_No, 0, CT);
          Inc(PF.Cty_No);
          if Pf_Num >= MaxPrefix then begin
            KillWindow(Win);
            WriteLn('Too many prefixes!  This file is too large to convert.');
            WriteLn('Please contact WF1B or download new WF1B files from the internet.');
            Halt;
          end;
        end;
        if PF.Cty_No > MaxPrefix then begin
          KillWindow(Win);
          WriteLn('# of prefixes exceeded! Cannot continue.');
          Halt;
        end;
        CT.Name := '';
        CT.Code := '';
        CT.CqZone := 0;
        CT.Continent := '';
        CT.Info := '';
      end;
    end;
    KillWindow(Win);
  end;

  procedure GetFileName(header : String);
  var
    Win : WindowPtr;
    SWES : EsRecord;
    ExitCommand : EsType;
  begin
    CTFileName := '';
    with Colors^ do begin
      MakeWindow(Win, 3, 3, 47, 7, True, True, False, WindowAttr, FrameAttr, HeaderAttr, header);
      InitEsRecord(SWES);
      SetCtrlAttr(CtrlAttr);
      SetFieldAttr(PromptAttr);
      SetPromptAttr(PromptAttr);
      SetStringAttr(StringAttr);
      SetEntryWindow(SWES, 3, 3, 47, 5, False, PromptAttr, StringAttr);
      AddStringField(SWES, 'Filename:', 3, 3, charstr('X', 30), 3, 13,
        30, 1, nil, CTFileName);
      DisplayWindow(Win);
      FastWriteWindow('<^Enter> Done', 4, 4, FrameAttr);
    end;
    repeat
      ExitCommand := EditScreen(SWES, 0, False);
    until (ExitCommand = EsQuit) or (ExitCommand = EsDone) or (ExitCommand = esMy47);
    if (ExitCommand = EsQuit) or (ExitCommand = esMy47) then CTFileName := '';
    KillWindow(Win);
    DisposeEditScreen(SWES);
  end;

  procedure TranslateFile(FileType : String);
  var
    Error : Word;
    SortStat : SortStatus;
  begin
    Ct_Recno := 1;
    ClrScr;
    if FileType = 'CTY' then
      GetFileName('Identify the K1EA Country File(.CTY)')
    else GetFileName('Identify the K1EA Country File(.DAT)');
    if CTFileName = '' then Exit;
    Ct_Num := 0;
    Pf_Num := 0;
    if not Open_CT_Country_File then begin
      ErrorString[1] := 'Unable to open text input file';
      ErrorString[2] := 'Please check: '+CTFileName;
      DisplayError;
      CTFileName := '';
    end;
    if CTFileName = '' then Exit;
    GetArrayNames;
    if not CT_flag then MakeA(Ct_Array, MaxCountry, 1, SizeOf(Ct_Rec_Type));
    ClearA(Ct_Array, Ct_Zero, ExactInit);
    CT_flag := True;
    if not PF_flag then MakeA(Pf_Array, MaxPrefix, 1, SizeOf(Pf_Rec_Type));
    ClearA(Pf_Array, Pf_Zero, ExactInit);
    PF_flag := True;
    if FileType = 'CTY' then Process_CTY_File
    else Process_DAT_File;
    gotoxy(1, 15);
    WriteLn('Sorting Prefixes ...');
    SortStat := Sort(MaxPrefix, SizeOf(PF), SortPrefixIn, SortPrefix, SortPrefixOut);
    case SortStat of
      SortSuccess : WriteLn('Sort complete.');
      SortOutOfMemory : WriteLn('Insufficient Memory.');
      SortTooManyElements : WriteLn('Too many elements to sort.');
    end;
    StoreA(Ct_Array, CountryFileName);
    StoreA(Pf_Array, PrefixFileName);
    FilesGotten := True;
    Close(Ct_File);
  end;


  procedure ListCountries;
  var
    WinPtr : WindowPtr;
    col, row : Byte;
    Num : Word;
  begin
    if not FilesGotten then
      if not OpenRtn then Exit;
    with Colors^ do begin
      MakeWindow(WinPtr, 1, 1, 80, 25, True, True, False, WindowAttr, FrameAttr, HeaderAttr, 'All Country Codes');
      DisplayWindow(WinPtr);
      row := 1;
      col := 1;
      for Num := 0 to MaxCountry-1 do begin
        Reta(Ct_Array, Num, 0, CT);
        if CT.Code <> '' then FastWriteWindow(CT.Code, row, col, WindowAttr);
        Inc(row);
        if row = 24 then begin
          row := 1;
          col := col+5;
        end;
      end;
      FastWrite('Press Any Key to continue', 25, 30, WindowAttr);
    end;
    repeat until Keypressed;
    ReadKeyWord;
    KillWindow(WinPtr);
  end;

begin
  InitIni;
  Colors := New(PColors, Init);
  SetVerticalPick;
  TPedit.WindowRelative := True;
  with Colors^ do begin
    SetCtrlAttr(HiLiteAttr);
    SetFieldAttr(PromptAttr);
    SetPromptAttr(PromptAttr);
    SetStringAttr(StringAttr);
    SetVerticalPick;
  end;
  Choice := 1;
  SetZeroRecords;
  CT_flag := False;
  PF_flag := False;
  FilesGotten := False;
  with Colors^ do
    MakeWindow(MainWinPtr, 1, 1, 80, 25, True, True, False, WindowAttr, FrameAttr, HeaderAttr, rttybywf1b+version+copyright);
  DisplayWindow(MainWinPtr);
  CountryFileName := '';
  PrefixFileName := '';
  repeat
    FastWrite(FileNames, 25, 3, Colors^.WindowAttr);
    if FilesGotten then begin
      HowMany(CountriesUsed, PrefixesUsed);
      FastWrite('Countries(Left)='+long2str(CountriesUsed)+
                '('+long2str(MaxCountry-CountriesUsed)+')'+
                '/Prefixes(Left)='+long2str(PrefixesUsed)+
                '('+long2str(MaxPrefix-PrefixesUsed)+')', 25, 30, Colors^.WindowAttr);
    end;
    PickMenu;
    for B := 13 to 24 do
      FastWrite(charstr(' ', 78), B, 2, Colors^.WindowAttr);
    if PickCmdNum = PKSSelect then
      case Choice of
        1 : AddCountry;
        2 : CancelChanges;
        3 : ChangeCountry;
        4 : DeleteCountry;
        5 : ListCountries;
        6 : OpenRtn;
        7 : SaveChanges;
        8 : TranslateFile('CTY');
        9 : TranslateFile('DAT');
        10 : Ch := Chr(27);
      end;
  until ((PKSSelect <> PKSSelect) or (Choice = 10));
  KillWindow(MainWinPtr);
  if CT_flag then DisposeA(Ct_Array);
  if PF_flag then DisposeA(Pf_Array);
  DisposeA(New_Ct_Array);
  Dispose(Colors, Done(False));
  ClrScr;
  WriteLn(rttybywf1b+version+copyright);
  WriteLn('Written by Ray Ortgiesen, WF1B');
  Halt;
end.
