{* start-of-license

Copyright (C) 1990-2000 Raymond Ortgiesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Required Reading For Developers and Distributors:
Full Text of License   http://www.gnu.org/copyleft/gpl.html
What is Free Software? http://www.gnu.org/philosophy/free-sw.html
What is copyleft?      http://www.gnu.org/copyleft/copyleft.html

Raymond Ortgiesen
35 Colvintown Road
Coventry, RI 02816
USA

end-of-license *}
{$O+,F+}
unit NetworkL; { NetworkL - the L stands for Loopback chained }

interface

uses
  Network, NetNode;

type

PNetworkL = ^TNetworkL;
TNetworkL = object(TNetwork)
  Constructor Init(StationNum : byte);
  Destructor  Done; virtual;
  Procedure   PassItOn(ToNode : NodeSwitch); virtual;
end;

implementation

uses
  cRttyWin,  EditText,  LowLvl,  Routines,  IniFile,  IniTools,  OneTimers,
  Keys,  ApPort,  cMsgWin,  TpDate,  TpDos,  TpString,  Dos,  TpCrt,  DebugRtns,
  CSerNum,  cEditWin,  TpEntry,  TpWindow,  TpMouse,  ClusterTerm,  ClstrCom,
  ClstrNet,  cColors,  c_Contest,  c_Radio,  cDupeTbl;

Constructor TNetworkL.Init(StationNum : Byte);
begin
  Inherited Init(StationNum);
  {$IFDEF DEBUG}
  AppendDebugMessage('NetworkL created');
  {$ENDIF}
end;

Destructor TNetworkL.Done;
Begin
  Inherited Done;
end;

Procedure TNetworkL.PassItOn(ToNode : NodeSwitch);
{var
s : string;
i : integer; }
begin { PassItOn }
  { the parameter is ignored, all data always goes to FirstNode }
  if Assigned(Node[FirstNode]) then
    if MD.DestNode <> ThisNode then  { it wasn't for me }
      if MD.OrigNode <> ThisNode then { and it wasn't from me }
        Node[FirstNode]^.TransmitBlock(Block);
{  s := '';
  for i := 0 to Ord(Block[0]) do
    s := s + hexb(ord(block[i]))+' ';
  AppendDebugMessage('PassItOn='+S); }
end; { PassItOn }

end.
